/***************************************************************/
/*                                                             */
/*    Java-Progamm SchiriAnlage                                */
/*                                                             */
/*    Ulrich Wller, (C) Juni 2003 - Version 0.9.5 bis (s.u.)  */
/*                                                             */
/***************************************************************/
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.StringTokenizer;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Calendar;
import java.util.Hashtable;
import java.io.*;
import java.net.*;


/*
 * Dieses Java-Programm kann als Applet mit den Methoden init(), start(), stop()
 * oder als standalone-Programm laufen mit der Methode main()
 */
public class SchiriAnlage extends Applet implements ActionListener, WindowListener, KeyListener, iconControl {

	// allgemein verfgbare static Variablen ...
	private static String    version          = "2.1";
	public  static int[]     VersionDate      = { 3, 3, 2009 }; // Erstellungdatum der Version
	private static int       UpToDateMonth    = 24;               // nach 24 Monaten veraltet!

	public  static boolean   debug            = false;
	private static boolean   simulation       = true;     // gibt es eine Hardware-Abfrage (ParallelPortKommunikation ber FiFos) oder nicht
	public  static boolean   schiriSimulation = true;     // werden Klicks auf die Schiri-Symbole ausgewertet
	public  static boolean   runAsProgram     = false;    // wird in main() auf true gesetzt.
	private static String    OS               = System.getProperty("os.name");
	public  static boolean   isLinux          = ( OS.compareTo("Linux") == 0 ) ? true : false;
	public  static Toolkit   tools            = Toolkit.getDefaultToolkit(); // Tools (z.B. Beep) kann man immer gebrauchen :-)
	private static Dimension initDimension    = tools.getScreenSize();       // verfgbare Flche ohne Leisten, Applet -> Flche
	private static int       maxWidth         = 1100;     // grer sieht nicht aus
	private static int       maxHeight        = 880;      // dito
	private static int       minHeight        = 700;      // Braucht man mindestens fr gute Darstellung. Wenn hher wird die Differenz verteilt.

	// Die Texte, die sprachabhngig sind. Durch eine Datei language.html knnen die Texte berschrieben werden ...
	Hashtable textHash = new Hashtable();

	String TextLabel[][] = {
		{ "exit", "Ende" } ,
		{ "activate", "Aktivieren" },
		{ "stop", "Stopp" },
		{ "title", "Unterwasser-Rugby-Schiedrichter-Anlage Version" },
		{ "config", "Konfiguration" },
		{ "switch", "Seitenwechsel" },
		{ "hornTest", "Hup-Test" },
		{ "protocol", "Protokoll" },
		{ "stopwatch", "Stoppuhr" },
		{ "timeOut", "Auszeit" },
		{ "penaltyThrow", "Strafwurf" },
		{ "startClock", "Uhr starten" },
		{ "stopClock", "Uhr stoppen" },
		{ "team", "Mannschaft" },
		{ "simulation", "Simulation gestartet, Schiedsrichtereingabe mit Klick auf die Symbole ..." },
		{ "progStarted", "Programm gestartet ..." },
		{ "penaltyLeft", "Strafzeiten links" },
		{ "penaltyRight", "Strafzeiten rechts" },
		{ "matchActivate", "Das Spiel muss noch aktiviert werden!" },
		{ "secondActivate", "Die 2. Halbzeit muss noch aktiviert werden!" },
		{ "UWreferee1", "UW-Schiedsrichter 1" },
		{ "UWreferee2", "UW-Schiedsrichter 2" },
		{ "deckreferee", "Spielleiter" },
		{ "missingIcons", "Nicht alle Icons im Verzeichnis '$$$' gefunden!" },
		{ "yes", "Ja" },
		{ "no", "Nein" },
		{ "exitTitle?", "Beenden?" },
		{ "exit?", "Das Programm wirklich beenden?" },
		{ "matchExitTitle?", "Spiel beenden?" },
		{ "matchExit?", "Das Spiel wirklich beenden?" },
		{ "matchExit", "Spiel wurde vorzeitig unterbrochen." },
		{ "matchStart", "Spiel-Beginn. Spielleiter kann angehupen." },
		{ "secondStart", "Beginn zweite Halbzeit. Spielleiter kann angehupen." },
		{ "protocolIn", "Protokoll in '$$$'" },
		{ "infoIn", "Diese Infozeilen in '$$$'" },
		{ "1playingTime", "1. Halbzeit" },
		{ "2playingTime", "2. Halbzeit" },
		{ "adjustTime", "Das Programm ist neuer als die eingestellte System-Zeit. Bitte Zeit richtig einstellen!" },
		{ "oldVersion", "Diese Version ist schon ber $$$ Monate alt! Bitte nach einer neuen Version fragen bei:" },
		{ "manWatchStart", "Uhr vom Protokolltisch gestartet!" },
		{ "manWatchStop", "Uhr vom Protokolltisch gestoppt!" },
		{ "hornTestComment", "Hup-Test: Jetzt knnen alle Schiedsrichterdrcker getestet werden (Komplett-Test). Wenn alles funktioniert, diesen Dialog mit 'OK' schliessen. Im Gegensatz dazu kann man mit Klicks auf die Hup-Icons die einzelnen Relais und die Hupe testen." },
		{ "noChangeEnds", "Kein Seitenwechsel whrend eines Strafwurfs!" },
		{ "noFoul", "kein Foul" },
		{ "noGoal", "kein Tor" },
		{ "goalScored", "Tor gefallen" },
		{ "foulOccurred,", "Foul begangen" },
		{ "correction", "Korrektur" },
		{ "unknown", "unbekannt" },
		{ "left", "links" },
		{ "right", "rechts" },
		{ "blue", "Blau" },
		{ "white", "Weiss" },
		{ "noPrtocolAvail", "Aktuell kein Protokoll vorhanden!" },
		{ "goal", "Tor" },
		{ "long", "lang" },
		{ "short", "kurz" },
		{ "foul", "Foul" },
		{ "foulExplain", "d.h. Freiwurf, Schiedsrichterball oder Strafwurf" },
		{ "penaltyThrowEnd", "Strafwurf-Ende, Ball aus dem Wasser" },
		{ "manySignals", "mehr als zwei Signale" },
		{ "matchResuming", "Spiel ist angehupt bzw. geht weiter." },
		{ "veryShortSignal", "Etwas kurzes Signal" },
		{ "penaltyTiStart", "Start" },
		{ "unknown", "unbekannt" },
		{ "blue", "Blau" },
		{ "white", "Weiss" },
		{ "penaltyTimeFor", "Strafzeit fr" },
		{ "penaltyThrowA", "Strafwurf gegen" },
		{ "penaltyTimeEnd", "Strafwurf-Zeit abgelaufen." },
		{ "firstEnd", "Erste Halbzeit zu Ende!" },
		{ "matchEnd", "Spiel zu Ende!" },
		{ "halfTimeInt", "Halbzeitpause" },
		{ "autoSwitch", "automatischer Seitenwechsel" },
		{ "autoActivate", "automatisch 2. Halbzeit aktivieren" },
		{ "terminateMatch", "Spiel beenden" },
		{ "resumeMatch", "weiterspielen" },
		{ "halfTimeIntEnd", "Halbzeitpause ist beendet." },
		{ "timeUp", "rauf" },
		{ "timeDown", "runter" },
		{ "start", "Start" },
		{ "close", "Schlieen" },
		{ "configTitle", "Konfiguration der SchiriAnlage" },
		{ "programName", "Schiri-Anlagen-Programm" },
		{ "playtime", "Spielzeit (pro Halbzeit)" },
		{ "penaltyTime", "Strafzeit" },
		{ "penaltyThrowTime", "Strafwurfzeit" },
		{ "halfTimeInterval", "Halbzeitpause" },
		{ "fullProtocol", "volles Protokoll + autom. Torstand" },
		{ "continuousClock", "durchlaufende Zeit" },
		{ "refereeSim", "Schiri-Simulation" },
		{ "on", "An" },
		{ "off", "Aus" },
		{ "signalConnection", "Anschluss Signalgeber" },
		{ "refereeShort", "UW-Schiri" },
		{ "DeckRefShort", "Spielleiter" },
		{ "signalThreshold", "kurz/lang Signalschwelle" },
		{ "ok", "OK" },
		{ "cancel", "Abbruch" },
		{ "wrongData", "Fehlerhafte Daten!" },
		{ "selectTeam", "Mannschaftsauswahl" },
		{ "newTeam", "Neue Mannschaft" },
		{ "removeTeam", "Mannsch. entfernen" },
		{ "teamListLoad", "M.-Liste laden" },
		{ "teamListSave", "M.-Liste speichern" },
		{ "playsBlue", "Spielt Blau" },
		{ "playsWhite", "Spielt Weiss" },
		{ "newPlayer", "Neuer Spieler" },
		{ "removePlayer", "Entfernen" },
		{ "registerTeam", "Mannschaft eintragen" },
		{ "registerPlayer", "Spieler eintragen" },
		{ "teamList", "Mannschaftsliste" },
		{ "player", "Spieler" },
		{ "number", "Nummer" },
		{ "teamLeader", "Mannschaftsfhrer" },
		{ "teamLeaderAbr", "MF" },
		{ "playerName", "Name" },
		{ "selectTeams", "Bitte beim vollen Protokoll erst die Mannschaften mit den Mannschafts-Buttons auswhlen!" },
		{ "insertPlayer", "Bitte bei der Mannschaft $$$ die Spieler eintragen!" },
		{ "selectTeamLeader", "Bitte bei der Mannschaft $$$ den Mannschaftsfhrer eintragen!" },
		{ "errorTeamNumber", "Fehler aufgetreten! Anzahl der Mannschaften stimmt nicht!" },
		{ "errorTeamList", "Fehler aufgetreten! Mannschaft $$$ nicht in der Liste!" },
		{ "exampleTeam", "Dies Applet ld nur eine Beispiel-Mannschaftsliste geladen!" },
		{ "loadTeam", "Mannschaftenliste laden ..." },
		{ "saveTeam", "Mannschaftenliste speicher als ..." },
		{ "fileNotFound", "Die Datei '$$$' konnte nicht gefunden werden!" },
		{ "noFile", "'$$$' ist keine Datei!" },
		{ "noReadFile", "Die Datei '$$$' kann nicht gelesen werden!" },
		{ "noLoadFile", "Die Datei '$$$' kann nicht herunterladen werden!" },
		{ "errTeamWrite", "Fehler beim Schreiben der Mannschaften!" },
		{ "followingErr", "Folgender Fehler ist aufgetreten:" },
		{ "noTeamSel", "Keine Mannschaft ausgewhlt! Bitte Mannschaft anklicken." },
		{ "noTeamSelP", "Keine Mannschaft ausgewhlt! Fr das Protokoll werden Mannschaften gebraucht. Bitte Mannschaft anklicken." },
		{ "noAppWri", "Geht leider nur als Programm! Applets knnen keine Dateien schreiben." },
		{ "blueTeam", "blaue Mannschaft" },
		{ "whiteTeam", "weisse Mannschaft" },
		{ "wrongPlayerNo", "Fehler aufgetreten! Anzahl der Spieler stimmt nicht!" },
		{ "playerNotList", "Fehler aufgetreten! Spieler '$$$' nicht in der Liste!" },
		{ "selectPlayer", "Einen Spieler auswhlen!" },
		{ "teamNameInput", "Bitte einen Mannschaftsnamen eingeben!" },
		{ "errorNoColor", "Fehler: Spieler hat keine Farbe!" },
		{ "newEntry", "Neuer Eintrag" },
		{ "removeProtEntry", "Entfernen" },
		{ "registerProtEntry", "Eintragen" },
		{ "registerClose", "Eintragen + schliessen" },
		{ "saveProtocol", "Protokoll speichern" },
		{ "showProtocol", "Protokoll anzeigen" },
		{ "goalShort", "Tor" },
		{ "freeThrowShort", "Freiw." },
		{ "penaltyThrowShort", "Strafw." },
		{ "exchangeShort", "Wechsel" },
		{ "initiallyOutShort", "Anf.raus" },
		{ "refereeBallShort", "Schirib." },
		{ "warningShort", "Verwarn." },
		{ "disqualiShort", "Sperre" },
		{ "timePenShort", "Zeitst." },
		{ "timeOutShort", "Auszeit" },
		{ "halfTimeShort", "Halbzeit" },
		{ "errorTeamEntry", "Fehler aufgetreten! Mannschaften nicht eingetragen!" },
		{ "against", "gegen" },
		{ "protocolPartly", "Teil-Protokoll" },
		{ "remainderTime", "Restzeit" },
		{ "HalfTimeAbr", "H" },
		{ "playerIn", "Spieler rein" },
		{ "playerOut", "Spieler raus" },
		{ "comment", "Bemerkung" },
		{ "errorProtEntry", "Fehler aufgetreten! Anzahl der Protokoll-Eintrge stimmt nicht!" },
		{ "errorProtMissing", "Fehler aufgetreten! Protokoll-Eintrag '$$$' nicht in der Liste!" },
		{ "errorProtWrite", "Fehler beim Schreiben des Protokolls aufgetreten." },
		{ "changeIn", "Hinein" },
		{ "changeOut", "Heraus" },
		{ "noBrowser", "Browser leider nicht gefunden. '$$$' selbst ffnen!" },
		{ "selectProtEntry", "Fehler aufgetreten! Bitte Protokoll-Eintrag auswhlen (Zeile anklicken)." },
		{ "appletWrite", "Ein Java-Applet kann leider keine Daten speichern." },
		{ "sampleProtocol", "Deshalb wird nur ein Beispiel-Protokoll geladen." },
		{ "colorUnknown", "Farbe unbekannt" },
		{ "undefined", "nicht definiert" },
		{ "initiallyOut", "Am Anfang nicht im Spiel" },
		{ "numberAbr", "Nr." },
		{ "goalFor", "Tor fr" },
		{ "foulAgainst", "Freiwurf gegen" },
		{ "refereeBall", "SchiriBall" },
		{ "warningAgainst", "Verwarnung gegen" },
		{ "disqualiAgainst", "Spielsperre gegen" },
		{ "exchange", "Wechsel" },
		{ "timeOutFor", "Auszeit fr" },
		{ "scorer", "Torschtze" },
		{ "foulPlayer", "Foul-Spieler" },
		{ "warnedPlayerShort", "verwarnter Sp." },
		{ "warnedPlayerShort", "verwarnter Sp." },
		{ "expelledPlayerShort", "gesperrter Sp." },
		{ "forPlayer", "fr Spieler" },
		{ "typeNotSet", "Type (z.B. Tor) nicht gesetzt!" },
		{ "setRemainderTime", "Restzeit (korrekt) eingeben!" },
		{ "setPlayerNumber", "Spielernummer(n) (korrekt) eingeben!" },
		{ "playerRegistered", "Spieler mit Nummer $$$ nicht in der Mannschaft $$$ vorhanden! Spieler wird eingetragen!" },
		{ "colorNotSet", "Farbe ist nicht gesetzt!" }
	};

	// Dies sind die zustzlichen Fenster, die whrend des Programms mglich sind.
	private schiriConfig         configWin         = null;
	public  ablaufzeitFenster    stoppUhr          = null;
	private ablaufzeitFenster    auszeitUhrRechts  = null;
	private ablaufzeitFenster    auszeitUhrLinks   = null;
	public  halbzeitpauseFenster halbzeitpausenUhr = null;

	// dies sind die Font, die in diesem Programm benutzt werden.
	// ausser diesen gibt es nocht die kleinen 12-er in der Uhr und den Zeitbalken und
	// die groen 60-er in der Uhr und in der Stoppuhr fr Auszeit und Halbzeitpause
	Font HauptButtonFont        = new Font("Helvetica", Font.PLAIN, 20);
	Font MannschaftsButtonFont  = new Font("Helvetica", Font.PLAIN, 18);
	Font ProtokollUhrButtonFont = new Font("Helvetica", Font.PLAIN, 18);
	Font AuszeitButtonFont      = new Font("Helvetica", Font.PLAIN, 18);
	Font InfoLabelFont          = new Font("Helvetica", Font.PLAIN, 18);
	Font InfoLabelFontSmall     = new Font("Helvetica", Font.PLAIN, 16);
	Font textspaceFont          = new Font("Helvetica", Font.PLAIN, 18);

	// das ist das Fenster, das das Programm beheimatet
	Frame  programmFenster;

	// das Panel ist in das Fenster gelegt
	Panel  saPanel       = null;

	// Dialog fr Ende-Bestaetigung und Stoppen eines Spiels ...
	alertFenster endeFrage, spielStoppFrage;

	// die sichtbaren Elemente dieses Frames ...
	Label  InfoLabel;
	Button activateButton, wechselButton, huptestButton, konfigButton, quitButton;
	Button stoppuhrButton, protokollButton;
	Button strafwurfButtonLinks, strafwurfButtonRechts;
	Button auszeitButtonLinks,   auszeitButtonRechts;
	Button endeDialogJaButton,   endeDialogNeinButton;
	Button spielStoppDialogJaButton, spielStoppDialogNeinButton;
	Button uhrStartButton, uhrStoppButton;
	Button lMannschaftsButton, rMannschaftsButton;
	Button torStandLinksPlusButton,  torStandLinksMinusButton,  torStandLinksAusButton;
	Button torStandRechtsPlusButton, torStandRechtsMinusButton, torStandRechtsAusButton;

	Schiedsrichter uwSchiri1;
	Schiedsrichter uwSchiri2;
	Schiedsrichter spielleiter;

	Strafzeit strafzeitRechts1, strafzeitRechts2, strafzeitRechts3;
	Strafzeit strafzeitLinks1,  strafzeitLinks2,  strafzeitLinks3;

	Strafwurf strafwurfRechts, strafwurfLinks;

	TextArea textspace;       // Flche fr die Textmeldungen
	String   meldung1 = null; // Scrollende Meldungen
	String   meldung2 = null;
	String   meldung3 = null;
	String   meldung4 = null;
	BufferedWriter writer = null;

	uwrUhr     spieluhr;      // Die Uhr in der Mitte des Programms
	toranzeige torLinks;      // Anzeige der Tore der Mannschaft links
	toranzeige torRechts;     // Anzeige der Tore der Mannschaft rechts

	// die vordefinierten Werte ...
	int  spielzeit     = 900;                // 15 Minuten = 900 Sekunden
	int  strafzeit     = 120;                //  2 Minuten = 120 Sekunden
	int  strafwurfzeit = 45;                 // 45 Sekunden ist normal
	int  halbzeitpause = 300;                //  5 Minuten
	int  auszeit       = 60;                 //  1 Minute
	long schiriSignalKurzLangSchwelle = 300; // Vorher kurzes Signal, nachher langes

	boolean durchlaufendeZeit = false;       // bei true wird die Spielzeit und die Strafzeiten nicht angehalten

	boolean ersteHalbzeit     = true;        // fr Halbzeitpause und Spielende
	boolean vollesProtokoll   = false;       // bei true mssen bei Toren und Fouls Spieler, etc eingegeben werden!
	boolean torstandMitButton = true;        // der Torstand (bei vollesProtokoll = false) kann manuell gesetzt werden

	Color colorLinks = null; // blau, white -> Farbe gesetzt (rechts andere Farbe) ; null -> Farbe noch nicht gesetzt
	//Color colorLinks = Color.white;

	mannschaftenListe alleMannschaften;
	mannschaft        linkeMannschaft, rechteMannschaft;

	protokoll         aktuellesProtokoll = null;

	int statusBitUw1 = 3;                 // UWR-Schiedsrichter am Status-Eingang (mglich 3-7)
	int statusBitUw2 = 4;
	int statusBitSL  = 5;

	// dieser Thread ist fr die Kommunikation mit dem C-Programm ueber die FiFos zustndig
	ParallelPortKommunikation ppk  = null;

	char dataBitValue[]            = new char[8]; // schreiben an ParallelPortKommunikation
	char statusBitValue[]          = new char[8]; // erhalten von ParallelPortKommunikation
	char statusBitOverwriteValue[] = new char[8]; // schreiben an ParallelPortKommunikation

	int dataBitHupe1            = 0;              // Hupe Data Ausgang (mglich 0-7)
	int dataBitHupe2            = 1;

	int dataBitStrafzeitLinks1  = 2;              // Strafzeiten-Anzeige Data Ausgang
	int dataBitStrafzeitLinks2  = 3;
	int dataBitStrafzeitLinks3  = 4;
	int dataBitStrafzeitRechts3 = 7;
	int dataBitStrafzeitRechts2 = 6;
	int dataBitStrafzeitRechts1 = 5;

	// die Signal-Verfolgung erkennt das Schiri-Signal
	SchiriSignalVerfolgung ssv = null;

	boolean activated = false;            // true: Zugriff fr Schiris; false: Konfig mglich
	boolean abgehupt  = true;             // fr die Schirisignalverfolgung: true -> warten auf anhupen
	boolean hupenLLL  = false;            // nur ein Hupsignal lang-lang-lang in abhupen()
	boolean huptesten = false;            // Alle Signale der Drcker sind zugelassen, wenn true.

	// Namen der Fifos zur Kommunikation mit C-Programm
	public static String fifo_pp_command = "fifo_pp_command";
	public static String fifo_ppc_answer = "fifo_ppc_answer";

	// Name der Sprachdatei
	public String languageFile = "language.html";
	
	// Verzeichnis der Protokolle
	public String protDir = "Protokolle";

	// Bilder ...
	String imageDir           = "images";
	String korbDatei          = "korb.gif";           // Korb ohne Ball  fr "nicht Tor" in SA u. Protokoll
	String korbBallDatei      = "korb-ball.gif";      // Korb mit Ball   fr "Tor" in SA u. Protokoll
	String hupeAnDatei        = "hupe.gif";           // Hupe mit Schall fr "Hupe an" in SA
	String hupeAusDatei       = "hupe-aus.gif";       // Hupe grau       fr "Hupe aus" in SA
	String foulDatei          = "foul.gif";           // Foul fr S.A.   fr "Foul" in SA
	String foulGrauDatei      = "foul-grau.gif";      // kein Foul       fr "kein Foul" in SA

	String freiwurfDatei      = "freiwurf.gif";       // Freiwurf        fr Protokoll-Eintrag
	String freiwurfGrauDatei  = "freiwurf-grau.gif";
	String strafwurfDatei     = "strafwurf.gif";      // Strafwurf       fr Protokoll-Eintrag
	String strafwurfGrauDatei = "strafwurf-grau.gif";
	String wechselDatei       = "wechsel.gif";        // Wechsel         fr Protokoll-Eintrag
	String wechselGrauDatei   = "wechsel-grau.gif";
	String anfRausDatei       = "anfRaus.gif";        // Raus am Spielanfang fr Protokoll-Eintrag
	String anfRausGrauDatei   = "anfRaus-grau.gif";
	String schiriBallDatei    = "schiriBall.gif";     // Schirball       fr Protokoll-Eintrag
	String schiriBallGrauDatei= "schiriBall-grau.gif";
	String verwarnungDatei    = "verwarnung.gif";     // Verwarnung      fr Protokoll-Eintrag
	String verwarnungGrauDatei= "verwarnung-grau.gif";
	String sperreDatei        = "sperre.gif";         // Spielsperre     fr Protokoll-Eintrag
	String sperreGrauDatei    = "sperre-grau.gif";
	String zeitStrafeDatei    = "zeitStrafe.gif";     // Zeit-Strafe     fr Protokoll-Eintrag
	String zeitStrafeGrauDatei= "zeitStrafe-grau.gif";
	String auszeitDatei       = "auszeit.gif";        // Auszeit         fr Protokoll-Eintrag
	String auszeitGrauDatei   = "auszeit-grau.gif";
	String halbzeitDatei       = "halbzeit.gif";       // Halbzeitpause   fr Protokoll-Eintrag
	String halbzeitGrauDatei   = "halbzeit-grau.gif";

	iconCanvas   hupe1Canvas, hupe2Canvas, korbCanvas, foulCanvas;
	MediaTracker tracker;
	Image  korbImage, korbBallImage, hupeAnImage, hupeAusImage, foulImage, foulPlatzImage;
	Image  freiwurfImage, freiwurfGrauImage, strafwurfImage, strafwurfGrauImage, wechselImage, wechselGrauImage;
	Image  anfRausImage, anfRausGrauImage, schiriBallImage, schiriBallGrauImage, verwarnungImage, verwarnungGrauImage;
	Image  sperreImage, sperreGrauImage, zeitStrafeImage, zeitStrafeGrauImage, auszeitImage, auszeitGrauImage;
	Image  halbzeitImage, halbzeitGrauImage;

	/*
	 * Als standalone-Programm wird zuerst die Methode main() aufgerufen ...
	 */
	public static void main (String args[]) {
		SchiriAnlage sa;

		runAsProgram = true;

		if ( args.length != 0 ) {
			System.out.println("Usage without argument!");
			System.exit(-1);
		}

		if ( debug ) System.out.println("Starting with main ...");

		// vom Applet "SchiriAnlage" wird beim Standalone-Programm die Flaeche nicht benutzt
		sa  = new SchiriAnlage();

		// Linux ? Fifos vorhanden ? Simulation?
		File fifoppc = new File(fifo_pp_command);
		File fifoppa = new File(fifo_ppc_answer);
		if ( isLinux && fifoppc.exists() && fifoppc.canRead() && fifoppa.exists() && fifoppa.canRead() ) {
			if ( debug ) System.out.println("Linux and Fifos available -> no Simulation.");
			simulation       = false;
			schiriSimulation = false; // kann per Konfiguration wieder gesetzt werden
		}

		// nun wird noch init() aufgerufen, soll ja wie das Applet laufen ...
		sa.init();

		// nun wird das Programm richtig gestartet ...
		sa.start();
	}

	/*
	 * Applet hat in der aufrufenden Seite nur eine kleine Flche,
	 * in dem ein "Applet SchiriAnlage" steht. Alles andere im extra Fenster.
	 */
	public void paint(Graphics g) {
		g.setColor(Color.black);
		g.drawString("Applet SchiriAnlage", 100,100);
		return;
	}

	/*
	 * Die Texte, die sprachabhngig sind werden in die Hashtabelle textHash gesetzt .
	 */
	public void setTextLabel() {
		for ( int i = 0; i < TextLabel.length; i++ )
			textHash.put(TextLabel[i][0],TextLabel[i][1]);

		openLanguageFile();
		return;
	}

	/*
	 * Methode openLanguageFile().
	 * liest die sprachabhngigen Text-Label aus der Datei languageFile
	 */
	private void openLanguageFile() {
		File        datafile;
		InputStream stream     = null;
		String      fileString = null;
		int    maxStringLength = 1000;
		int    pos;
		String part;
		String labelName;
		String labelValue;
		String labelTag        = "<label>";
		String nameTag         = "<name>";
		String textValueTag    = "<text>";

		try {
			if ( SchiriAnlage.runAsProgram ) {
				datafile = getLanguageFile(languageFile);
				if ( datafile == null )            // keine brauchbare Datei -> nichts zu tun.
					return;
				stream   = getInputStreamProg(datafile);
			}
			else {
				stream = getLanguageInputStreamApplet(languageFile);
				if ( stream == null )
					return;
			}
			fileString = getFileString(stream);        // aus Stream lesen
		} catch (IOException e) {
			System.out.println(e);
		}


		// Schleife ... xmlString.indexOf(tagString,startPos);
		for ( pos  = fileString.indexOf(labelTag, 0);  // pos = -1, wenn nicht gefunden
		      pos >= 0;                                // kein Mannschaft mehr!
		      pos  = fileString.indexOf(labelTag, pos+labelTag.length()) ) {

			part  = protokoll.getXmlTagString(fileString, labelTag, pos, false);
			if ( part == null ) return; // kein Text-Label mehr ...
			// Text-Label-Name zuerst ...
			labelName = protokoll.getXmlTagString(part, nameTag, 0, false);
			if ( labelName == null || labelName.length() > maxStringLength )
				return;  // falsche Werte!
			labelName = labelName.trim();
			labelValue = protokoll.getXmlTagString(part, textValueTag, 0, false);
			if ( labelValue == null || labelValue.length() > maxStringLength )
				return;  // falsche Werte!
			textHash.put(labelName, labelValue);
			//System.out.println("openLanguageFile: labelName: " + labelName + "; labelValue: " + labelValue );
		}

	}

	/*
	 * Diese Methode ueberprueft die Datei "filename"
	 * Return-Wert = null, wenn Datei nicht lesbar/vorhanden.
	 * getLanguageFile() wird von openLanguageFile() aufgerufen.
	 */
	private File getLanguageFile(String filename) throws IOException {
		File datafile = new File(filename);	   // Probleme beim Datei einlesen?
		if ( ! datafile.exists() ) {
			return null;
		}
		if ( ! datafile.isFile() ) {
			return null;
		}
		if ( ! datafile.canRead() ) {
			return null;
		}
		return datafile;
	}

	/*
	 * Diese Methode liefert den InputStream zur URL zum filename
	 * Return-Wert = InputStream, wenn alles ok. Sonst null.
	 * getInputStreamApplet() wird von openLanguageFile() aufgerufen.
	 */
	private InputStream getLanguageInputStreamApplet (String filename) throws IOException {
		URL         dataUrl;

		try {
			dataUrl = new URL(getDocumentBase(), filename);
		} catch (MalformedURLException e) {
			return null;
		}
		String urlString = dataUrl.toString();
		return dataUrl.openStream();
	}

	/*
	 * Diese Methode liefert den InputStream zur Datei datafile
	 * Return-Wert = InputStream, wenn alles ok. Sonst null.
	 * getInputStreamProg() wird von openFile() aufgerufen.
	 */
	private InputStream getInputStreamProg (File datafile) throws IOException {
		FileInputStream fileIn = new FileInputStream(datafile);
		return fileIn;
	}

	/*
	 * Methode getFileString():
	 * IN: datafile    die Datei
	 * Liest den Datei-Inhalt in fileString
	 */
	public static String getFileString(InputStream stream) throws IOException {
		String fileString = "";
		BufferedReader reader;
		int  maxReadChars = 50000;
		int  readChars    = 0;
		char cbuf[]       = new char[maxReadChars];

		reader = new BufferedReader(new InputStreamReader(stream));

		// warten bis die ersten Daten da sind ...
		while ( ! reader.ready() ) {
			stream.available();
		}

		while ( (readChars = reader.read(cbuf, 0, maxReadChars)) != -1) {
			fileString += new String(cbuf, 0, readChars);
		}

		reader.close();

		return fileString;
	}


	/*
	 * Gibt die Texte, die sprachabhngig sind, aus der Hashtabelle textHash.
	 */
	public String getTextLabel(String name) {
		return (String) textHash.get(name);
	}

	/*
	 * init() wird beim Applet von dem Browser oder
	 * beim Start als Programm duch die Methode main()
	 * vor der Darstellung aufgerufen ...
	 */
	public void init() {
		int distributeHeight = 0;  // zu verteilende Hhe (mehr als minHeight)
		int i;

		// Die Texte, die sprachabhngig sind werden in die Hashtabelle gesetzt ...
		setTextLabel();

		// das Programm laeuft in einem extra Window ...
		programmFenster = new Frame(getTextLabel("title") + " " + version + ", Ulrich Wller");

		// sa (SchiriAnlage) bekommt das Fenster-Schliessen-Event ...
		programmFenster.addWindowListener(this);

		// neues Panel in das Fenster ...
		saPanel = new Panel(new BorderLayout());
		saPanel.setBackground(Color.white);

		// und das Applet wird in dieses Fenster hineingesetzt ...
		programmFenster.add(saPanel);

		// die Fenstergre bestimmen ...
		if ( initDimension.height > maxHeight ) initDimension.height = maxHeight;
		if ( initDimension.width  > maxWidth  ) initDimension.width  = maxWidth;

		if ( initDimension.height > minHeight ) // verfgbare Hhe verteilen auf 10 Stellen
			distributeHeight = ( initDimension.height - minHeight ) / 10;
		//System.out.println("initDimension.height: " + initDimension.height + "; Verteilhhe: " + distributeHeight);

		// Applet: weisse Flche
		// 30 Punkte zustzlich fr die Applet-Zeile unten am Fensterrand
		if ( runAsProgram == false ) {
			this.setBackground(Color.white);
			minHeight += 30;
		}

		// alle Kommunikations-Bits auf '0' ...
		for (i=0; i<8; i++) {
			statusBitValue[i]          = '0';
			statusBitOverwriteValue[i] = '0';
			dataBitValue[i]            = '0';
		}

		// Die Button, die direkt hier berwacht werden
		activateButton        = new Button(getTextLabel("activate"));
		konfigButton          = new Button(getTextLabel("config"));
		quitButton            = new Button(getTextLabel("exit"));
		wechselButton         = new Button(getTextLabel("switch"));
		huptestButton         = new Button(getTextLabel("hornTest"));
		protokollButton       = new Button(" " + getTextLabel("protocol")+ "  ");
		stoppuhrButton        = new Button(" " + getTextLabel("stopwatch") + "  ");
		auszeitButtonRechts   = new Button(getTextLabel("timeOut"));
		auszeitButtonLinks    = new Button(getTextLabel("timeOut"));
		uhrStartButton        = new Button(getTextLabel("startClock"));
		uhrStoppButton        = new Button(getTextLabel("stopClock"));
		lMannschaftsButton    = new Button(getTextLabel("team")+ " " + getTextLabel("left"));
		rMannschaftsButton    = new Button(getTextLabel("team") + " " + getTextLabel("right"));
		torStandLinksPlusButton   = new Button("+");
		torStandLinksMinusButton  = new Button("-");
		torStandLinksAusButton    = new Button("X");
		torStandRechtsPlusButton  = new Button("+");
		torStandRechtsMinusButton = new Button("-");
		torStandRechtsAusButton   = new Button("X");
		// und die beiden Strafwurf-Buttons ...
		strafwurfButtonRechts = new Button(getTextLabel("penaltyThrowShort"));
		strafwurfButtonLinks  = new Button(getTextLabel("penaltyThrowShort"));

		// die richtigen Font fr die Buttons ...
		activateButton.setFont(HauptButtonFont);
		wechselButton.setFont(HauptButtonFont);
		huptestButton.setFont(HauptButtonFont);
		konfigButton.setFont(HauptButtonFont);
		quitButton.setFont(HauptButtonFont);

		protokollButton.setFont(ProtokollUhrButtonFont);
		stoppuhrButton.setFont(ProtokollUhrButtonFont);
		uhrStartButton.setFont(ProtokollUhrButtonFont);
		uhrStoppButton.setFont(ProtokollUhrButtonFont);
		lMannschaftsButton.setFont(MannschaftsButtonFont);
		rMannschaftsButton.setFont(MannschaftsButtonFont);
		auszeitButtonRechts.setFont(AuszeitButtonFont);
		auszeitButtonLinks.setFont(AuszeitButtonFont);

		// Dieses Applet ueberwacht seine Buttons selbst ...
		activateButton.addActionListener(this);        // Mouse-Klicks
		wechselButton.addActionListener(this);
		huptestButton.addActionListener(this);
		konfigButton.addActionListener(this);
		quitButton.addActionListener(this);
		protokollButton.addActionListener(this);
		stoppuhrButton.addActionListener(this);
		auszeitButtonLinks.addActionListener(this);
		auszeitButtonRechts.addActionListener(this);
		uhrStartButton.addActionListener(this);
		uhrStoppButton.addActionListener(this);
		lMannschaftsButton.addActionListener(this);
		rMannschaftsButton.addActionListener(this);
		torStandLinksPlusButton.addActionListener(this);
		torStandLinksMinusButton.addActionListener(this);
		torStandLinksAusButton.addActionListener(this);
		torStandRechtsPlusButton.addActionListener(this);
		torStandRechtsMinusButton.addActionListener(this);
		torStandRechtsAusButton.addActionListener(this);


		activateButton.addKeyListener(this);           // Tastatur-Eingaben
		wechselButton.addKeyListener(this);
		huptestButton.addKeyListener(this);
		konfigButton.addKeyListener(this);
		quitButton.addKeyListener(this);
		protokollButton.addKeyListener(this);
		stoppuhrButton.addKeyListener(this);
		auszeitButtonLinks.addKeyListener(this);
		auszeitButtonRechts.addKeyListener(this);
		uhrStartButton.addKeyListener(this);
		uhrStoppButton.addKeyListener(this);
		lMannschaftsButton.addKeyListener(this);
		rMannschaftsButton.addKeyListener(this);
		torStandLinksPlusButton.addKeyListener(this);
		torStandLinksMinusButton.addKeyListener(this);
		torStandLinksAusButton.addKeyListener(this);
		torStandRechtsPlusButton.addKeyListener(this);
		torStandRechtsMinusButton.addKeyListener(this);
		torStandRechtsAusButton.addKeyListener(this);

		/*
		 * Die Flche ist mit BorderLayout aufgeteilt.
		 * NORTH:  fr die Haupt-Buttons
		 * SOUTH:  fr das Textfeld mit den Meldungen
		 * EAST:   fr die rechten Strafwurf- und die Starfzeiten
		 * WEST:   fr die linken Strafwurf- und die Starfzeiten
		 * CENTER: fr die Uhr, Toranzeige, Icons, Schiri-Lichter, ...
		 */

		// *** NORTH ***:  fr die Haupt-Buttons ...
		Panel northPanel = new Panel(new GridLayout(1,5));

		northPanel.add(activateButton);
		northPanel.add(wechselButton);
		northPanel.add(huptestButton);
		northPanel.add(konfigButton);
		northPanel.add(quitButton);

		saPanel.add (BorderLayout.NORTH, northPanel);


		// *** SOUTH ***:  fr das Textfeld mit den Meldungen ...
		Panel southPanel = new Panel(new BorderLayout()); // eigentlich ist hier in the SOUTH kein eigenes Panel notwendig, aber man weiss ja nie was kommt ...
		if ( simulation )
			meldung1 = getTextLabel("simulation");
		else
			meldung1 = getTextLabel("progStarted");
		textspace = new TextArea(meldung1, 4, 58, TextArea.SCROLLBARS_NONE);
		textspace.setFont(textspaceFont);
		textspace.setEditable(false);
		southPanel.add(BorderLayout.CENTER, textspace);
		saPanel.add (BorderLayout.SOUTH, southPanel);


		// *** WEST ***:   fr die linken Strafwurf- und die Starfzeiten ...
		Panel westPanel = new Panel(new BorderLayout());
		saPanel.add (BorderLayout.WEST, westPanel);

		Panel westPanelLabelPanel = new Panel(new GridLayout(3,1,0,5));
		westPanel.add (BorderLayout.NORTH, westPanelLabelPanel);

		westPanelLabelPanel.add (new Panel());                         // fr Abstand
		westPanelLabelPanel.add (lMannschaftsButton);
		westPanelLabelPanel.add (new Label(getTextLabel("penaltyLeft") + "          ",Label.RIGHT));
		Panel linksPanel = new Panel(new FlowLayout(FlowLayout.CENTER, 10, 0));
		westPanel.add (BorderLayout.CENTER, linksPanel);

		  // die drei Strafzeiten und der Strafwurf ...
		strafzeitLinks1 = new Strafzeit("1", dataBitStrafzeitLinks1, initDimension.height - minHeight, this);
		strafzeitLinks2 = new Strafzeit("2", dataBitStrafzeitLinks2, initDimension.height - minHeight, this);
		strafzeitLinks3 = new Strafzeit("3", dataBitStrafzeitLinks3, initDimension.height - minHeight, this);

		strafwurfLinks  = new Strafwurf(strafwurfButtonLinks, initDimension.height - minHeight, this);

		linksPanel.add (strafwurfLinks);
		linksPanel.add (strafzeitLinks1);
		linksPanel.add (strafzeitLinks2);
		linksPanel.add (strafzeitLinks3);

		  // Auszeit-Button ...
		Panel auszeitButtonLinksPanel = new Panel(new GridLayout(2,1,0,0));
		westPanel.add (BorderLayout.SOUTH, auszeitButtonLinksPanel);

		auszeitButtonLinksPanel.add (auszeitButtonLinks);
		auszeitButtonLinksPanel.add (new Label()); // fr Abstand nach unten


		// *** EAST ***:   fr die rechten Strafwurf- und die Starfzeiten ...
		Panel eastPanel = new Panel(new BorderLayout());
		saPanel.add (BorderLayout.EAST, eastPanel);

		Panel eastPanelLabelPanel = new Panel(new GridLayout(3,1,0,5));
		eastPanel.add (BorderLayout.NORTH, eastPanelLabelPanel);

		eastPanelLabelPanel.add (new Panel());                         // fr Abstand
		eastPanelLabelPanel.add (rMannschaftsButton);
		eastPanelLabelPanel.add (new Label("          " + getTextLabel("penaltyRight"),Label.LEFT));
		Panel rechtsPanel = new Panel(new FlowLayout(FlowLayout.CENTER, 10, 0));
		eastPanel.add (BorderLayout.CENTER, rechtsPanel);

		  // die drei Strafzeiten und der Strafwurf ...
		strafzeitRechts3 = new Strafzeit("3", dataBitStrafzeitRechts3, initDimension.height - minHeight, this);
		strafzeitRechts2 = new Strafzeit("2", dataBitStrafzeitRechts2, initDimension.height - minHeight, this);
		strafzeitRechts1 = new Strafzeit("1", dataBitStrafzeitRechts1, initDimension.height - minHeight, this);

		strafwurfRechts  = new Strafwurf(strafwurfButtonRechts, initDimension.height - minHeight, this);

		rechtsPanel.add (strafzeitRechts3);
		rechtsPanel.add (strafzeitRechts2);
		rechtsPanel.add (strafzeitRechts1);
		rechtsPanel.add (strafwurfRechts);

		  // Auszeit-Button ...
		Panel auszeitButtonRechtsPanel = new Panel(new GridLayout(2,1,0,0));
		eastPanel.add (BorderLayout.SOUTH, auszeitButtonRechtsPanel);

		auszeitButtonRechtsPanel.add (auszeitButtonRechts);
		auszeitButtonRechtsPanel.add (new Label()); // fr Abstand nach unten


		// *** CENTER ***: fr die Uhr, Toranzeige, Icons, Schiri-Lichter, ...
		// 			Uhr, Toranzeige		NORTH
		//			Label			CENTER
		//			Icon+Schiris		SOUTH
		Panel centerPanel = new Panel(new BorderLayout()); // Fr Uhr und Schiedsrichteranzeigen

		  // Uhr, Toranzeige ...
		Panel uhrPanel = new Panel(new FlowLayout(FlowLayout.CENTER, 5, distributeHeight)); // Fr Rand-Abstand
		spieluhr  = new uwrUhr(this, spielzeit);
		torLinks  = new toranzeige (this, 0);
		torRechts = new toranzeige (this, 0);

		centerPanel.add (BorderLayout.NORTH, uhrPanel);   // Uhr, Toranzeige und Buttons oben
		Panel buttonTorLinksPanel = new Panel(new GridLayout(2,1,0,40));
		Panel buttonTorRechtsPanel = new Panel(new GridLayout(2,1,0,40));
		Panel torLinksPanel = new Panel(new FlowLayout(FlowLayout.LEFT));
		Panel torRechtsPanel = new Panel(new FlowLayout(FlowLayout.RIGHT));
		Panel torLinksAllPanel = new Panel(new BorderLayout());
		Panel torRechtsAllPanel = new Panel(new BorderLayout());
		Panel torLinksButtonPanel = new Panel(new FlowLayout(FlowLayout.LEFT,10,0));
		Panel torRechtsButtonPanel = new Panel(new FlowLayout(FlowLayout.RIGHT,10,0));
		torLinksPanel.add (torLinks);
		torRechtsPanel.add (torRechts);
		buttonTorLinksPanel.add (torLinksAllPanel);
		buttonTorRechtsPanel.add (torRechtsAllPanel);
		torLinksAllPanel.add (BorderLayout.NORTH,torLinksPanel);
		torLinksAllPanel.add (BorderLayout.SOUTH,torLinksButtonPanel);
		torRechtsAllPanel.add (BorderLayout.NORTH,torRechtsPanel);
		torRechtsAllPanel.add (BorderLayout.SOUTH,torRechtsButtonPanel);
		torLinksButtonPanel.add (torStandLinksPlusButton);
		torLinksButtonPanel.add (torStandLinksAusButton);
		torLinksButtonPanel.add (torStandLinksMinusButton);
		torRechtsButtonPanel.add (torStandRechtsPlusButton);
		torRechtsButtonPanel.add (torStandRechtsAusButton);
		torRechtsButtonPanel.add (torStandRechtsMinusButton);
		Panel buttonLinksPanel = new Panel(new BorderLayout());
		Panel buttonRechtsPanel = new Panel(new BorderLayout());
		buttonLinksPanel.add (BorderLayout.NORTH, stoppuhrButton);
		buttonLinksPanel.add (BorderLayout.SOUTH, protokollButton);
		buttonRechtsPanel.add (BorderLayout.NORTH, uhrStartButton);
		buttonRechtsPanel.add (BorderLayout.SOUTH, uhrStoppButton);
		buttonTorLinksPanel.add (buttonLinksPanel);
		buttonTorRechtsPanel.add (buttonRechtsPanel);

		uhrPanel.add (buttonTorLinksPanel);
		uhrPanel.add (spieluhr);
		uhrPanel.add (buttonTorRechtsPanel);

		  // Label zur Aktivierung ...
		Panel InfoPanel = new Panel(new FlowLayout(FlowLayout.CENTER, 5, distributeHeight)); // Fr Rand-Abstand
		InfoLabel = new Label("      " + getTextLabel("matchActivate") + "      ", Label.CENTER);
		InfoLabel.setForeground(Color.red);
		InfoLabel.setFont(InfoLabelFont);
		centerPanel.add(BorderLayout.CENTER, InfoPanel);       // Label in der Mitte
		InfoPanel.add(InfoLabel);

		  // Icons und Schiedrichteranzeigen
		Panel iconSchiriPanel = new Panel(new GridLayout(2,1,5,distributeHeight)); // Icon oben, Schiris unten
		centerPanel.add(BorderLayout.SOUTH, iconSchiriPanel);  // Icon und Schirianzeigen unten

		    // vier Icons
		Panel iconPanel = new Panel(new GridLayout(1,4,0, distributeHeight)); // vier Icons in einer Reihe
		iconSchiriPanel.add(iconPanel);

		Panel hupe1Panel = new Panel(); // jedes Icon in eigenem Panel wegen des FlowLayouts der Panel
		hupe1Canvas      = new iconCanvas(this, this, true, dataBitHupe1);  // Konstruktor mit Hupe
		hupe1Panel.add(hupe1Canvas);
		iconPanel.add(hupe1Panel);

		Panel korbPanel = new Panel();
		korbCanvas      = new iconCanvas(this, this, false, protokoll.TOR); //  Konstruktor ohne Hupe, isTor = true
		korbPanel.add(korbCanvas);
		iconPanel.add(korbPanel);

		Panel foulPanel = new Panel();
		foulCanvas      = new iconCanvas(this, this, false, protokoll.FREIWURF); //  Konstruktor ohne Hupe, isTor = false
		foulPanel.add(foulCanvas);
		iconPanel.add(foulPanel);

		Panel hupe2Panel = new Panel();
		hupe2Canvas      = new iconCanvas(this, this, true, dataBitHupe2); // Konstruktor mit Hupe
		hupe2Panel.add(hupe2Canvas);
		iconPanel.add(hupe2Panel);

		    // drei Schiris
		Panel schiriPanel = new Panel(new FlowLayout(FlowLayout.CENTER, 5, distributeHeight)); // Fr Rand-Abstand
		iconSchiriPanel.add(schiriPanel);
		uwSchiri1   = new Schiedsrichter(getTextLabel("UWreferee1"), statusBitUw1, this);
		uwSchiri2   = new Schiedsrichter(getTextLabel("UWreferee2"), statusBitUw2, this);
		spielleiter = new Schiedsrichter("          " + getTextLabel("deckreferee") + "          ", statusBitSL, this);
		schiriPanel.add(uwSchiri1);
		schiriPanel.add(spielleiter);
		schiriPanel.add(uwSchiri2);

		saPanel.add (BorderLayout.CENTER, centerPanel);

		// nun wird dieses Window auf den Bildschirm gebracht ...
		if ( debug ) System.out.println("Creating Window ...");
		programmFenster.pack();
		programmFenster.setSize(initDimension);
		programmFenster.show();

	}

	/*
	 * Hier werden alle Dinge erledigt, die zu Beginn des Programms gemacht werden mssen ...
	 */
	public void start () {
		activateButton.requestFocus();            // sollte der Normalfall sein

		alleMannschaften = new mannschaftenListe (this);

		ppk = new ParallelPortKommunikation(simulation,this);

		uwSchiri1.setAnzeige('0');
		spielleiter.setAnzeige('0');
		uwSchiri2.setAnzeige('0');

		// strafwurfEnable, halbzeitpauseEnable, konfigEnable, strafzeitEnable
		buttonDeEnable(false, true, false);

		// alle Bilder laden ...
		tracker = new MediaTracker(this);

		if ( ! runAsProgram ) {                        // als Applet vorgeben (Web-Link)
			imageDir = imageDir + '/';
		}
		else {
			imageDir = imageDir + File.separator;  // als Programm entsprechnd dem File-System
			protDir  = protDir  + File.separator;  // als Programm entsprechnd dem File-System
			
			// Erzeugung des Protokoll-Verzeichnisses
			File protDirFile = new File(protDir);
			if ( ! protDirFile.exists() ) {
				if ( debug ) System.out.println("Directory " + protDir + " does not exist!");
				boolean success = (new File(protDir)).mkdir();
				if ( ! success )
					if ( debug ) System.out.println("Directory could not be created!");
			}
			protDirFile = new File(protDir);
			if ( ! protDirFile.isDirectory() ) {
				if ( debug ) System.out.println(protDir + " is no directory!");
			}
		}

		korbImage          = getImageNow(imageDir + korbDatei);
		korbBallImage      = getImageNow(imageDir + korbBallDatei);
		hupeAnImage        = getImageNow(imageDir + hupeAnDatei);
		hupeAusImage       = getImageNow(imageDir + hupeAusDatei);
		foulImage          = getImageNow(imageDir + foulDatei);
		foulPlatzImage     = getImageNow(imageDir + foulGrauDatei);

		hupe1Canvas.setImage(hupeAnImage, hupeAusImage, 0);               // kleine 0 an der Hupe
		korbCanvas.setImage(korbBallImage, korbImage, -1);                // keine Zahl
		foulCanvas.setImage(foulImage, foulPlatzImage, -1);               // keine Zahl
		hupe2Canvas.setImage(hupeAnImage, hupeAusImage, 1);               // kleine 1

		freiwurfImage      = getImageNow(imageDir + freiwurfDatei);
		freiwurfGrauImage  = getImageNow(imageDir + freiwurfGrauDatei);
		strafwurfImage     = getImageNow(imageDir + strafwurfDatei);
		strafwurfGrauImage = getImageNow(imageDir + strafwurfGrauDatei);
		wechselImage       = getImageNow(imageDir + wechselDatei);
		wechselGrauImage   = getImageNow(imageDir + wechselGrauDatei);
		anfRausImage       = getImageNow(imageDir + anfRausDatei);
		anfRausGrauImage   = getImageNow(imageDir + anfRausGrauDatei);
		schiriBallImage    = getImageNow(imageDir + schiriBallDatei);
		schiriBallGrauImage= getImageNow(imageDir + schiriBallGrauDatei);
		verwarnungImage    = getImageNow(imageDir + verwarnungDatei);
		verwarnungGrauImage= getImageNow(imageDir + verwarnungGrauDatei);
		sperreImage        = getImageNow(imageDir + sperreDatei);
		sperreGrauImage    = getImageNow(imageDir + sperreGrauDatei);
		zeitStrafeImage    = getImageNow(imageDir + zeitStrafeDatei);
		zeitStrafeGrauImage= getImageNow(imageDir + zeitStrafeGrauDatei);
		auszeitImage       = getImageNow(imageDir + auszeitDatei);
		auszeitGrauImage   = getImageNow(imageDir + auszeitGrauDatei);
		halbzeitImage      = getImageNow(imageDir + halbzeitDatei);
		halbzeitGrauImage  = getImageNow(imageDir + halbzeitGrauDatei);

		if ( tracker.isErrorAny() ) {
			new alertFenster(replaceVar(getTextLabel("missingIcons"), imageDir),
							 programmFenster);
		}

		hupe1Canvas.setActive(false);
		korbCanvas.setActive(true);
		foulCanvas.setActive(true);
		hupe2Canvas.setActive(false);

		setErweitertesProtokoll (vollesProtokoll);
		setMannschaftsColor(colorLinks);

		checkAlter();

		// print_meldung( "##############################################################", false );
	}

	/*
	 * setzt die Mannschaftsfarben
	 */
	public void setMannschaftsColor(Color newColorLinks) {
		Color defaultCoulor = konfigButton.getBackground();
		Color blau          = new Color (192,192,255);
		Color weiss         = Color.white;
		colorLinks          = newColorLinks;

		if      ( colorLinks == Color.white ) {
			lMannschaftsButton.setBackground(weiss);
			torLinks.setColor(weiss);
			rMannschaftsButton.setBackground(blau);
			torRechts.setColor(blau);
		}
		else if ( colorLinks == Color.blue ) {
			lMannschaftsButton.setBackground(blau);
			torLinks.setColor(blau);
			rMannschaftsButton.setBackground(weiss);
			torRechts.setColor(weiss);
		}
		else {
			lMannschaftsButton.setBackground(defaultCoulor);
			torLinks.setColor(defaultCoulor);
			rMannschaftsButton.setBackground(defaultCoulor);
			torRechts.setColor(defaultCoulor);
		}
	}

	/*
	 * Die folgende Methode ersetzt in einem String das erste "$$$" durch das zweite Argument.
	 */
	public static String replaceVar(String longString, String setString) {
		String varString = "$$$";
		int    foundPos;
		int    endPos;

		if ( longString == null  || setString == null )  // bitte keine Null-Pointer-Exception
			return longString;

		foundPos = longString.indexOf(varString);
		endPos   = foundPos + varString.length();

		if ( foundPos < 0 )                              // keinen String varString gefunden
			return longString;

		return longString.substring(0, foundPos) + setString + longString.substring(endPos);
	}

	/*
	 * setzt activated und Label vom Button
	 */
	public void setActivated(boolean active) {
		this.activated = active;                  // Status merken
		if ( active ) {
			activateButton.setLabel(getTextLabel("stop")); // Button zum Stoppen labeln
			setInfoLabel(false);              // Halbzeit anzeigen
			if ( vollesProtokoll && ersteHalbzeit ) {  // Tore auf 0
				torLinks.setTore(0);
				torRechts.setTore(0);
			}
		}
		else {
			activateButton.setLabel(getTextLabel("activate"));
			setInfoLabel(true);               // Hinweis zum Aktivieren zeigen
		}
	}

	/*
	 * Die Einstellung zum vollen Protokoll werden eingestellt
	 */
	public void setErweitertesProtokoll (boolean vP) {
		vollesProtokoll = vP;
		torLinks.setVisible(vollesProtokoll || torstandMitButton);
		torRechts.setVisible(vollesProtokoll || torstandMitButton);
		torStandLinksPlusButton.setVisible(!vollesProtokoll);
		torStandLinksMinusButton.setVisible(!vollesProtokoll);
		torStandLinksAusButton.setVisible(!vollesProtokoll);
		torStandRechtsPlusButton.setVisible(!vollesProtokoll);
		torStandRechtsMinusButton.setVisible(!vollesProtokoll);
		torStandRechtsAusButton.setVisible(!vollesProtokoll);
	}

	/*
	 * manuelle nderung der Toranzeit
	 */
	public void setToreManuell(toranzeige anzeige, int add) {
		int tore = anzeige.getTore() + add;
		if (tore >= 0)
			anzeige.setTore(tore);
	}

	/*
	 * ldt die Bilder,
	 * (kann mit "g.drawImage(this.korbImage,x0,y0,this);" gezeichnet werden)
	 */
	private Image getImageNow(String imageName) {
		// System.out.println("getImageNow: image: " + imageName );
		Image returnImage = null;
		URL   url;

		try {
			if ( runAsProgram ) {
				returnImage = tools.getImage(imageName);     // getImage vom Toolkit mit Filename
			}
			else {
				url = new URL(getDocumentBase(), imageName);
				returnImage = getImage(url);                 // getImage vom Applet mit URL
			}
			tracker.addImage(returnImage, 0);                    // alle Bilder mit der ID 0
			tracker.waitForID(0);                                // etwas Geduld
		} catch (Exception e) { }
		return returnImage;
	}

	/*
	 * wird vom dem Thread ParallelPortKommunikation aufgerufen, um eine Vernderung
	 * eines Status-Bits = Schiedsrichter-Hupsignal anzuzeigen.
	 */
	public void setChangedStatus(String status) {
		boolean gedrueckt;
		// System.out.println("setChangedStatus: status = " + status);

		// Ueberpruefung der Signale vom Spielleiter (einschliesslich der Simulation)
		if ( ( status.charAt(7-statusBitSL  ) != statusBitValue[statusBitSL  ] ) && (! spielleiter.gesperrt) ) {
			statusBitValue[statusBitSL] = status.charAt(7-statusBitSL);     // Wert merken
			spielleiter.setAnzeige(statusBitValue[statusBitSL]);            // GUI-Anzeige
			gedrueckt = (statusBitValue[statusBitSL] == '1');               // gedrueckt oder nicht gedrueckt, das ist hier die Frage!

			// Hier kommt die eigentliche Steuerung der SchiriSignale
			schiriSignalAuswertung(spielleiter, gedrueckt, uwSchiri1, uwSchiri2);
		}
		// Ueberpruefung der Signale vom UW-Schiedsrichter 1 (einschliesslich der Simulation)
		else if ( ( status.charAt(7-statusBitUw1) != statusBitValue[statusBitUw1] ) && (! uwSchiri1.gesperrt) ) {
			statusBitValue[statusBitUw1] = status.charAt(7-statusBitUw1);
			uwSchiri1.setAnzeige(statusBitValue[statusBitUw1]);
			gedrueckt = (statusBitValue[statusBitUw1] == '1');

			// Hier kommt die eigentliche Steuerung der SchiriSignale
			schiriSignalAuswertung(uwSchiri1, gedrueckt, spielleiter, uwSchiri2);
		}
		// Ueberpruefung der Signale vom UW-Schiedsrichter 2 (einschliesslich der Simulation)
		else if ( ( status.charAt(7-statusBitUw2) != statusBitValue[statusBitUw2] ) && (! uwSchiri2.gesperrt) ) {
			statusBitValue[statusBitUw2] = status.charAt(7-statusBitUw2);
			uwSchiri2.setAnzeige(statusBitValue[statusBitUw2]);
			gedrueckt = (statusBitValue[statusBitUw2] == '1');

			// Hier kommt die eigentliche Steuerung der SchiriSignale
			schiriSignalAuswertung(uwSchiri2, gedrueckt, spielleiter, uwSchiri1);
		}
	}

	/*
	 * Wird von setChangedStatus() aufgerufen (also nur ber den Thread ParallelPortKommunikation gesteuert).
	 * eines Status-Bits = Schiedsrichter-Hupsignal anzuzeigen.
	 */
	public void schiriSignalAuswertung(Schiedsrichter aktivSchiri, boolean gedrueckt, Schiedsrichter passivSchiri1, Schiedsrichter passivSchiri2) {
		setHupe(-1, statusBitValue[aktivSchiri.statusBit]);
		if ( huptesten )  // beim Huptest keine Signalverfolgung
			return;
		if ( ssv == null ) {
			ssv = new SchiriSignalVerfolgung(aktivSchiri, passivSchiri1, passivSchiri2, this);
		}
		ssv.setSignal(gedrueckt);
	}

	/*
	 * Setzt das Status-Bit mit Nummer statusBit auf c ('0' oder '1').
	 * Wird von der Klasse Schiedsrichter fr die Schiri-Simulation aufgerufen.
	 */
	public void setStatusBit(int statusBit, char c) {
		String OverwriteStatus;

		statusBitOverwriteValue[statusBit] = c;
		OverwriteStatus = "" + statusBitOverwriteValue[7] + statusBitOverwriteValue[6] +
				  statusBitOverwriteValue[5] + statusBitOverwriteValue[4] +
				  statusBitOverwriteValue[3] + "000";
		if (debug) System.out.println( "Overwrite Status Bits: " + OverwriteStatus);
		ppk.setStatusOverwrite(OverwriteStatus);
	}

	/*
	 * Schickt dem Thread ParallelPortKommunikation die Daten, um die Hupe an (c = '1')
	 * oder aus (c = '0') zu schalten.
	 * dataBit = -1                        : beide Daten-Bits benutzen.
	 *           dataBitHupe1/dataBitHupe2 : nur dieses Daten-Bit benutzen.
	 */
	public void setHupe(int dataBit, char c) {
		String data;

		if ( dataBit < 0 ) {
			dataBitValue[dataBitHupe1] = c;
			dataBitValue[dataBitHupe2] = c;
			hupe1Canvas.setActive(c == '1');
			hupe2Canvas.setActive(c == '1');
		}
		else {
			dataBitValue[dataBit] = c;
			if ( dataBit == dataBitHupe1 )
				hupe1Canvas.setActive(c == '1');
			else
				hupe2Canvas.setActive(c == '1');
		}
		data = "" + dataBitValue[7] + dataBitValue[6] + dataBitValue[5] + dataBitValue[4] +
			dataBitValue[3] + dataBitValue[2] + dataBitValue[1] + dataBitValue[0];

		ppk.setDataPort(data);

		if (debug) System.out.println( "Hupe " + data);
	}

	/*
	 * Schickt dem Thread ParallelPortKommunikation die Daten, um die Strafzeit-Anzeigen an (c = '1')
	 * oder aus (c = '0') zu schalten.
	 * dataBit = dataBitStrafzeitLinks1    : nur dieses Daten-Bit (Strafzeiten-Anzeige Data Ausgang) benutzen.
	 *           dataBitStrafzeitLinks2
	 *           dataBitStrafzeitLinks3
	 *           dataBitStrafzeitRechts3
	 *           dataBitStrafzeitRechts2
	 *           dataBitStrafzeitRechts1
	 */
	public void setStrafzeit(int dataBit, char c) {
		String data;

		dataBitValue[dataBit] = c;

		data = "" + dataBitValue[7] + dataBitValue[6] + dataBitValue[5] + dataBitValue[4] +
			dataBitValue[3] + dataBitValue[2] + dataBitValue[1] + dataBitValue[0];

		ppk.setDataPort(data);

		if (debug) System.out.println( "Strafzeiten " + data);
	}

	/*
	 * Scheibt Meldungen in das Textfeld (scrollend) ...
	 */
	public void print_meldung( String meldung, boolean date ) {
		String  out = null;

		// makeBeep();  // zuviel Beep nervt!
		if ( meldung4 != null ) {
			meldung1 = meldung2;
			meldung2 = meldung3;
			meldung3 = meldung4;
			meldung4 = meldung;
			out = meldung1 + '\n' + meldung2 + '\n' + meldung3 + '\n' + meldung4;
		}
		else {
			if      ( meldung2 == null ) {
				meldung2 = meldung;
				out = meldung1 + '\n' + meldung2;
			}
			else if ( meldung3 == null ) {
				meldung3 = meldung;
				out = meldung1 + '\n' + meldung2 + '\n' + meldung3;
			}
			else                         {
				meldung4 = meldung;
				out = meldung1 + '\n' + meldung2 + '\n' + meldung3 + '\n' + meldung4;
			}
		}
		textspace.setText(out);

		if ( date )
			meldung = getDatumUhrzeit(false) + ": " + meldung;

		if ( runAsProgram && writer != null ) {
			try {
				writer.write(meldung + '\n');
			} catch (IOException e) {
				System.out.println(e);
			}
		}
	}

	/*
	 * Programm-Ende noch ohne Besttigung, deshalb Nachfrage.
	 */
	public void ProgramExit () {
		endeDialogJaButton = new Button(getTextLabel("yes"));
		endeDialogNeinButton = new Button(getTextLabel("no"));
		Button dialogButtons[] = {endeDialogJaButton, endeDialogNeinButton};

		endeFrage = new alertFenster(getTextLabel("exitTitle?"), getTextLabel("exit?"), dialogButtons, programmFenster);

		// erst die Listener hinzufgen ...
		endeDialogJaButton.addActionListener(this);
		endeDialogJaButton.addKeyListener(this);
		endeDialogNeinButton.addActionListener(this);
		endeDialogNeinButton.addKeyListener(this);

		// ... und dann den Dialog auf den Bildschirm.
		endeFrage.show();
	}

	/*
	 * Wie der Name sagt: Ende, Aus, Finito,...
	 * Hier wird auch die Kommunikation mit dem C-Programm ParallelPortControl beendet.
	 */
	public void ProgramExitFinal () {
		if ( debug ) System.out.println("Programm-Ende");
		protocolClose();
		if ( aktuellesProtokoll != null )
			aktuellesProtokoll.protkollSichern();
		ppk.quitKommunikation(); // Beenden (der Kommunikation mit) des/dem C-Programm ParallelPortControl
		this.stop();
		endeFrage.schliessen();
		programmFenster.dispose();
		if ( runAsProgram ) {
			System.exit(0);
		}
	}

	/*
	 * Spiel wirklich stoppen ...
	 */
	public void stoppSpielFragen() {
		spielStoppDialogJaButton = new Button(getTextLabel("yes"));
		spielStoppDialogNeinButton = new Button(getTextLabel("no"));
		Button dialogButtons[] = {spielStoppDialogJaButton, spielStoppDialogNeinButton};

		spielStoppFrage = new alertFenster(getTextLabel("matchExitTitle?"), getTextLabel("matchExit?"), dialogButtons, programmFenster);

		// erst die Listener hinzufgen ...
		spielStoppDialogJaButton.addActionListener(this);
		spielStoppDialogJaButton.addKeyListener(this);
		spielStoppDialogNeinButton.addActionListener(this);
		spielStoppDialogNeinButton.addKeyListener(this);

		// ... und dann den Dialog auf den Bildschirm.
		spielStoppFrage.show();
	}

	/*
	 * Spiel wirklich stoppen ...
	 */
	public void stoppSpielFinal() {
		spielStoppFrage.schliessen();

		setHupe(-1, '0');                   // sicherheitshalber nicht mehr hupen ...

		//activated = false;
		setActivated(false);
		abgehupt  = true;                   // fr die Schirisignalverfolgung: true -> warten auf anhupen
		ersteHalbzeit = true;

		print_meldung( getTextLabel("matchExit"), true );

		strafwurfRechts.beenden(false);
		strafwurfLinks.beenden(false);
		spieluhr.beenden(false);            // enthalten: -> sa.setSpielEnde -> Strafzeiten beenden

		strafzeitRechts1.beenden();         // auch in erster Halbzeit (sonst wrde nur angehalten)
		strafzeitRechts2.beenden();
		strafzeitRechts3.beenden();
		strafzeitLinks1.beenden();
		strafzeitLinks2.beenden();
		strafzeitLinks3.beenden();

		if ( halbzeitpausenUhr != null )
			halbzeitpausenUhr.ablaufZC.beenden(false, false);

		// strafwurfEnable, halbzeitpauseEnable, konfigEnable, strafzeitEnable
		buttonDeEnable(false, true, false);

		hupe1Canvas.setActive(false);
		korbCanvas.setActive(false);
		foulCanvas.setActive(false);
		hupe2Canvas.setActive(false);

		protocolClose();  // Protokoll-Datei schliessen.
		if ( aktuellesProtokoll != null )
			aktuellesProtokoll.protkollSichern();

		schiriSperre(uwSchiri1,true,uwSchiri2,true,spielleiter,true);
	}

	/*
	 * Nach Drcken des Aktivierung-Buttons ...
	 */
	public void startStoppSpiel() {

		if ( activated ) {                  // Spiel wird beendet ...
			stoppSpielFragen();
		}
		else {                              // Spiel kann beginnen, wenn die Mannschaften stimmen ...
			if ( vollesProtokoll ) {    // sind die Mannschafteneingetragen?
				if ( ! alleMannschaften.checkMannschaft(linkeMannschaft, programmFenster) ||
				     ! alleMannschaften.checkMannschaft(rechteMannschaft, programmFenster) )
					return;
			}

			// Spiel kann beginnen ...
			setHupe(-1, '0');           // sicherheitshalber nicht mehr hupen ...

			setActivated(true);         // activated = true;

			// alle Stoppuhren (false = sofort) beenden ...
/*
			if ( stoppUhr != null )
					stoppUhr.ablaufZC.beenden(false);
			if ( halbzeitpausenUhr != null )
					halbzeitpausenUhr.ablaufZC.beenden(false);
*/
			if ( auszeitUhrLinks != null )
				auszeitUhrLinks.ablaufZC.beenden(false, false);
			if ( auszeitUhrRechts != null )
				auszeitUhrRechts.ablaufZC.beenden(false, false);

			// strafwurfEnable, konfigEnable, strafzeitEnable
			buttonDeEnable(true, false, true);

			hupe1Canvas.setActive(false);
			korbCanvas.setActive(false);
			foulCanvas.setActive(false);
			hupe2Canvas.setActive(false);

			if ( ersteHalbzeit ) {
				// altes Protokoll erst speichern ...
				if ( runAsProgram && aktuellesProtokoll != null )
					aktuellesProtokoll.protkollSichern();

				// neues Protokoll benutzen ...
				aktuellesProtokoll = new protokoll (this);

				print_meldung( "#######################################################################", false );
				print_meldung( getTextLabel("matchStart"), true );
			}
			else {
				print_meldung( getTextLabel("secondStart"), true );
			}

			if ( runAsProgram && ersteHalbzeit ) {
				try {
					String SpielInfoFilename = protDir + "Match-Info_" + getDatumUhrzeit(true) + ".txt";
					if ( aktuellesProtokoll != null ) {
						String ProtokollName = protDir + "Protocol_" + getDatumUhrzeit(true) + ".html";
						aktuellesProtokoll.setNewProtokollDatei(ProtokollName);
						print_meldung(replaceVar(getTextLabel("protocolIn"), ProtokollName), false );
					}
					print_meldung(replaceVar(getTextLabel("infoIn"), SpielInfoFilename), false );
					File protocolFile = new File(SpielInfoFilename);
					FileOutputStream protocolOutputStream = new FileOutputStream(protocolFile);
					writer = new BufferedWriter(new OutputStreamWriter(protocolOutputStream));
				} catch (IOException e) {
					System.out.println(e);
				}
			}

			schiriSperre(uwSchiri1,true,uwSchiri2,true,spielleiter,false);
		}
	}

	/*
	 * Nach Aktivierung den InfoLabel setzen...
	 */
	public void setInfoLabel(boolean spielAktivieren) {
		InfoLabel.setVisible(false);
		if ( spielAktivieren ) {
			InfoLabel.setFont(InfoLabelFont);
			InfoLabel.setForeground(Color.red);
			if ( ersteHalbzeit )
				InfoLabel.setText(getTextLabel("matchActivate"));
			else
				InfoLabel.setText(getTextLabel("secondActivate"));
		}
		else {
			InfoLabel.setFont(InfoLabelFontSmall);
			InfoLabel.setForeground(Color.blue);
			if ( ersteHalbzeit )
				InfoLabel.setText(getTextLabel("1playingTime"));
			else
				InfoLabel.setText(getTextLabel("2playingTime"));
		}
		InfoLabel.setVisible(true);
	}

	/*
	 * Wenn das Programm zu alt ist wird ein Hinweis gegeben.
	 */
	public void checkAlter() {
		// System.out.println("GregorianCalendar gcCom = " + gcCom);
		int diffMonth = 0;

		if ( ! runAsProgram ) return;  // keine Veraltet-Abfrage als Applet

		int VersionDateDay   = VersionDate[0];
		int VersionDateMonth = VersionDate[1];
		int VersionDateYear  = VersionDate[2];

		GregorianCalendar gcProg = new GregorianCalendar();
		gcProg.set(VersionDateYear,VersionDateMonth-1,VersionDateDay); // die Erstellung der Version

		GregorianCalendar gcNow = new GregorianCalendar();             // die Zeit jetzt

		// .getTimeInMillis() leider in java 1.3.1 noch protected :-(
		//diffMonth = (int) ((gcNow.getTimeInMillis()-gcProg.getTimeInMillis()) / 2628000000L ); // 1000*3600*24*365/12
		if ( gcNow.before(gcProg) ) {                                  // Zeit ist zurck gestellt vor die Erstellung
			// System.out.println("Version neuer als aktuelle Zeit!");
			new alertFenster(getTextLabel("adjustTime"), programmFenster);
		}
		else {                                                         // Alter der Version bestimmen
			diffMonth = -1;
			for (int i = 0; i < 240 && gcProg.before(gcNow); i++) {
				diffMonth++;
				gcProg.add(Calendar.MONTH, 1);
			}
		}

		if ( diffMonth >= UpToDateMonth ){                             // Version zu alt oder Zeit ist zurck gestellt vor die Erstellung
			//System.out.println("Version zu alt!");
			new alertFenster(replaceVar(getTextLabel("oldVersion") + " Ulrich Wller, Ulrich.Wueller@t-online.de.", (new Integer(diffMonth)).toString()), programmFenster);
		}
	}

	/*
	 * String mit Datum und Uhrzeit
	 */
	public String getDatumUhrzeit(boolean forFilename) {
		char   trennerUhrzeit, trennerDatumUhrzeit;
		String datum = "", uhrzeit = "";

		if ( forFilename ) {
			trennerUhrzeit      = '_';
			trennerDatumUhrzeit = '-';
		}
		else {
			trennerUhrzeit      = ':';
			trennerDatumUhrzeit = ' ';
		}
		Calendar rightNow = Calendar.getInstance();
		datum   += printf02d(rightNow.get(Calendar.DATE  )) + "." +
			   printf02d((rightNow.get(Calendar.MONTH )) + 1) + "." +   // Monat um 1 erhht!
			   printf02d(rightNow.get(Calendar.YEAR  ));
		uhrzeit += printf02d(rightNow.get(Calendar.HOUR_OF_DAY)) + trennerUhrzeit +
			   printf02d(rightNow.get(Calendar.MINUTE     ))      + trennerUhrzeit +
			   printf02d(rightNow.get(Calendar.SECOND     ));
		return datum + trennerDatumUhrzeit + uhrzeit;
	}

	private String printf02d(int n) {
		if ( n < 10 ) return '0' + Integer.toString(n);
		else          return Integer.toString(n);
	}

	/*
	 * Schliessen der Protokoll-Datei
	 */
	public void protocolClose() {
		try {
			if ( runAsProgram && writer != null ) {
				writer.flush();
				writer.close();
				writer = null;
			}
		} catch (IOException e) {
			System.out.println(e);
		}
	}

	/*
	 * Sperrung oder Entsperrung der Schiedrichter ...
	 */
	public void schiriSperre(Schiedsrichter schiri1, boolean schiri1Sperre,
				 Schiedsrichter schiri2, boolean schiri2Sperre,
				 Schiedsrichter schiri3, boolean schiri3Sperre) {
		if ( schiri1 != null ) {
			schiri1.gesperrt = schiri1Sperre;
			schiri1.setAnzeige('0');          // auch wegen des repaint()
		}
		if ( schiri2 != null ) {
			schiri2.gesperrt = schiri2Sperre;
			schiri2.setAnzeige('0');          // auch wegen des repaint()
		}
		if ( schiri3 != null ) {
			schiri3.gesperrt = schiri3Sperre;
			schiri3.setAnzeige('0');          // auch wegen des repaint()
		}
	}

	/*
	 * Aktivierung/Deaktivierung dee Buttons ...
	 */
	public void buttonDeEnable(boolean strafwurfEnable, boolean konfigEnable, boolean strafzeitEnable) {
		strafwurfButtonRechts.setEnabled(strafwurfEnable);
		strafwurfButtonLinks.setEnabled(strafwurfEnable);

		konfigButton.setEnabled(konfigEnable);

		strafzeitRechts1.startButton.setEnabled(strafzeitEnable);
		strafzeitRechts1.startButton.setEnabled(strafzeitEnable);
		strafzeitRechts2.startButton.setEnabled(strafzeitEnable);
		strafzeitRechts3.startButton.setEnabled(strafzeitEnable);
		strafzeitLinks1.startButton.setEnabled(strafzeitEnable);
		strafzeitLinks2.startButton.setEnabled(strafzeitEnable);
		strafzeitLinks3.startButton.setEnabled(strafzeitEnable);
	}

	/*
	 * alles, was nach Beendigung des Spiels zu tun ist ...
	 */
	public void setSpielEnde() {

		// wird schon in woanders gemacht ...
		// schiriSperre(uwSchiri1,true,uwSchiri2,true,spielleiter,true);

		// strafwurfEnable, konfigEnable, strafzeitEnable
		buttonDeEnable(false, true, false);

		if ( ! this.ersteHalbzeit ) {
			strafzeitRechts1.beenden();
			strafzeitRechts2.beenden();
			strafzeitRechts3.beenden();
			strafzeitLinks1.beenden();
			strafzeitLinks2.beenden();
			strafzeitLinks3.beenden();
		}
		else {
			strafzeitRechts1.anhalten();
			strafzeitRechts2.anhalten();
			strafzeitRechts3.anhalten();
			strafzeitLinks1.anhalten();
			strafzeitLinks2.anhalten();
			strafzeitLinks3.anhalten();
		}

		strafwurfRechts.beenden(false);
		strafwurfLinks.beenden(false);

		spielleiter.showActive(false);
		uwSchiri1.showActive(false);
		uwSchiri2.showActive(false);

	}

	/*
	 * fnfmal hupen Spielende oder Strafwurfende ...
	 */
	public void abhupen() {
		int hupAnzahl = 5;

		abgehupt = true;
		if ( hupenLLL ) return; // zum Blocken von nochmal abhupen
		hupenLLL = true;
		// alle Schiris knnen nicht dazwischen hupen ...
		schiriSperre(uwSchiri1, true, uwSchiri2, true, spielleiter, true );

		// Ende hupen : 5xlang
		for ( int i=1; i<=hupAnzahl; i++) {
			setHupe(-1,'1'); // Hupe an
			try {Thread.sleep(600);} catch (InterruptedException e){}
			setHupe(-1,'0'); // Hupe aus
			if ( i != hupAnzahl )
				try {Thread.sleep(300);} catch (InterruptedException e){}
		}

		// nun knnen wieder alle Schiris hupen ...
		schiriSperre(uwSchiri1, false, uwSchiri2, false, spielleiter, false );
		hupenLLL = false;
	}

	/*
	 * wer weiss, wann man 'mal ein Beep braucht :-) ...
	 */
	public void makeBeep() {
		tools.beep();
	}

	/*
	 * Uhr vom Protokolltisch starten ...
	 */
	public void uhrStart() {
		if ( ( ! durchlaufendeZeit ) && abgehupt && activated ) {
			print_meldung(spieluhr.getSpielzeitString() + ": " + getTextLabel("manWatchStart"), true);
			spieluhr.beginnenFortsetzen(true);

			strafzeitRechts1.beginnenFortsetzen(true);
			strafzeitRechts2.beginnenFortsetzen(true);
			strafzeitRechts3.beginnenFortsetzen(true);
			strafzeitLinks1.beginnenFortsetzen(true);
			strafzeitLinks2.beginnenFortsetzen(true);
			strafzeitLinks3.beginnenFortsetzen(true);

			strafwurfRechts.beginnenFortsetzen(true);
			strafwurfLinks.beginnenFortsetzen(true);

			korbCanvas.setActive(false);
			foulCanvas.setActive(false);

			abgehupt = false;
		}
	}

	/*
	 * Uhr vom Protokolltisch stoppen ...
	 */
	public void uhrStopp() {
		if ( ( ! durchlaufendeZeit ) && ( ! abgehupt ) && activated ) {
			print_meldung(spieluhr.getSpielzeitString() + ": " + getTextLabel("manWatchStop"), true);
			spieluhr.anhalten();

			strafzeitRechts1.anhalten();
			strafzeitRechts2.anhalten();
			strafzeitRechts3.anhalten();
			strafzeitLinks1.anhalten();
			strafzeitLinks2.anhalten();
			strafzeitLinks3.anhalten();

			strafwurfRechts.anhalten();
			strafwurfLinks.anhalten();

			abgehupt = true;
		}
	}

	/*
	 * wird bei Druecken des Konfig-Buttons aufgerufen ...
	 */
	private void config() {
/* gendert, damit auch unter Linux immer sichtbar.
		if ( configWin == null )
			configWin = new schiriConfig(this);
		else
			configWin.activate();
*/
		configWin = new schiriConfig(this);
	}

	/*
	 * wird bei Druecken des Huptest-Buttons aufgerufen ...
	 */
	public void huptest() {
		boolean uwSchiri1gesperrt   = uwSchiri1.gesperrt;
		boolean uwSchiri2gesperrt   = uwSchiri2.gesperrt;
		boolean spielleitergesperrt = spielleiter.gesperrt;;

		huptesten = true;  // damit weiss schiriSignalAuswertung(), dass keine Signalverfolgung gestartet werden soll.
		setHupe(-1, '0');  // sicherheitshalber nicht mehr hupen ...

		schiriSperre(uwSchiri1,false,uwSchiri2,false,spielleiter,false); // alle Schiris drfen jetzt testen.

		// whrend der Meldung kann getestet werden ...
		new alertFenster(getTextLabel("hornTestComment"), programmFenster);

		huptesten = false; // jetzt wieder Signalverfolgung
		schiriSperre(uwSchiri1,uwSchiri1gesperrt,uwSchiri2,uwSchiri2gesperrt,spielleiter,spielleitergesperrt);
		setHupe(-1, '0');  // sicherheitshalber nicht mehr hupen ...
	}

	/*
	 * wird bei Druecken des Seitenwechsel-Buttons und am Ende der ersten Halbzeit aufgerufen ...
	 */
	public void seitenwechsel() {
		long       ms;
		boolean    isActivated;
		mannschaft tmpMannschaft;
		String     tmpString;

		boolean starfwurfSituation = ( strafwurfRechts.isActivated || strafwurfLinks.isActivated );
		if ( starfwurfSituation ) {
			new alertFenster(getTextLabel("noChangeEnds"), programmFenster);
			return;
		}

		// zuerst Wechsel der Strafzeiten ...
		ms          = strafzeitRechts1.getStrafzeit();
		isActivated = strafzeitRechts1.isActiv();
		strafzeitRechts1.setStrafzeitNeu(strafzeitLinks1.getStrafzeit(), strafzeitLinks1.isActiv());
		strafzeitLinks1.setStrafzeitNeu(ms, isActivated);

		ms          = strafzeitRechts2.getStrafzeit();
		isActivated = strafzeitRechts2.isActiv();
		strafzeitRechts2.setStrafzeitNeu(strafzeitLinks2.getStrafzeit(), strafzeitLinks2.isActiv());
		strafzeitLinks2.setStrafzeitNeu(ms, isActivated);

		ms          = strafzeitRechts3.getStrafzeit();
		isActivated = strafzeitRechts3.isActiv();
		strafzeitRechts3.setStrafzeitNeu(strafzeitLinks3.getStrafzeit(), strafzeitLinks3.isActiv());
		strafzeitLinks3.setStrafzeitNeu(ms, isActivated);

		// die Toranzeigen wechseln ...
		int tmpTore = torLinks.getTore();
		torLinks.setTore(torRechts.getTore());
		torRechts.setTore(tmpTore);

		// dann Wechsel der Farben
		if ( colorLinks != Color.blue && colorLinks != Color.white ) return;

		setMannschaftsColor ( ( colorLinks == Color.blue ) ? Color.white : Color.blue);

		// Wechsel der Mannschaften und Button-Beschriftungen
		tmpMannschaft    = rechteMannschaft;

		rechteMannschaft = linkeMannschaft;
		linkeMannschaft  = tmpMannschaft;

		tmpString          = rMannschaftsButton.getLabel();
		rMannschaftsButton.setLabel(lMannschaftsButton.getLabel());
		lMannschaftsButton.setLabel(tmpString);
	}

	/*
	 * Die folgenden Methoden bilden das iconCanvas-Interface und
	 * wird beim Anklicken des Icons gestartet.
	 */
	public void iconCanvasAction (iconCanvas ic) {
		ProtokollEintrag editEntry = aktuellesProtokoll.getLastSortedEntry();
		String  korrekturString = "";
		boolean active          = ic.getActive();

		if ( ic.getType() == protokoll.TOR && this.activated ) {  // auf das Tor-Icon geklicket
			if ( vollesProtokoll ) {
				if ( editEntry != null ) {                // letzten Protokoll-Eintrag zeigen
					//editEntry.owner = this.programmFenster;
					editEntry.showEntry();
					editEntry.setAnzeigeType(protokoll.TOR);
				}
				else {                                    // neuen Protokoll-Eintrag erzeugen
					aktuellesProtokoll.newProtokollEntry(protokoll.TOR , null);
				}
			}
			else {
				boolean FoulIconActive = this.foulCanvas.getActive();
				if ( FoulIconActive ) {
					korrekturString = getTextLabel("noFoul") + ", ";
					this.foulCanvas.setActive( false );
				}
				korrekturString += (active) ? getTextLabel("noGoal") : getTextLabel("goalScored");
				korrekturString += ".";
				ic.setActive( ! active );

				if ( editEntry != null ) {               // letzten Protokoll-Eintrag ndern
					if ( editEntry.type == protokoll.FREIWURF && FoulIconActive )
						editEntry.type = protokoll.TOR;
					if ( editEntry.type == protokoll.TOR && active ) {
						aktuellesProtokoll.aushaengen(editEntry);
						aktuellesProtokoll.protokollListeAktualisieren(null, true); // Vorsichtshalber, ohne Protokoll-Fenster keine Wirkung
					}
				}
				else {                                    // neuen Protokoll-Eintrag erzeugen
					aktuellesProtokoll.newProtokollEntry(protokoll.TOR , null);
				}

				print_meldung(spieluhr.getSpielzeitString() + ": " + getTextLabel("correction") + ": " + korrekturString, true);
			}
		}
		if ( ic.getType() == protokoll.FREIWURF && this.activated ) {  // auf das Foul-Icon geklicket
			if ( vollesProtokoll ) {
				if ( editEntry != null ) {                // letzten Protokoll-Eintrag zeigen
					//editEntry.owner = this.programmFenster;
					editEntry.showEntry();
					editEntry.setAnzeigeType(protokoll.FREIWURF);
				}
				else {                                    // neuen Protokoll-Eintrag erzeugen
					aktuellesProtokoll.newProtokollEntry(protokoll.FREIWURF , null);
				}
			}
			else {
				boolean KorbIconActive = this.korbCanvas.getActive();
				if ( KorbIconActive ) {
					korrekturString = getTextLabel("noGoal") + ", ";
					this.korbCanvas.setActive( false );
				}
				korrekturString += (active) ? getTextLabel("noFoul") : getTextLabel("foulOccurred");
				korrekturString += ".";
				ic.setActive( ! active );

				if ( editEntry != null ) {               // letzten Protokoll-Eintrag ndern
					if ( editEntry.type == protokoll.TOR && KorbIconActive )
						editEntry.type = protokoll.FREIWURF;
					if ( editEntry.type == protokoll.FREIWURF && active ) {
						aktuellesProtokoll.aushaengen(editEntry);
						aktuellesProtokoll.protokollListeAktualisieren(null, true); // Vorsichtshalber, ohne Protokoll-Fenster keine Wirkung
					}
				}
				else {                                    // neuen Protokoll-Eintrag erzeugen
					aktuellesProtokoll.newProtokollEntry(protokoll.FREIWURF , null);
				}

				print_meldung(spieluhr.getSpielzeitString() + ": " + getTextLabel("correction") + ": " + korrekturString, true);
			}
		}

	}

	/*
	 * Die folgenden Methoden bilden das WindowListener-Interface und
	 * beantworten ersteinmal das Anklicken des Windows-Schliessens.
	 */
	public void windowClosing(WindowEvent e) {
		ProgramExit();
	}
	public void windowActivated(WindowEvent e)   { }
	public void windowClosed(WindowEvent e)      { }
	public void windowDeactivated(WindowEvent e) { }
	public void windowDeiconified(WindowEvent e) { }
	public void windowIconified(WindowEvent e)   { }
	public void windowOpened(WindowEvent e)      { }

	/*
	 * Die folgende Methode bildet das ActionListener-Interface und
	 * beantworten das Anklicken der Buttons.
	 */
	public void actionPerformed(ActionEvent e) {
		if ( ! ( e.getSource() instanceof Button ) ) {
			return;
		}

		if ( debug ) System.out.println("Button: " + e.getSource());

		Button target = (Button) e.getSource();        // MOUSE CLICK auf Button ...
		buttonAction(target);
	}

	/*
	 * Die folgenden Methoden bilden das KeyListener-Interface und
	 * beantworten Tastatureingaben.
	 */
	public void keyPressed(KeyEvent e) {
		if ( debug ) System.out.println("KeyEvent: " + e);

		int key = e.getKeyCode();

		if ( key != KeyEvent.VK_ENTER )
			return;
		if ( ! ( e.getSource() instanceof Button ) ) {
			if ( debug ) System.out.println("ActionEvent: " + e);
			if ( debug ) System.out.println("Kein Button!?");
			return;
		}
		Button target = (Button) e.getSource();        // Tastatur-Eigabe ...
		buttonAction(target);
	}
	public void keyReleased(KeyEvent e)  { }
	public void keyTyped(KeyEvent e)     { }

	/*
	 * Die folgenden Methoden ist wird gemeinsam von actionPerformed und keyPressed genutzt.
	 */
	private void buttonAction(Button target) {
		Color farbe        = null;
		String farbeString = "(" + getTextLabel("unknown") + ")";

		if      (target == activateButton) {
			startStoppSpiel();
		}
		else if (target == stoppuhrButton) {
			stoppUhr = new ablaufzeitFenster (halbzeitpause,
					getTextLabel("stopwatch"), getTextLabel("stopwatch"), 0, true, false, this);
		}
		else if (target == auszeitButtonLinks) {
			auszeitUhrLinks = new ablaufzeitFenster (auszeit,
					getTextLabel("timeOut"), getTextLabel("timeOut") + " " + getTextLabel("left"), -350, true, true, this);
			farbe = colorLinks;
			if ( farbe == Color.blue  ) farbeString = getTextLabel("blue") + ".";
			if ( farbe == Color.white ) farbeString = getTextLabel("white") + ".";
			print_meldung(spieluhr.getSpielzeitString() + ": " + getTextLabel("timeOut") + " " + farbeString, true);
			if ( aktuellesProtokoll != null )
				aktuellesProtokoll.newProtokollEntry(protokoll.AUSZEIT, farbe);
		}
		else if (target == auszeitButtonRechts) {
			auszeitUhrRechts = new ablaufzeitFenster (auszeit,
					getTextLabel("timeOut"), getTextLabel("timeOut") + " " + getTextLabel("right"), +350, true, true, this);
			if ( colorLinks == Color.blue  ) farbe = Color.white;
			if ( colorLinks == Color.white ) farbe = Color.blue;
			if ( farbe == Color.blue  ) farbeString = getTextLabel("blue") + ".";
			if ( farbe == Color.white ) farbeString = getTextLabel("white") + ".";
			print_meldung(spieluhr.getSpielzeitString() + ": " + getTextLabel("timeOut") + " " + farbeString, true);
			if ( aktuellesProtokoll != null )
				aktuellesProtokoll.newProtokollEntry(protokoll.AUSZEIT, farbe);
		}
		else if (target == lMannschaftsButton) {
			alleMannschaften.showMannschaftsliste(true);
		}
		else if (target == rMannschaftsButton) {
			alleMannschaften.showMannschaftsliste(false);
		}
		else if (target == wechselButton) {
			seitenwechsel();
		}
		else if (target == huptestButton) {
			huptest();
		}
		else if (target == protokollButton) {
			if ( aktuellesProtokoll == null ) {
				new alertFenster(getTextLabel("noPrtocolAvail"), programmFenster);
			}
			else {
				aktuellesProtokoll.showProtokoll(null);  // letzten ProtokollEintrag anzeigen
			}
		}
		else if (target == uhrStartButton) {
			uhrStart();
		}
		else if (target == uhrStoppButton) {
			uhrStopp();
		}
		else if (target == konfigButton) {
			config();
		}
		else if (target == quitButton) {
			ProgramExit();
		}
		else if (target == endeDialogJaButton) {
			ProgramExitFinal();
		}
		else if (target == endeDialogNeinButton) {
			endeFrage.schliessen();
		}
		else if (target == spielStoppDialogJaButton) {
			stoppSpielFinal();
		}
		else if (target == spielStoppDialogNeinButton) {
			spielStoppFrage.schliessen();
		}
		else if (target == torStandLinksPlusButton) {
			setToreManuell(torLinks, 1);
		}
		else if (target == torStandLinksMinusButton) {
			setToreManuell(torLinks, -1);
		}
		else if (target == torStandRechtsPlusButton) {
			setToreManuell(torRechts, 1);
		}
		else if (target == torStandRechtsMinusButton) {
			setToreManuell(torRechts, -1);
		}
		else if (target == torStandLinksAusButton || target == torStandRechtsAusButton) {
			if (torstandMitButton)
				torstandMitButton = false;
			else
				torstandMitButton = true;
			torLinks.repaint();
			torRechts.repaint();
		}
	}
}

/*
 * Diese Klasse ist fr die zeitliche Verfolgung der SchiriSignale
 *
 *	Hupsignale:
 *
 *	einmal lang	Spielbeginn oder Anhupen nach Tor, Freiwurf, etc.
 *
 *	zweimal lang	Tor ist gefallen und vom Schiedsrichter gesehen worden.
 *
 *	ein oder zweimal kurz
 *			Einmal ist keinmal. Weiterspielen.
 *
 *	mehrmals kurz hintereinander
 *			Irgendein Foulspiel: den Ball fallen lassen und erst einmal Lage klaeren.
 *			Es geht mit Freiwurf, Schiedsrichterball oder Strafwurf (s.u.) weiter.
 *			Die Schiedsrichter zeigen in die Richtung der Mannschaft,
 *			gegen die der Freiwurf ausgefuehrt wird.
 *
 *	mind. dreimal lang	Halbzeit oder Spielende, wird von der Uhr ausgefhrt
 */
class SchiriSignalVerfolgung implements Runnable {
	Schiedsrichter  aktivSchiri, passivSchiri1, passivSchiri2;
	SchiriAnlage    sa;
	public Thread  schiriThread = null;
	Date    date = null;
	long    schiriStart_ms, sperrEnd_ms; // in Millisekunden
	long    aktZeit_ms;
	long    gedruecktStart_ms;   // zu dieser Zeit hat der Schiri das letzte mal den Druckknopf herunter gedrckt
	// genau 1000 ms nach dem letzten Hupen wird die Signalverfolgung beendet und die andern Schiris drfen wieder hupen
	long    sperrZeit_ms = 1000;
	long    kurzLangSchwelle;
	boolean gedrueckt;
	boolean signalErkannt = false;
	String  signalFolge = "";            // z.B. "KKL" fr kurz kurz lang
	boolean starfwurfSituation;
	boolean wartenAufAbhupen;            // merkt sich die Spielsituation bei Beginn der Signalverfolgung
					     // true  = (Uhr luft bei nicht durchlaufender Zeit) warten auf Tor oder Foul
					     // false = (Uhr steht bei nicht durchlaufender Zeit) warten auf Anhupen
	String  zeitString;

	/*
	 * Die SchiriSignalVerfolgung beginnt mit dem ersten Hupsignal.
	 */
	public SchiriSignalVerfolgung(Schiedsrichter aktivSchiri, Schiedsrichter passivSchiri1, Schiedsrichter passivSchiri2, SchiriAnlage sa) {
		this.aktivSchiri   = aktivSchiri;
		this.passivSchiri1 = passivSchiri1;
		this.passivSchiri2 = passivSchiri2;
		this.sa = sa;
		this.kurzLangSchwelle = sa.schiriSignalKurzLangSchwelle;
		zeitString     = sa.spieluhr.getSpielzeitString();
		date           = new Date();
		schiriStart_ms = date.getTime();
		sperrEnd_ms    = schiriStart_ms + sperrZeit_ms;  // wenn keine Erkennung, sind die anderen solange gesterrt
		schiriThread   = new Thread(this);
		schiriThread.start();

		// die anderen sind in der Zeit gesperrt ...
		sa.schiriSperre(passivSchiri1, true, passivSchiri2, true, null, false );

		// den letzten aktiven Schiri zeigen ...
		aktivSchiri.showActive(true);
		passivSchiri1.showActive(false);
		passivSchiri2.showActive(false);

		wartenAufAbhupen = (! sa.abgehupt) ;
		starfwurfSituation = ( sa.strafwurfRechts.isActivated || sa.strafwurfLinks.isActivated );

		// Erst einmal reagieren, wenn kein Signal erkannt, kann man immer noch ndern ...
		if ( wartenAufAbhupen ) { // wartenAufAbhupen = true:  nicht abgehupt, warten auf Tor oder Foul
			zeitAnhalten();
		}
		else {                    // wartenAufAbhupen = false: abgehupt, warten auf Anhupen
			zeitBeginnenFortsetzen(true);  // lastStopWasOK = true
		}
	}

	/*
	 * wird bei einer Signalvernderung von SchiriAnlage aufgerufen.
	 */
	public void setSignal(boolean gedrueckt) {
		long   signal_ms, signalDauer_ms;

		this.gedrueckt = gedrueckt; // Signal-Zustand merken!

		date           = new Date();
		signal_ms      = date.getTime();

		sperrEnd_ms    = signal_ms + sperrZeit_ms;

		// Anfang des Hupsignals, Drcker wird heruntergedrckt, ...
		if ( gedrueckt ) {
			gedruecktStart_ms = signal_ms;
			return;
		}

		// Ende des Hupsignals (gedrueckt == false) ...
		signalDauer_ms = signal_ms - gedruecktStart_ms;
		// System.out.println( "SchiriSignalVerfolgung: " +  signalDauer_ms);

		if ( wartenAufAbhupen ) { // wartenAufAbhupen = true:  nicht abgehupt, warten auf Tor oder Foul
			if ( signalDauer_ms > kurzLangSchwelle ) { // langes Signal
				signalFolge += 'L';
			}
			else {                                     // kurzes Signal
				signalFolge += 'K';
			}
			checkSignalFolge();
		}
		else {                  // wartenAufAbhupen = false: abgehupt, warten auf Anhupen
			if ( signalDauer_ms > kurzLangSchwelle / 2 ) { // langes Signal, oder zumindest halbes langes
				anhupen(signalDauer_ms);
				// System.out.println("anhupen: " + sa.spieluhr.spielzeit_ms );
			}
			else {
				// System.out.println("kurzes Signal, nicht erwartet :-( " + signalDauer_ms );
				zeitAnhalten();
				sa.schiriSperre(sa.uwSchiri1, false, sa.uwSchiri2, false, sa.spielleiter, false );
				beenden(false); // dieser SchiriSignalVerfolgung ...
			}
		}
	}

	private void checkSignalFolge() {
		if      ( signalFolge.compareTo("LL") == 0 ) {
			sa.print_meldung(zeitString + ": " + sa.getTextLabel("goal") + " (" + sa.getTextLabel("long") + " " + sa.getTextLabel("long") + ")", true);
			sa.aktuellesProtokoll.newProtokollEntry(protokoll.TOR, null);
			sa.korbCanvas.setActive(true);
			spielAnhalten();
		}
		else if ( signalFolge.compareTo("KL") == 0 ) {
			sa.print_meldung(zeitString + ": " + sa.getTextLabel("goal") + " (" + sa.getTextLabel("short") + " " + sa.getTextLabel("long") + ")", true);
			sa.aktuellesProtokoll.newProtokollEntry(protokoll.TOR,  null);
			sa.korbCanvas.setActive(true);
			spielAnhalten();
		}
		else if ( signalFolge.compareTo("K") == 0 ) {
			// System.out.println("Signal: kurz (einmal ist keinmal)");
		}
		else if ( signalFolge.compareTo("KK") == 0 ) {
			// System.out.println("Signal: kurz kurz (zweimal ist einaml ist keinmal)");
		}
		else if ( signalFolge.compareTo("KKK") == 0 ) {
			sa.print_meldung(zeitString + ": " + sa.getTextLabel("foul") + ", " + sa.getTextLabel("foulExplain") + " (" + sa.getTextLabel("short") + " " + sa.getTextLabel("short") + " " + sa.getTextLabel("short") + ")", true);
			sa.aktuellesProtokoll.newProtokollEntry(protokoll.FREIWURF,  null);
			sa.foulCanvas.setActive(true);
			spielAnhalten();
		}
		else if ( signalFolge.compareTo("LLL") == 0 && starfwurfSituation ) {
			sa.print_meldung(zeitString + ": " + sa.getTextLabel("correction") + ": " + sa.getTextLabel("penaltyThrowEnd") + " (" + sa.getTextLabel("long") + " " + sa.getTextLabel("long") + " " + sa.getTextLabel("long") + ")", true);
			sa.korbCanvas.setActive(false);
		}
		else if ( signalFolge.length() > 2 && ! signalErkannt ) {
			sa.print_meldung(zeitString + ": "+ sa.getTextLabel("foul") + ", " + sa.getTextLabel("foulExplain") + " (" + sa.getTextLabel("manySignals") + ")", true);
			sa.aktuellesProtokoll.newProtokollEntry(protokoll.FREIWURF,  null);
			sa.foulCanvas.setActive(true);
			spielAnhalten();
		}
	}

	private void spielAnhalten() {
			sa.abgehupt = true;
			signalErkannt = true;
			// strafwurfEnable, halbzeitpauseEnable, konfigEnable, strafzeitEnable
			sa.buttonDeEnable(true, false, true);

			// ein Strafwurf wird danach ggf. neu aufgesetzt, aber nicht fortgesetzt
			sa.strafwurfRechts.beenden(false);
			sa.strafwurfLinks.beenden(false);

			// nun knnen wieder alle Schiris hupen ...
			sa.schiriSperre(sa.uwSchiri1, false, sa.uwSchiri2, false, sa.spielleiter, false );
	}

	private void zeitAnhalten() {
			// Uhren anhalten, wenn keine durchlaufende Zeit ...
			if ( ! sa.durchlaufendeZeit ) {
				sa.spieluhr.anhalten();
				sa.strafzeitRechts1.anhalten();
				sa.strafzeitRechts2.anhalten();
				sa.strafzeitRechts3.anhalten();
				sa.strafzeitLinks1.anhalten();
				sa.strafzeitLinks2.anhalten();
				sa.strafzeitLinks3.anhalten();

				sa.strafwurfRechts.anhalten();
				sa.strafwurfLinks.anhalten();
			}
	}

	/*
	 * Zeit soll anlaufen bzw. weiterlaufen
	 * wenn lastStopWasOK == false: Weiterlaufen, als wre sie zuletzt nicht angehalten worden.
	 */
	private void zeitBeginnenFortsetzen(boolean lastStopWasOK) {
			sa.spieluhr.beginnenFortsetzen(lastStopWasOK); // falls sa.durchlaufendeZeit true passiert nichts

			sa.strafzeitRechts1.beginnenFortsetzen(lastStopWasOK);
			sa.strafzeitRechts2.beginnenFortsetzen(lastStopWasOK);
			sa.strafzeitRechts3.beginnenFortsetzen(lastStopWasOK);
			sa.strafzeitLinks1.beginnenFortsetzen(lastStopWasOK);
			sa.strafzeitLinks2.beginnenFortsetzen(lastStopWasOK);
			sa.strafzeitLinks3.beginnenFortsetzen(lastStopWasOK);

			sa.strafwurfRechts.beginnenFortsetzen(lastStopWasOK);
			sa.strafwurfLinks.beginnenFortsetzen(lastStopWasOK);
	}

	private void anhupen(long signalDauer_ms) {
		// nur einmal pro SchiriSignalVerfolgung
		if ( signalErkannt )
			return;

		signalErkannt = true;
		sa.abgehupt   = false;

		// System.out.println("anhupen: " + sa.spieluhr.spielzeit_ms );
		String meldung = zeitString + ": " + sa.getTextLabel("matchResuming");

		if ( signalDauer_ms < kurzLangSchwelle )
			meldung += ". " + sa.getTextLabel("veryShortSignal") + ": " + signalDauer_ms + " ms.";

		sa.print_meldung( meldung, true );

		// nun knnen wieder alle Schiris hupen ...
		sa.schiriSperre(sa.uwSchiri1, false, sa.uwSchiri2, false, sa.spielleiter, false );

		// strafwurfEnable, halbzeitpauseEnable, konfigEnable, strafzeitEnable
		sa.buttonDeEnable(true, false, true);

		// Die Icons wieder auf neutral ...
		sa.korbCanvas.setActive(false);
		sa.foulCanvas.setActive(false);

		beenden(false);
	}


	private void beenden(boolean passivFreischalten) {
		if ( passivFreischalten && ! signalErkannt ) {
			sa.schiriSperre(passivSchiri1, false, passivSchiri2, false, null, false );
		}
		schiriThread = null;
		sa.ssv = null;
	}

	public void run() {
		while (schiriThread != null) {
			date         = new Date();
			aktZeit_ms   = date.getTime();
			if ( gedrueckt ) // Weiterlaufen, wenn gedrueckt. Sperrzeit wird immer wieder hochgesetzt.
				sperrEnd_ms  = aktZeit_ms + sperrZeit_ms;
			if ( aktZeit_ms < sperrEnd_ms ) {
				try {Thread.sleep(sperrEnd_ms - aktZeit_ms);} catch (InterruptedException e){}
			}
			else {
				if ( signalErkannt == false ) {
					if ( wartenAufAbhupen ) { // flschlicherweise angehalten
						zeitBeginnenFortsetzen(false); // lastStopWasOK = false
					}
					else { // "flschlicherweise gestartet". Kommt nicht hier her, wird vorher beendet.
						zeitAnhalten();
					}
				}
				beenden(true);
			}
		}
	}
}

/*
 * Dieses Interface ist fr "halbzeitpauseFenster".
 * Wenn die Zeit abgelaufen ist, fhrt "ablaufzeitCanvas" die Methode zeitEndeAction() vom Interface aus.
 */
interface zeitEnde {
	public void zeitEndeAction ();
}

/*
 * Dieses Interface ist fr das Blinken. "Strafzeit" stellt dieses Interface zur Verfgung.
 * Wenn notwendig wird dann ein "Blinkgeber" erzeugt, der dann die Methode "blink (boolean onOff)" aufruft.
 */
interface blinkable {
	public void blink (boolean onOff);
}

/*
 * Diese Klasse ist fr periodische Vernderungen. Es lsst das "blinkable blinkableObject" blinken.
 */
class Blinkgeber implements Runnable {
	Thread    runThread = null;
	int       msOn, msOff;        // Milli-Sekunden fr An und Aus.
	blinkable blinkableObject;    // Objekt, das blinken soll.

	public Blinkgeber(int msOn, int msOff, blinkable blinkableObject) {
		this.msOn = msOn;
		this.msOff = msOff;
		this.blinkableObject = blinkableObject;
		if(runThread == null) {
			runThread    = new Thread(this);
			runThread.start();
		}
	}
	public void run() {
		while (runThread != null) {
			blinkableObject.blink (true);
			try {Thread.sleep(msOn);} catch (InterruptedException e){}
			if (runThread != null) {        // falls inszwischen beendet, nicht mehr
				blinkableObject.blink (false);
				try {Thread.sleep(msOff);} catch (InterruptedException e){}
			}
		}
	}

	public void beenden() {
		// System.out.println( "Blinkgeber wird beendet.");
		runThread = null;
		blinkableObject.blink (false);
	}

}

/*
 * Diese Klasse ist fr die Strafzeiten verantwortlich.
 * Zur Darstellung ist es ein Panel. Zum Starten: start() -> run()
 */
class Strafzeit extends Panel implements Runnable, ActionListener, KeyListener, blinkable {
	Button          startButton;
	zeitBalken      balken;
	SchiriAnlage    sa;
	Thread          runThread = null;
	Blinkgeber      blinker   = null;
	boolean isActivated = false;  // true nach dem Start, bis zum beenden
	boolean isRunning = false;    // true wenn die Zeit luft
	Date    date = null;
	long    ms = 0, start_ms = 0, strafzeit_ms = 0;  // in Millisekunden
	int     gesamtStrafzeit = 120;
	int     restStrafzeit;
	int     lastRestStrafzeit  = gesamtStrafzeit + 1;
	int     blinkRestStrafzeit = 10;
	long    gesamtStrafzeit_ms = (long)(gesamtStrafzeit * 1000);
	int     dataBit;
	int     minHeight = 250;

	public Strafzeit(String bezeichnung, int dataBit, int additionalHeight, SchiriAnlage sa) {
		// System.out.println("Strafzeit: ");
		this.sa = sa;
		this.dataBit = dataBit;
		this.setLayout(new BorderLayout());
		Panel balkenPanel = new Panel(new FlowLayout(FlowLayout.CENTER, 5, 5));
		// zeitBalken (int zeit, Color backgroundColor, Color zeitbalkenColor, Color fontColor);
		balken = new zeitBalken(gesamtStrafzeit, Color.lightGray, Color.red, Color.black);
		balken.setSize(20,minHeight+additionalHeight);
		this.add (new Label(bezeichnung, Label.CENTER), BorderLayout.NORTH);
		this.add (balkenPanel, BorderLayout.CENTER);
		balkenPanel.add (balken);
		startButton = new Button(sa.getTextLabel("penaltyTiStart"));
		this.add (startButton, BorderLayout.SOUTH);
		startButton.addActionListener(this);  // Mouse-Klicks
		startButton.addKeyListener(this);     // Tastatur-Eingaben
		isActivated = false;  // true nach dem Start, bis zum beenden
		isRunning = false;    // true wenn die Zeit luft
	}

	/*
	 * Die folgende Methode bildet das blinkable-Interface
	 */
	public void blink (boolean onOff) {
		if ( onOff ) {
			balken.setColor(Color.green);  // Balken grn
			sa.setStrafzeit(dataBit, '0'); // Lampe aus
		}
		else {
			balken.setColor(null);         // Balken in alter Farbe
			sa.setStrafzeit(dataBit, '1'); // Lampe an
		}
	}

	/*
	 * Setzt die GesamtStrafzeit neu.
	 */
	public void setGesamtStrafzeit(int strafzeit) {
		this.gesamtStrafzeit = strafzeit;
		lastRestStrafzeit = gesamtStrafzeit + 1;
		gesamtStrafzeit_ms = (long)(gesamtStrafzeit * 1000);
		balken.setZeit(strafzeit);
	}

	/*
	 * Die folgenden drei Methoden sind fr den Seitenwechsel
	 */
	public void setStrafzeitNeu(long strafzeit_ms, boolean activate) {
		beenden();                     // damit man definiert anfngt
		if ( activate ) {              // nur wenn berhaupt aktiviert werden soll
			runThread = new Thread(this);
			runThread.start();
			activatedStrafzeit(false);
			this.strafzeit_ms = strafzeit_ms;
			date              = new Date();
			start_ms          = date.getTime() - strafzeit_ms;
			balken.setRestzeit(gesamtStrafzeit - (int)(strafzeit_ms/1000));
			if ( ! sa.abgehupt && sa.durchlaufendeZeit )
				isRunning = true;
		}
	}

	public long getStrafzeit() {
		return strafzeit_ms;
	}

	public boolean isActiv() {
		return isActivated;
	}

	public void activatedStrafzeit(boolean mitProtokoll) {
		Color  farbe       = null;
		String farbeString = "(" + sa.getTextLabel("unknown") + ")";

		// System.out.println("Strafzeit: " );
		isActivated = true;  // true nach dem Start, bis zum beenden
		startButton.setLabel(sa.getTextLabel("stop"));
		sa.setStrafzeit(dataBit, '1'); // Lampe an
		balken.setRestzeit(gesamtStrafzeit);

		if ( ! sa.abgehupt || sa.durchlaufendeZeit ) // versptet gedrckt, luft sofort los
			this.beginnenFortsetzen(true);       // lastStopWasOK = true

		// Farbe?
		if      ( this == sa.strafzeitLinks1 ||
			  this == sa.strafzeitLinks2 ||
			  this == sa.strafzeitLinks3   ) farbe = sa.colorLinks; // Strafzeit fr linke Mannschaft
		else if ( sa.colorLinks == Color.blue  ) farbe = Color.white;   // Strafzeit fr rechte Mannschaft
		else if ( sa.colorLinks == Color.white ) farbe = Color.blue;

		if      ( farbe == Color.blue  ) farbeString = sa.getTextLabel("blue") + ".";
		if      ( farbe == Color.white ) farbeString = sa.getTextLabel("white") + ".";

		// Info und Protokoll ...
		if ( mitProtokoll ) {
			sa.print_meldung(sa.spieluhr.getSpielzeitString() + ": " + sa.getTextLabel("penaltyTimeFor") + " " + farbeString, true);
			sa.aktuellesProtokoll.newProtokollEntry(protokoll.ZEITSTRAFE, farbe);
		}
	}

	/*
	 * Anhupen des Spielleiters fhrt zu dieser Methode fr die Strafzeit
	 * lastStopWasOK = false: die Zeit soll so weiterlaufen als wre nicht gestoppt worden
	 */
	public void beginnenFortsetzen(boolean lastStopWasOK) {
		// System.out.println("Strafzeit: beginnenFortsetzen: " );

		if ( ! isActivated ) // wenn die Strafzeit nicht aktiviert, soll auch nichts passieren.
			return;
		if ( isRunning )     // luft ja schon ...
			return;
		date         = new Date();

		if(runThread == null) {                  // Strafzeitbeginn
			start_ms     = date.getTime();
			strafzeit_ms = 0;
			runThread    = new Thread(this);
			runThread.start();
		}
		else {                                  // Anhupen nach Foul oder Tor
			if ( ! sa.durchlaufendeZeit &&  // nur bei nicht durchlaufender Zeit
			     lastStopWasOK) {           // wenn der letzte Stopp nicht ok war, mit alter Startzeit
				start_ms     = date.getTime() - strafzeit_ms;
			}
		}

		isRunning    = true;
	}

	public void anhalten() {
		isRunning = false;
	}

	public void beenden() {
		// System.out.println( "Strafzeit wird beendet." + strafzeit_ms);
		runThread = null;
		if ( blinker != null ) blinker.beenden();
		blinker = null;
		sa.setStrafzeit(dataBit, '0'); // Lampe aus
		ms = 0;
		start_ms = 0;
		strafzeit_ms = 0;
		balken.setRestzeit(0);
		startButton.setLabel(sa.getTextLabel("penaltyTiStart"));
		isActivated = false;  // true nach dem Start, bis zum beenden
		isRunning = false;    // true wenn die Zeit luft
	}

	public void run() {
		int sleep_ms;

		while (runThread != null) {
			if ( isRunning )  {
				date         = new Date();
				ms           = date.getTime();
				strafzeit_ms = ms - start_ms;
				restStrafzeit = gesamtStrafzeit - (int)(strafzeit_ms/1000);
				if ( restStrafzeit != lastRestStrafzeit ) {
					balken.setRestzeit(restStrafzeit);

				}
				lastRestStrafzeit = restStrafzeit;
				if ( restStrafzeit <= blinkRestStrafzeit && blinker == null) {   // Blinken
					blinker = new Blinkgeber(250, 750, this);
				}
				if ( strafzeit_ms >= gesamtStrafzeit_ms ) {
					beenden();
				}
				else {
					if ( strafzeit_ms >= gesamtStrafzeit_ms - 500 )
						sleep_ms = (int) (gesamtStrafzeit_ms - strafzeit_ms);
					else
						sleep_ms = 500;  // immer maximal eine halbe Sekunde warten.
					try {Thread.sleep(sleep_ms);} catch (InterruptedException e){}
				}
			}
			else                   // noch 50 Millisekunden warten.
				try {Thread.sleep(50);} catch (InterruptedException e){}
		}
	}

	public void buttonAction() {
		if ( isActivated ) {            // luft schon, wird jetzt beendet ...
			beenden();
		}
		else {                          // luft noch nicht -> aktivieren ....
			activatedStrafzeit(true);
		}
	}

	/*
	 * Die folgende Methode bildet das ActionListener-Interface und
	 * beantworten das Anklicken der Buttons.
	 */
	public void actionPerformed(ActionEvent e) {
		if ( ! ( e.getSource() instanceof Button ) ) {
			return;
		}
		Button target = (Button) e.getSource();        // MOUSE CLICK auf Button ...
		if      (target == startButton) {
			buttonAction();
		}
	}

	/*
	 * Die folgenden Methoden bilden das KeyListener-Interface und
	 * beantworten Tastatureingaben.
	 */
	public void keyPressed(KeyEvent e) {
		int key = e.getKeyCode();
		if ( key != KeyEvent.VK_ENTER )
			return;
		if ( ! ( e.getSource() instanceof Button ) ) {
			return;
		}
		Button target = (Button) e.getSource();        // Tastatur-Eigabe ...
		if      (target == startButton) {
			buttonAction();
		}
	}
	public void keyReleased(KeyEvent e)  { }
	public void keyTyped(KeyEvent e)     { }

}


/*
 * Diese Klasse ist fr die Strafwrfe verantwortlich.
 * Zur Darstellung ist es ein Panel. Zum Starten des Threads: start() -> run()
 */
class Strafwurf extends Panel implements Runnable, ActionListener, KeyListener {
	Button          startButton;
	zeitBalken      balken;
	SchiriAnlage    sa;
	Thread  runThread = null;
	boolean isActivated = false;                     // true nach dem Start, bis zum beenden
	boolean isRunning   = false;                     // true wenn die Zeit luft
	Date    date = null;
	long    ms = 0, start_ms = 0, strafwurf_ms = 0;  // in Millisekunden
	int     gesamtStrafwurf = 45;                    // vorlufig, wird neu gesetzt
	long    gesamtStrafwurf_ms = (long)(gesamtStrafwurf * 1000);
	int     minHeight = 250;

	public Strafwurf(Button strafwurfButton, int additionalHeight, SchiriAnlage sa) {
		// System.out.println("Strafwurf: ");
		this.sa = sa;
		startButton = strafwurfButton;
		gesamtStrafwurf = sa.strafwurfzeit;
		this.setLayout(new BorderLayout());
		Panel balkenPanel = new Panel(new FlowLayout(FlowLayout.CENTER, 5, 5));
		// zeitBalken (int zeit, Color backgroundColor, Color zeitbalkenColor, Color fontColor);
		balken = new zeitBalken(gesamtStrafwurf, Color.gray, Color.blue, Color.white);
		balken.setSize(20,minHeight+additionalHeight);
		this.add (new Label("", Label.CENTER), BorderLayout.NORTH);
		this.add (balkenPanel, BorderLayout.CENTER);
		balkenPanel.add (balken);
		this.add (startButton, BorderLayout.SOUTH);
		startButton.addActionListener(this);  // Mouse-Klicks
		startButton.addKeyListener(this);     // Tastatur-Eingaben
		isActivated = false;                  // true nach dem Start, bis zum beenden
		isRunning = false;                    // true wenn die Zeit luft
	}

	/*
	 * Setzt die Strafzeit neu.
	 */
	public void setStrafwurf(int strafwurf) {
		this.gesamtStrafwurf = strafwurf;
		gesamtStrafwurf_ms = (long)(gesamtStrafwurf * 1000);
		balken.setZeit(strafwurf);
	}

	/*
	 * Die Strafwurfzeit wird aktiviert.
	 */
	public void activatedStrafwurf() {
		Color farbe        = null;
		String farbeString = "(" + sa.getTextLabel("unknown") + ")";
		ProtokollEintrag lastPE;

		// System.out.println("Strafwurf: " );
		isActivated = true;  // true nach dem Start, bis zum beenden
		startButton.setLabel(sa.getTextLabel("stop"));
		balken.setRestzeit(gesamtStrafwurf);

		if ( ! sa.abgehupt ) // verstptet den Button gedrckt -> luft sofort los
			this.beginnenFortsetzen(true);

		// Farbe?
		if      ( this == sa.strafwurfLinks    ) farbe = sa.colorLinks; // Strafwurf gegen linke Mannschaft
		else if ( sa.colorLinks == Color.blue  ) farbe = Color.white;   // Strafwurf gegen rechte Mannschaft
		else if ( sa.colorLinks == Color.white ) farbe = Color.blue;

		if      ( farbe == Color.blue  ) farbeString = sa.getTextLabel("blue") + ".";
		if      ( farbe == Color.white ) farbeString = sa.getTextLabel("white") + ".";

		// Info und Protokoll ...
		lastPE = sa.aktuellesProtokoll.getLastSortedEntry();
		if ( lastPE == null || lastPE.type != protokoll.STRAFWURF || lastPE.colorEntry != farbe ) {
			sa.print_meldung(sa.spieluhr.getSpielzeitString() + ": " + sa.getTextLabel("penaltyThrowA") + " " + farbeString, true);
			sa.aktuellesProtokoll.newProtokollEntry(protokoll.STRAFWURF, farbe);
		}
	}

	/*
	 * Anhupen des Spielleiters fhrt zu dieser Methode fr die Strafwurf
	 * lastStopWasOK = false: die Zeit soll so weiterlaufen als wre nicht gestoppt worden
	 */
	public void beginnenFortsetzen(boolean lastStopWasOK) {
		// System.out.println("Strafwurf: beginnenFortsetzen: " );

		if ( ! isActivated ) // wenn die Strafwurf nicht aktiviert, soll auch nichts passieren.
			return;
		if ( isRunning )     // luft ja schon ...
			return;

		date         = new Date();

		if(runThread == null) {                  // Strafwurfbeginn
			start_ms     = date.getTime();
			strafwurf_ms = 0;
			runThread    = new Thread(this);
			runThread.start();               // Starten des Threads ...
		}
		else {                                   // Anhupen nach Foul oder Tor
			if ( ! sa.durchlaufendeZeit &&   // nur bei nicht durchlaufender Zeit
			     lastStopWasOK) {            // wenn der letzte Stopp nicht ok war, mit alter Startzeit
				start_ms     = date.getTime() - strafwurf_ms;
			}
		}

		isRunning    = true;                     // die Starfwurfzeit luft
	}

	/*
	 * Die Strafwurfzeit wird angehalten. run() schaut nach "isRunning".
	 */
	public void anhalten() {
		isRunning = false;                       // die Starfwurfzeit luft nicht
	}

	/*
	 * Die Strafwurfzeit wird beendet. Regulr beenden -> hupen = true.
	 */
	public void beenden(boolean hupen) {
		// System.out.println( "Strafwurf wird beendet." + strafwurf_ms);
		runThread    = null;
		ms           = 0;
		start_ms     = 0;
		strafwurf_ms = 0;
		balken.setRestzeit(0);
		startButton.setLabel(sa.getTextLabel("penaltyThrowShort"));
		isActivated  = false;  // true nach dem Start, bis zum beenden
		isRunning    = false;  // true wenn die Zeit luft
		if ( hupen ) {
			// Uhren anhalten, wenn keine durchlaufende Zeit ...
			if ( ! sa.durchlaufendeZeit ) {
				sa.spieluhr.anhalten();
				sa.strafzeitRechts1.anhalten();
				sa.strafzeitRechts2.anhalten();
				sa.strafzeitRechts3.anhalten();
				sa.strafzeitLinks1.anhalten();
				sa.strafzeitLinks2.anhalten();
				sa.strafzeitLinks3.anhalten();
			}

			sa.abhupen();

			sa.print_meldung(sa.spieluhr.getSpielzeitString() + ": " + sa.getTextLabel("penaltyTimeEnd"), true);
		}
	}

	/*
	 * Steuert den Thread.
	 */
	public void run() {
		int sleep_ms;

		while (runThread != null) {
			if ( isRunning )  {
				date         = new Date();
				ms           = date.getTime();
				strafwurf_ms = ms - start_ms;
				balken.setRestzeit(gesamtStrafwurf - (int)(strafwurf_ms/1000));
				if ( strafwurf_ms >= gesamtStrafwurf_ms ) {
					beenden(true);
				}
				else {                            // wie lange noch?
					if ( strafwurf_ms >= gesamtStrafwurf_ms - 500 )
						sleep_ms = (int) (gesamtStrafwurf_ms - strafwurf_ms);
					else
						sleep_ms = 500;   // immer maximal eine halbe Sekunde warten.
					try {Thread.sleep(sleep_ms);} catch (InterruptedException e){}
				}
			}
			else                   // noch 50 Millisekunden warten.
				try {Thread.sleep(50);} catch (InterruptedException e){}
		}
	}

	/*
	 * Reaktion auf das Klicken des Buttons
	 */
	public void buttonAction() {
		if ( isActivated ) {            // luft schon, wird jetzt beendet (ohne Hupen) ...
			beenden(false);
		}
		else {                          // luft noch nicht -> aktivieren ....
			activatedStrafwurf();
		}
	}

	/*
	 * Die folgende Methode bildet das ActionListener-Interface und
	 * beantworten das Anklicken der Buttons.
	 */
	public void actionPerformed(ActionEvent e) {
		if ( ! ( e.getSource() instanceof Button ) ) {
			return;
		}
		Button target = (Button) e.getSource();        // MOUSE CLICK auf Button ...
		if      (target == startButton) {
			buttonAction();
		}
	}

	/*
	 * Die folgenden Methoden bilden das KeyListener-Interface und
	 * beantworten Tastatureingaben.
	 */
	public void keyPressed(KeyEvent e) {
		int key = e.getKeyCode();
		if ( key != KeyEvent.VK_ENTER )
			return;
		if ( ! ( e.getSource() instanceof Button ) ) {
			return;
		}
		Button target = (Button) e.getSource();        // Tastatur-Eigabe ...
		if      (target == startButton) {
			buttonAction();
		}
	}
	public void keyReleased(KeyEvent e)  { }
	public void keyTyped(KeyEvent e)     { }

}

/*
 * Diese Klasse ist fr die Zeitbalken von den Strafzeiten und Strafwrfen
 */
class zeitBalken extends Canvas {
	private int         gesamtzeit;       // in Sekunden
	private int         restzeit   = 0;
	private int         y          = -1;  // von oben bis zur Oberkante des roten Balkens
	private Font        secFont;
	private FontMetrics fm;
	private int         fontHeight;
	private Color       backgroundColor, zeitbalkenColor, fontColor;
	private Color       changeZeitbalkenColor = null;

	public zeitBalken (int zeit, Color backgroundColor, Color zeitbalkenColor, Color fontColor) {
		// System.out.println("zeitBalken: ");
		this.backgroundColor = backgroundColor;
		this.zeitbalkenColor = zeitbalkenColor;
		this.fontColor       = fontColor;

		setZeit(zeit);
		setBackground(backgroundColor);
		secFont    = new Font("Helvetica", Font.PLAIN, 12);
		fm         = getFontMetrics(secFont);
		fontHeight = fm.getAscent();
	}

	public void setZeit(int zeit) {
		this.gesamtzeit = zeit;
	}

	public void paint(Graphics g) {
		if ( y >= 0 ) {
			if ( changeZeitbalkenColor == null )
				g.setColor(zeitbalkenColor);
			else
				g.setColor(changeZeitbalkenColor);
			g.fillRect(3,y,  // roter Balken rechts und links 3 frei
				   getSize().width -6,getSize().height -y);
			if ( restzeit > 0 ) {
				g.setColor(fontColor);
				g.setFont(secFont);
				String restzeitString = Integer.toString(restzeit);
				int    restzeitX      = (getSize().width - fm.stringWidth(restzeitString))/2;
				int    restzeitY      = (y > fontHeight+4) ? (y-3) : (fontHeight+1);
				g.drawString(restzeitString, restzeitX,restzeitY);
			}
		}
	}

	public void setRestzeit(int rest) {
		restzeit = rest;
		y = ((gesamtzeit - restzeit) * getSize().height  / gesamtzeit);
		repaint();
	}

	/*
	 * Zum Blinken kann die Farbe des Balkens gandert werden ...
	 */
	public void setColor (Color changeColor) {
		if ( changeColor != changeZeitbalkenColor ) {
			changeZeitbalkenColor = changeColor;
			repaint();
		}
	}
}

/*
 * Diese Klasse ist fr die SchiedsrichterAnzeige verantwortlich.
 * Zur Darstellung ist es ein Panel.
 */
class Schiedsrichter extends Panel implements MouseListener {

	public boolean gesperrt = true;  // keine Eingabe mglich. weder real noch Simulation

	SchiedsrichterLicht licht;
	Panel               anzeigenPanel;
	Color               activePanelColor;
	SchiriAnlage        sa;

	String              name;
	int                 statusBit;

	public Schiedsrichter(String bezeichnung, int statusBit, SchiriAnlage sa) {
		// System.out.println("Schiedsrichter: ");
		this.name      = bezeichnung;
		this.sa        = sa;
		this.statusBit = statusBit;
		this.setLayout(new BorderLayout());
		anzeigenPanel = new Panel(new FlowLayout(FlowLayout.CENTER, 20, 20));
		licht = new SchiedsrichterLicht();
		Label schiriLabel = new Label(bezeichnung, Label.CENTER);
		this.add (schiriLabel, BorderLayout.NORTH);
		this.add (anzeigenPanel, BorderLayout.CENTER);
		anzeigenPanel.add (licht);
		licht.addMouseListener(this);
		activePanelColor = new Color(180, 150, 150);
	}

	/*
	 * Wird ber die ParallelPortKommunikation gestartet (nicht direkt ber MouseKlick!)
	 */
	public void setAnzeige(char onOff) {

		licht.gesperrt = this.gesperrt;

		if (onOff == '1') {  // Schiedsrichter-Drcker (oder Simulation) aktiv
			licht.farbe = Color.red;
		}
		else {
			licht.farbe = Color.lightGray;
		}
		licht.repaint();
	}

	/*
	 * Damit man den letzten Schiri erkennt, der aktiv war
	 */
	public void showActive(boolean active) {
		if (active)
			anzeigenPanel.setBackground(activePanelColor);
		else
			anzeigenPanel.setBackground(Color.white);
	}

	/*
	 * Die folgende Methode bildet das MouseListener-Interface und
	 * beantworten das Drcken und Loslassen der Maus.
	 */
	public void mouseClicked(MouseEvent e)   { }
	public void mouseEntered(MouseEvent e)   { }
	public void mouseExited (MouseEvent e)   { }
	public void mousePressed(MouseEvent e) {
		if ( sa.schiriSimulation && ! gesperrt )
			sa.setStatusBit(statusBit,'1');
	}
	public void mouseReleased(MouseEvent e) {
		if ( sa.schiriSimulation && ! gesperrt )
			sa.setStatusBit(statusBit,'0');
	}
}


/*
 * Diese Klasse bildet nur das Licht fr einen Schiedsrichter.
 */
class SchiedsrichterLicht extends Canvas {
	public boolean gesperrt = false;
	public Color   farbe    = Color.lightGray;

	public SchiedsrichterLicht () {
		// System.out.println("SchiedsrichterLicht: ");
		this.setSize(20,20);
	}

	public void paint(Graphics g) {
		g.setColor(farbe);
		g.fillOval(0,0,19,19);
		g.setColor(Color.black);
		g.drawOval(0,0,19,19);
		if ( gesperrt ) {
			g.drawLine(0, 0, 19, 19);
			g.drawLine(0, 1, 18, 19);
			g.drawLine(1, 0, 19, 18);
			g.drawLine(0, 19, 19, 0);
			g.drawLine(0, 18, 18, 0);
			g.drawLine(1, 19, 19, 1);
		}
	}
}


/*
 * Diese Interface ist notwendig, damit sowohl die Klasse SchiriAnlage als auch die Klasse protokoll
 * gleich auf das Anklicken eines Icons reagieren knnen.
 */
interface iconControl {

	public void iconCanvasAction (iconCanvas ic);

}

/*
 * Diese Klasse stellt die Icon fr Tor, Hupe, Foul dar.
 */
class iconCanvas extends Canvas implements MouseListener {
	private boolean      active = true;       // true -> buntes Bild; false -> graues Bild
	private Image        activeImage, passiveImage;
	private Color        farbe = Color.black; // Farbe fr Hup-Nummer
	private SchiriAnlage sa;
	private iconControl  ic;                  // Interface fr Anklicken der Icons: SchiriAnlage oder protokoll
	private int          number = -1;         // Hupennummer, 0 und 1 werden angezeigt, -1 nicht.
	private int          height = 60, width = 60;
	private int          dataBitHupe;
	private int          type;               // type = protokoll.TOR, ...
	private boolean      isHupe = false;     // anderes Verhalten bei den Hup-Icons

	// Constructor fr Hup- und andere Icons; ic kontrolliert; typeOrBit = Bit fr Hupe oder type fr andere Icons.
	public iconCanvas (SchiriAnlage sa, iconControl ic, boolean isHupe, int typeOrBit) {
		this.sa = sa;
		this.ic = ic;
		this.setSize(width,height);
		this.isHupe = isHupe;
		if ( isHupe ) {     // fr Hup-Icons
			this.dataBitHupe = typeOrBit;  // typeOrBit = Bit
			this.type = protokoll.UNDEFINED;
		}
		else {              // fr andere Icons
			this.dataBitHupe = -1;
			this.type = typeOrBit;         // typeOrBit = type
		}

		this.addMouseListener(this);
	}

	/*
	 * Die folgende Methode kann erst spter aufgerufen werden, wenn das Programm schon auf dem Bildschirm.
	 * number = Hupennummer (wenn nicht Hupe dann -1)
	 */
	public void setImage(Image activeImage, Image passiveImage, int number) {
		// System.out.println("iconCanvas: ");
		Graphics g;

		this.activeImage  = activeImage;
		this.passiveImage = passiveImage;
		this.number       = number;
		repaint();
	}

	public void setActive(boolean a) {
		active = a;
		repaint();
	}

	public boolean getActive() {
		return active;
	}

	public int getType() {
		return type;
	}

	public void paint(Graphics g) {
		if ( active ) {
			try {
				g.drawImage(activeImage,0,0,sa);
			} catch (Exception e){}
		}
		else {
			try {
				g.drawImage(passiveImage,0,0,sa);
			} catch (Exception e){}
		}
		if ( number >= 0 ) {
			g.setColor(farbe);
			g.drawString(Integer.toString(number),width-10,height-1);
		}
	}


	/*
	 * Die folgende Methode bildet das MouseListener-Interface und
	 * beantworten das Drcken und Loslassen der Maus.
	 */
	public void mouseClicked(MouseEvent e)   {
		String korrekturString = "";

		if ( isHupe ) return;      // Hupe wird ber die anderen Methoden abgehandelt (s.u.)

		ic.iconCanvasAction(this); // ic steuert den Rest
	}
	public void mouseEntered(MouseEvent e)   { }
	public void mouseExited (MouseEvent e)   { }
	public void mousePressed(MouseEvent e) {
		if ( isHupe && sa.spieluhr != null && sa.abgehupt ) {
			sa.setHupe(dataBitHupe,'1');
		}
	}
	public void mouseReleased(MouseEvent e) {
		if ( isHupe && sa.spieluhr != null ) {
			sa.setHupe(dataBitHupe,'0');
		}
	}
}


/*
 * Diese Klasse ist fr die Anzeige des Spielstandes verantwortlich.
 * Genauer: Ein Objekt zeigt die Tore einer Mannschaft.
 * Zur Darstellung ist es ein Canvas.
 */
class toranzeige extends Canvas {
	SchiriAnlage sa;
	Font         digitalFont;
	FontMetrics  dFM;
	Graphics     g;
	int          tore;
	Color        mannschaftsfarbe;

	int sizeX  = 90;
	int sizeY  = 80;
	int round  =  8;
	int rahmen = 10;

	// konstruktor
	public toranzeige (SchiriAnlage sa, int tore) {
		// System.out.println("Tore: ");
		this.sa     = sa;
		this.tore   = tore;

		this.setSize(sizeX,sizeY);
		digitalFont = new Font("Helvetica", Font.PLAIN, 60);
		dFM = getFontMetrics(digitalFont);

		// anfnglich Mannschaftsfarbe = Button-Farbe
		mannschaftsfarbe = sa.konfigButton.getBackground();
	}

	/*
	 * Die folgende Methode ist fr die graphische Darstellung der Toranzeige
	 */
	public void paint(Graphics g) {
		super.paint(g);
		String toreString;

		// Digital-Anzeige ...
		g.setColor(mannschaftsfarbe);
		g.fillRoundRect(0,0,sizeX-1,sizeY-1,round-1,round-1);
		g.setColor(Color.white);
		g.fillRect(rahmen,rahmen,sizeX-(2*rahmen),sizeY-(2*rahmen));
		g.setColor(Color.black);  // schwarze Schrift und Rahmen
		g.setFont(digitalFont);
		g.drawRoundRect(0,0,sizeX-1,sizeY-1,round,round);
		g.drawRect(rahmen,rahmen,sizeX-(2*rahmen),sizeY-(2*rahmen));
		toreString = Integer.toString(tore);
		if (sa.torstandMitButton || sa.vollesProtokoll)
			g.drawString(toreString,(sizeX - dFM.stringWidth(toreString))/2, sizeY - 16);
		else {
			g.setColor(Color.lightGray);
			g.drawString("-",(sizeX - dFM.stringWidth("-"))/2, sizeY - 16);
		}
	}

	public void setColor(Color newColor) {
		mannschaftsfarbe = newColor;
		repaint();
	}

	public void setTore(int tore) {
		this.tore = tore;
		repaint();
	}

	public int getTore() {
		return tore;
	}

}

/*
 * Diese Klasse ist fr die Anzeige der Spielzeit-Uhr verantwortlich.
 * Zur Darstellung ist es ein Canvas.
 */
class uwrUhr extends Canvas implements Runnable, blinkable {
	SchiriAnlage sa;
	Font         digitalFont, analogFont;
	FontMetrics  dFM, aFM;
	int          DoppelpunktX, MinutenX, SekundenX;
	int          digitalY;
	Color        fontColor = Color.darkGray;

	int radius = 95;
	int pos15x, pos15y, pos30x, pos30y, pos45x, pos45y, pos60x, pos60y;

	int endeWait = 2;          // x Sekunden noch am Ende warten, dann wieder auf Anfang

	Thread     uhrThread;
	Blinkgeber blinker   = null;
	boolean    isRunning = false;
	boolean    beendet   = false; // damit nicht zweimal beenden() aufgerufen wird
	Date       date      = null;
	long       ms = 0, start_ms = 0, spielzeit_ms = 0;  // in Millisekunden

	int lastxs=0, lastys=0, lastxm=0, lastym=0;
	int xm, ym, xs, ys, xcenter, ycenter;
	int sec=0, min=0, lastSec = 0;
	int spielzeit, restSec, restMin;                 // in Sekunden
	Graphics g;

	public void circle(int x0, int y0, int r, Graphics g) {
		g.drawOval(x0-r,y0-r,2*r,2*r);
	}

	// konstruktor
	public uwrUhr (SchiriAnlage sa, int spielzeit) {
		// System.out.println("Spieluhr: ");
		this.sa = sa;
		this.spielzeit = spielzeit;

		this.setSize(200,300);
		analogFont  = new Font("Helvetica", Font.PLAIN, 12);
		digitalFont = new Font("Helvetica", Font.PLAIN, 60);
		aFM = getFontMetrics(analogFont);
		dFM = getFontMetrics(digitalFont);

		digitalY     = 50  + (dFM.getAscent()    / 2);
		DoppelpunktX = 100 - (dFM.charWidth(':') / 2);
		int w00      = dFM.stringWidth("00");
		MinutenX     = 5 + ((DoppelpunktX - w00) / 2);
		SekundenX    = 200 - w00 - MinutenX;

		this.xcenter = 100;
		this.ycenter = 200;

		pos15x = xcenter + radius - 5 - aFM.stringWidth("15");
		pos15y = ycenter + ( aFM.getAscent()       / 2 );
		pos30x = xcenter - ( aFM.stringWidth("30") / 2 );
		pos30y = ycenter + radius - 5;
		pos45x = xcenter - radius + 5;
		pos45y = pos15y;
		pos60x = xcenter - ( aFM.stringWidth("60") / 2 );
		pos60y = ycenter - radius + 5 + aFM.getAscent();

		xs = xcenter;
		ys = ycenter-75;
		xm = xcenter;
		ym = ycenter-60;

		init();
	}

	public void init() {
		// System.out.println("Spieluhr: init: " + spielzeit_ms );
		ms = 0;
		start_ms = 0;
		spielzeit_ms = 0;
		sec=0;
		min=0;
		lastSec = 0;

		restMin = spielzeit/60;
		restSec = spielzeit%60;
	}

	public void paint(Graphics g) {
		int i, markx, marky;

//		super.paint(g);
		String zeitString;

		// Draw the circle and numbers ...
		g.setColor(Color.darkGray);
		circle(xcenter,ycenter,radius,g);
		g.setFont(analogFont);
		g.drawString("15",pos15x,pos15y);
		g.drawString("30",pos30x,pos30y);
		g.drawString("45",pos45x,pos45y);
		g.drawString("60",pos60x,pos60y);
		for ( i=1; i<60; i++) {
			if ( i%15 != 0 ) {  // jedes Viertel sind die Zahlen, hier keine Markierungen
				markx = (int)(Math.cos(i * 3.14f/30 - 3.14f/2) * (radius-3) + xcenter);
				marky = (int)(Math.sin(i * 3.14f/30 - 3.14f/2) * (radius-3) + ycenter);
				if ( i%5 == 0 )
					g.drawLine(markx,marky,
						   (int)(Math.cos(i * 3.14f/30 - 3.14f/2) * (radius-8) + xcenter),
						   (int)(Math.sin(i * 3.14f/30 - 3.14f/2) * (radius-8) + ycenter));
				else
					g.drawLine(markx,marky,markx,marky); // Punkt
			}
		}

		// Compute and draw the hands ...
		xs = (int)(Math.cos(sec * 3.14f/30 - 3.14f/2) * 80 + xcenter);
		ys = (int)(Math.sin(sec * 3.14f/30 - 3.14f/2) * 80 + ycenter);
		g.setColor(Color.red);
		g.drawLine(xcenter, ycenter, xs, ys);
		xm = (int)(Math.cos(min * 3.14f/30 - 3.14f/2) * 70 + xcenter);
		ym = (int)(Math.sin(min * 3.14f/30 - 3.14f/2) * 70 + ycenter);
		g.setColor(Color.darkGray);
		g.drawLine(xcenter, ycenter-1, xm, ym);
		g.drawLine(xcenter-1, ycenter, xm, ym);

		// Digital-Anzeige ...
		g.setFont(digitalFont);
		g.drawRoundRect(10,10,180,80,20,20);
		g.setColor(fontColor);
		g.drawString(printf02d(restMin),MinutenX,digitalY);
		g.drawString(":",DoppelpunktX,digitalY);
		g.drawString(printf02d(restSec),SekundenX,digitalY);
	}

	private String printf02d(int n) {
		if ( n < 10 ) return '0' + Integer.toString(n);
		else          return Integer.toString(n);
	}

	public String getSpielzeitString() {
		String hzString = (sa.ersteHalbzeit)? " (1)" : " (2)";

		//return printf02d(min) + ":" + printf02d(sec) + " (Rest " + printf02d(restMin) + ":" + printf02d(restSec) + ")";
		return printf02d(restMin) + ":" + printf02d(restSec) + hzString;
	}

	public int getRestMinuten() {
		return restMin;
	}

	public int getRestSekunden() {
		return restSec;
	}

	public void anhalten() {
		isRunning = false;
	}

	/*
	 * Anhupen des Spielleiters fhrt zu dieser Methode
	 * lastStopWasOK = false: die Zeit soll so weiterlaufen als wre nicht gestoppt worden
	 */
	public void beginnenFortsetzen(boolean lastStopWasOK) {
		// System.out.println("Spieluhr: beginnenFortsetzen: " + spielzeit_ms );
		date         = new Date();

		if(uhrThread == null) {                  // Spielbeginn
			start_ms     = date.getTime();
			spielzeit_ms = 0;
			uhrThread    = new Thread(this);
			uhrThread.start();
		}
		else {                                  // Anhupen nach Foul oder Tor
			if ( ! sa.durchlaufendeZeit &&  // nur bei nicht durchlaufender Zeit
			     lastStopWasOK) {           // wenn der letzte Stopp nicht ok war, mit alter Startzeit
				start_ms     = date.getTime() - spielzeit_ms;
			}
		}

		isRunning    = true;
		beendet      = false;
	}

	public void beenden(boolean spielzeitende) {
		// System.out.println("Spieluhr: beenden: " + spielzeitende);
		beendet = true;

		anhalten();

		// noch warten, wenn was luft ...
		// Schiri-Signal-Verfolgung noch vorhanden?
		while ( sa.ssv != null ) {
			try {Thread.sleep(100);} catch (InterruptedException e){}
		}

		// warten wenn noch ein Strafwurf luft ...
		while ( sa.strafwurfRechts.isActivated || sa.strafwurfLinks.isActivated ) {
			try {Thread.sleep(200);} catch (InterruptedException e){}
		}

		// Beenden der Starfzeiten, falls vorhanden
		sa.setSpielEnde();

		// der Thread wird beendet
		uhrThread = null;

		if ( blinker != null ) blinker.beenden();
		blinker = null;

		if (spielzeitende) { // also kein Stopp ber Button, sondern regulr Spielzeit beendet
			date = new Date();

			// alle Schiris sperren ...
			sa.schiriSperre(sa.uwSchiri1,true,sa.uwSchiri2,true,sa.spielleiter,true);

			// Spielende hupen ...
			sa.abhupen();

			// nach dem Hupen wieder alle Schiris sperren ...
			sa.schiriSperre(sa.uwSchiri1,true,sa.uwSchiri2,true,sa.spielleiter,true);

			if ( sa.ersteHalbzeit ) {
				sa.print_meldung(sa.getTextLabel("firstEnd"), true);
				sa.aktuellesProtokoll.newProtokollEntry(protokoll.HALBZEITPAUSE, null);
				sa.ersteHalbzeit = false;
				// die Halbzeituhr starten ...
				sa.halbzeitpausenUhr = new halbzeitpauseFenster (sa.halbzeitpause, sa);
			}
			else {
				sa.print_meldung( sa.getTextLabel("matchEnd"), true);
				sa.protocolClose();                // Protokoll-Datei schliessen
				sa.ersteHalbzeit = true;
			}

			// ein bisschen warten bis wieder alles auf Anfang gestellt wird ...
			try {Thread.sleep(endeWait * 1000);} catch (InterruptedException e){}
		}
		else
			sa.protocolClose();                        // Protokoll-Datei schliessen

		if(uhrThread == null) { // ist immer noch null? wer weiss, vielleicht ist wieder angehupt ...
			init();
			repaint();
			sa.setActivated(false);
			sa.abgehupt  = true;             // fr die Schirisignalverfolgung: true -> warten auf anhupen
		}
	}

	/*
	 * Die folgende Methode bildet das blinkable-Interface
	 */
	public void blink (boolean onOff) {
		if ( onOff ) {
			fontColor = Color.red;       // Schrift rot
		}
		else {
			fontColor = Color.darkGray;  // Schrift in alter Farbe
		}
		repaint();
	}

	public void run() {
		while (uhrThread != null) {
			try {Thread.sleep(100);} catch (InterruptedException e){}
			if ( isRunning ) {
				lastSec = sec;
				date         = new Date();
				ms           = date.getTime();
				spielzeit_ms = ms - start_ms;
				// Setzen der Uhrzeit ...
				sec          = (int)(spielzeit_ms/1000);
				if ( sec > spielzeit )
					sec  = spielzeit;
				restSec = spielzeit - sec;
				if ( restSec <= 10 && blinker == null) {   // Blinken
					blinker = new Blinkgeber(500, 500, this);
				}

				// Zeit schon zu Ende ?
				if ( restSec <= 0 ) {
					uhrThread = null;
				}
				min      = sec/60;
				restMin  = restSec/60;
				sec     %= 60;
				restSec %= 60;
				if ( lastSec != sec ) repaint();
			}
		}
		if ( ! beendet ) // wenn schon durch "Stopp" beendet, dann nicht noch einmal hier mit Hupen
			beenden(true);
	}
}


/*
 * Diese Klasse ist fr die Zeitberwachung einer Stoppuhr oder Auszeit.
 */
class halbzeitpauseFenster extends Frame implements zeitEnde, ActionListener, WindowListener, KeyListener {
	SchiriAnlage      sa;
	Button            spielendeButton, weiterSpielenButton;
	Button            minutenPlusButton, minutenMinusButton, sekundenPlusButton, sekundenMinusButton;
	Checkbox          automatischerSeitenwechsel, aktivierenNachPause;
	ablaufzeitCanvas  ablaufZC = null;
	Point             ownerObenLinks;
	Dimension         ownerSize, thisSize;

	public halbzeitpauseFenster (int ablaufZeit, SchiriAnlage sa) {
		this.sa = sa;
		this.setTitle(sa.getTextLabel("halfTimeInt"));
		this.setLayout(new BorderLayout(15,15));

		this.addWindowListener(this);

		// Uhr ...
		Panel uhrRahmenPanel = new Panel(new FlowLayout(FlowLayout.CENTER,15,15)); // ein bisschen Abstand
		this.add("North", uhrRahmenPanel);
		Panel uhrPanel = new Panel(new BorderLayout(0,0));                         // hier kommt Uhr und +/- Buttons hinein
		uhrRahmenPanel.add(uhrPanel);
		   // About ...
		Panel aboutPanel = new Panel(new FlowLayout(FlowLayout.CENTER,0,0));
		uhrPanel.add("North", aboutPanel);
		Label aboutLabel = new Label(sa.getTextLabel("halfTimeInt"));
		aboutLabel.setFont(sa.InfoLabelFont);
		aboutPanel.add(aboutLabel);
		   // Ablaufzeit-Canvas
		ablaufZC = new ablaufzeitCanvas(ablaufZeit, sa, this);
		ablaufZC.laufrunter  = true;
		ablaufZC.startatonce = true;
		ablaufZC.init();
		uhrPanel.add("Center",ablaufZC);
		Panel plusMinusPanel = new Panel();
		minutenPlusButton = new Button("+");
		minutenMinusButton = new Button("-");
		sekundenPlusButton = new Button("+");
		sekundenMinusButton = new Button("-");
		plusMinusPanel.add(minutenPlusButton);
		plusMinusPanel.add(minutenMinusButton);
		plusMinusPanel.add(new Label("        "));
		plusMinusPanel.add(sekundenPlusButton);
		plusMinusPanel.add(sekundenMinusButton);
		uhrPanel.add("South", plusMinusPanel);

		// Uhr luft rauf oder runter? ...
		Panel checkboxPanel = new Panel(new GridLayout(2,1,0,5));                  // Checkboxes ...
		Panel checkboxRahmenPanel = new Panel();
		this.add("Center", checkboxRahmenPanel);
		checkboxRahmenPanel.add( checkboxPanel);
		automatischerSeitenwechsel = new Checkbox(sa.getTextLabel("autoSwitch"), true);
		aktivierenNachPause        = new Checkbox(sa.getTextLabel("autoActivate"), true);
		checkboxPanel.add(automatischerSeitenwechsel);
		checkboxPanel.add(aktivierenNachPause);

		// Buttons ...
		Panel buttonPanel = new Panel(new FlowLayout(FlowLayout.CENTER,15,15));    // Buttons ...
		this.add("South", buttonPanel);
		spielendeButton     = new Button(sa.getTextLabel("terminateMatch"));
		weiterSpielenButton = new Button(sa.getTextLabel("resumeMatch"));
		buttonPanel.add(spielendeButton);
		buttonPanel.add(weiterSpielenButton);

		spielendeButton.addActionListener(this);   // Mouse-Eingaben
		weiterSpielenButton.addActionListener(this);
		minutenPlusButton.addActionListener(this);
		minutenMinusButton.addActionListener(this);
		sekundenPlusButton.addActionListener(this);
		sekundenMinusButton.addActionListener(this);
		spielendeButton.addKeyListener(this);      // Tastatur-Eingaben
		weiterSpielenButton.addKeyListener(this);
		minutenPlusButton.addKeyListener(this);
		minutenMinusButton.addKeyListener(this);
		sekundenPlusButton.addKeyListener(this);
		sekundenMinusButton.addKeyListener(this);

		this.pack();

		// Wohin ...
		ownerObenLinks = sa.programmFenster.getLocation();
		ownerSize      = new Dimension();
		ownerSize      = sa.programmFenster.getSize(ownerSize);
		thisSize       = new Dimension();
		thisSize       = this.getSize(thisSize);
		setLocation(ownerObenLinks.x + ((ownerSize.width  - thisSize.width ) / 2) ,
			    ownerObenLinks.y + ((ownerSize.height - thisSize.height) / 2) - 160);

		this.show();

		// und sofort beginnen ...
		ablaufZC.beginnenFortsetzen();
	}

	/*
	 * Die folgende Methode bildet das zeitEnde-Interface und
	 * wird am Ende der Ablaufzeit aufgerufen.
	 */
	public void zeitEndeAction () {
		sa.print_meldung( sa.getTextLabel("halfTimeIntEnd"), true );
		if ( automatischerSeitenwechsel.getState() )
			sa.seitenwechsel();

		// Kurz nach dem Beginn der Halbzeitpause ist "sa.activated" noch true.
		// Deshalb warten bis sich der uhrThread (uwrUhr) beendet hat (Methode beenden() )
		// und damit ber "sa.setActivated(false)" sa.activated auf false steht.
		while ( sa.activated ) try {Thread.sleep(100);} catch (InterruptedException e){}

		if ( aktivierenNachPause.getState() && ! sa.activated ) {
			sa.startStoppSpiel();
		}
	}

	/*
	 * Die folgenden Methoden bilden das WindowListener-Interface und
	 * beantworten ersteinmal das Anklicken des Windows-Schliessens.
	 */
	public void windowClosing(WindowEvent e) {
		ablaufZC.beenden(false, true);  // false: Zeit noch nicht zu Ende; true: this.zeitEndeAction() wird ausgefhrt.
	}
	public void windowActivated(WindowEvent e)   { }
	public void windowClosed(WindowEvent e)      { }
	public void windowDeactivated(WindowEvent e) { }
	public void windowDeiconified(WindowEvent e) { }
	public void windowIconified(WindowEvent e)   { }
	public void windowOpened(WindowEvent e)      { }

	/*
	 * Die folgende Methode bildet das ActionListener-Interface und
	 * beantworten das Anklicken der Buttons.
	 */
	public void actionPerformed(ActionEvent e) {
		// if ( debug ) System.out.println(e.getActionCommand());
		if ( ! ( e.getSource() instanceof Button ) ) {
			return;
		}
		Button target = (Button) e.getSource();        // MOUSE CLICK auf Button ...
		buttonAction(target);
	}

	/*
	 * Die folgenden Methoden bilden das KeyListener-Interface und
	 * beantworten Tastatureingaben.
	 */
	public void keyPressed(KeyEvent e) {
		int key = e.getKeyCode();
		if ( key != KeyEvent.VK_ENTER )
			return;
		if ( ! ( e.getSource() instanceof Button ) ) {
			return;
		}
		Button target = (Button) e.getSource();        // Tastatur-Eigabe ...
		buttonAction(target);
	}
	public void keyReleased(KeyEvent e)  { }
	public void keyTyped(KeyEvent e)     { }

	/*
	 * Die folgenden Methoden ist wird gemeinsam von actionPerformed und keyPressed genutzt.
	 */
	public void buttonAction(Button target) {
		if (target == spielendeButton) {
			sa.stoppSpielFragen();
		}
		else if (target == weiterSpielenButton) {
			ablaufZC.beenden(false, true);  // false: Zeit noch nicht zu Ende; true: this.zeitEndeAction() wird ausgefhrt.
		}
		else if (target == minutenPlusButton) {
			ablaufZC.addTime(60);
		}
		else if (target == minutenMinusButton) {
			ablaufZC.addTime(-60);
		}
		else if (target == sekundenPlusButton) {
			ablaufZC.addTime(1);
		}
		else if (target == sekundenMinusButton) {
			ablaufZC.addTime(-1);
		}
	}
}


/*
 * Diese Klasse ist fr die Zeitberwachung einer Stoppuhr oder Auszeit.
 */
class ablaufzeitFenster extends Frame implements ActionListener, WindowListener, KeyListener, ItemListener {
	SchiriAnlage      sa;
	Button            startButton, stoppButton, cancelButton;
	Button            minutenPlusButton, minutenMinusButton, sekundenPlusButton, sekundenMinusButton;
	CheckboxGroup     raufRunterCheckboxgroup;
	Checkbox          rauf, runter;
	ablaufzeitCanvas  ablaufZC = null;
	Point             ownerObenLinks;
	Dimension         ownerSize, thisSize;

	public ablaufzeitFenster (int ablaufZeit, String title, String label,
				  int xShift, boolean laufrunter, boolean startatonce, SchiriAnlage sa) {
		this.sa = sa;
		this.setTitle(title);
		this.setLayout(new BorderLayout(15,15));

		this.addWindowListener(this);

		// Uhr ...
		Panel uhrRahmenPanel = new Panel(new FlowLayout(FlowLayout.CENTER,15,15)); // ein bisschen Abstand
		this.add("North", uhrRahmenPanel);
		Panel uhrPanel = new Panel(new BorderLayout(0,0));                         // hier kommt Uhr und +/- Buttons hinein
		uhrRahmenPanel.add(uhrPanel);
		   // About ...
		Panel aboutPanel = new Panel(new FlowLayout(FlowLayout.CENTER,0,0));
		uhrPanel.add("North", aboutPanel);
		Label aboutLabel = new Label(label);
		aboutLabel.setFont(sa.InfoLabelFont);
		aboutPanel.add(aboutLabel);
		   // Ablaufzeit-Canvas
		ablaufZC = new ablaufzeitCanvas(ablaufZeit, sa, this);
		ablaufZC.laufrunter  = laufrunter;
		ablaufZC.startatonce = startatonce;
		ablaufZC.init();
		uhrPanel.add("Center",ablaufZC);
		Panel plusMinusPanel = new Panel();
		minutenPlusButton = new Button("+");
		minutenMinusButton = new Button("-");
		sekundenPlusButton = new Button("+");
		sekundenMinusButton = new Button("-");
		plusMinusPanel.add(minutenPlusButton);
		plusMinusPanel.add(minutenMinusButton);
		plusMinusPanel.add(new Label("        "));
		plusMinusPanel.add(sekundenPlusButton);
		plusMinusPanel.add(sekundenMinusButton);
		uhrPanel.add("South", plusMinusPanel);

		// Uhr luft rauf oder runter? ...
		Panel raufRunterRahmenPanel = new Panel(new FlowLayout(FlowLayout.CENTER,60,0));  // Rauf oder runter ...
		Panel raufRunterPanel = new Panel(new GridLayout(1,2));
		this.add("Center", raufRunterRahmenPanel);
		raufRunterRahmenPanel.add("Center", raufRunterPanel);
		raufRunterCheckboxgroup = new CheckboxGroup();
		rauf   = new Checkbox(sa.getTextLabel("timeUp"), raufRunterCheckboxgroup, false);
		runter = new Checkbox(sa.getTextLabel("timeDown"), raufRunterCheckboxgroup, false);
		rauf.addItemListener(this);
		runter.addItemListener(this);
		raufRunterPanel.add(rauf);
		raufRunterPanel.add(runter);
		if ( laufrunter ) raufRunterCheckboxgroup.setSelectedCheckbox(runter);
		else              raufRunterCheckboxgroup.setSelectedCheckbox(rauf);


		// Buttons ...
		Panel buttonPanel = new Panel(new FlowLayout(FlowLayout.CENTER,15,15));         // Buttons
		this.add("South", buttonPanel);
		startButton = new Button("  " + sa.getTextLabel("start") + "  ");
		stoppButton = new Button("   " + sa.getTextLabel("stop") + "  ");
		cancelButton = new Button(sa.getTextLabel("close"));
		buttonPanel.add(startButton);
		buttonPanel.add(stoppButton);
		buttonPanel.add(cancelButton);

		startButton.addActionListener(this);   // Mouse-Eingaben
		stoppButton.addActionListener(this);
		cancelButton.addActionListener(this);
		minutenPlusButton.addActionListener(this);
		minutenMinusButton.addActionListener(this);
		sekundenPlusButton.addActionListener(this);
		sekundenMinusButton.addActionListener(this);
		startButton.addKeyListener(this);      // Tastatur-Eingaben
		stoppButton.addKeyListener(this);
		cancelButton.addKeyListener(this);
		minutenPlusButton.addKeyListener(this);
		minutenMinusButton.addKeyListener(this);
		sekundenPlusButton.addKeyListener(this);
		sekundenMinusButton.addKeyListener(this);

		this.pack();

		// Wohin ...
		ownerObenLinks = sa.programmFenster.getLocation();
		ownerSize      = new Dimension();
		ownerSize      = sa.programmFenster.getSize(ownerSize);
		thisSize       = new Dimension();
		thisSize       = this.getSize(thisSize);
		setLocation(ownerObenLinks.x + ((ownerSize.width  - thisSize.width ) / 2) + xShift,
			    ownerObenLinks.y + ((ownerSize.height - thisSize.height) / 2) - 160);

		this.show();

		// und sofort beginnen ...
		if ( startatonce )
			ablaufZC.beginnenFortsetzen();
	}

	/*
	 * Die folgende Methode bildet das ItemListener-Interface und
	 * beantworten das Auswaehlen von der Laufrichtung der Zeit (rauf oder runter).
	 */
	public void itemStateChanged(ItemEvent e) {
		// System.out.println("ListenElement, e.getItem() = " + e.getItem());
		if ( ! ( e.getSource() instanceof Checkbox ) ) {
			return;
		}
		Checkbox target = (Checkbox) e.getSource();

		if ( target == rauf ) {
			ablaufZC.setZeitrichtung(false);
		}
		else if ( target == runter ) {
			ablaufZC.setZeitrichtung(true);
		}
	}

	/*
	 * Die folgenden Methoden bilden das WindowListener-Interface und
	 * beantworten ersteinmal das Anklicken des Windows-Schliessens.
	 */
	public void windowClosing(WindowEvent e) {
		ablaufZC.beenden(false, true);      // false: Zeit noch nicht zu Ende; true: keine Auswirkung, da nicht zeitEnde.
		this.dispose();                     // Halbzeitpause-Fenster entfernen.
	}
	public void windowActivated(WindowEvent e)   { }
	public void windowClosed(WindowEvent e)      { }
	public void windowDeactivated(WindowEvent e) { }
	public void windowDeiconified(WindowEvent e) { }
	public void windowIconified(WindowEvent e)   { }
	public void windowOpened(WindowEvent e)      { }

	/*
	 * Die folgende Methode bildet das ActionListener-Interface und
	 * beantworten das Anklicken der Buttons.
	 */
	public void actionPerformed(ActionEvent e) {
		// if ( debug ) System.out.println(e.getActionCommand());
		if ( ! ( e.getSource() instanceof Button ) ) {
			return;
		}
		Button target = (Button) e.getSource();  // MOUSE CLICK auf Button ...
		if (target == cancelButton) {
			ablaufZC.beenden(false, false);  // false: Zeit noch nicht zu Ende; false: keine Auswirkung, da nicht zeitEnde.
			this.dispose();                  // Halbzeitpause-Fenster entfernen.
		}
		else if (target == startButton) {
			ablaufZC.beginnenFortsetzen();
		}
		else if (target == stoppButton) {
			ablaufZC.anhalten();
		}
		else if (target == minutenPlusButton) {
			ablaufZC.addTime(60);
		}
		else if (target == minutenMinusButton) {
			ablaufZC.addTime(-60);
		}
		else if (target == sekundenPlusButton) {
			ablaufZC.addTime(1);
		}
		else if (target == sekundenMinusButton) {
			ablaufZC.addTime(-1);
		}
	}

	/*
	 * Die folgenden Methoden bilden das KeyListener-Interface und
	 * beantworten Tastatureingaben.
	 */
	public void keyPressed(KeyEvent e) {
		int key = e.getKeyCode();
		if ( key != KeyEvent.VK_ENTER )
			return;
		if ( ! ( e.getSource() instanceof Button ) ) {
			return;
		}
		Button target = (Button) e.getSource();  // Tastatur-Eigabe ...
		if (target == cancelButton) {
			ablaufZC.beenden(false, false);  // false: Zeit noch nicht zu Ende; false: keine Auswirkung, da nicht zeitEnde.
			this.dispose();                  // Halbzeitpause-Fenster entfernen.
		}
		else if (target == startButton) {
			ablaufZC.beginnenFortsetzen();
		}
		else if (target == stoppButton) {
			ablaufZC.anhalten();
		}
		else if (target == minutenPlusButton) {
			ablaufZC.addTime(60);
		}
		else if (target == minutenMinusButton) {
			ablaufZC.addTime(-60);
		}
		else if (target == sekundenPlusButton) {
			ablaufZC.addTime(1);
		}
		else if (target == sekundenMinusButton) {
			ablaufZC.addTime(-1);
		}
	}
	public void keyReleased(KeyEvent e)  { }
	public void keyTyped(KeyEvent e)     { }
}


/*
 * Diese Klasse ist fr die Anzeige der Halbzeitpausezeit-Uhr und der Auszeit-Uhr verantwortlich.
 * Zur Darstellung ist es ein Panel.
 */
class ablaufzeitCanvas extends Canvas implements Runnable, blinkable {
	SchiriAnlage sa;
	Frame    fenster;
	Font digitalFont;
	FontMetrics dFM;
	int DoppelpunktX, MinutenX, SekundenX;
	int digitalY;
	Color fontColor = Color.darkGray;

	boolean beendet   = false; // damit nicht zweimal beenden() aufgerufen wird
	boolean isRunning = false; // true, wenn die Zeit luft
	boolean startatonce;       // Startet sofort bei Erscheinen des Fensters und verschwindet von alleine
	boolean laufrunter;        // true = Zeit luft ab;     false = Zeit nimmt zu

	Thread     ablaufzeitCanvasThread;
	Blinkgeber blinker  = null;

	Date    date = null;
	long    aktuelle_ms = 0, anzeige_ms;  // in Millisekunden

	int lastxs = 0, lastys = 0, lastxm = 0, lastym = 0;
	int lastSec = 0;
	int anzeigeSec, anzeigeMin;
	int ablaufGesamtzeit;

	// konstruktor
	public ablaufzeitCanvas (int ablaufGesamtzeit, SchiriAnlage sa, Frame fenster) {
		this.sa = sa;
		this.fenster = fenster;
		this.ablaufGesamtzeit = ablaufGesamtzeit;

		this.setSize(200,100);
		digitalFont = new Font("Helvetica", Font.PLAIN, 60);
		dFM = getFontMetrics(digitalFont);

		digitalY     = 50  + (dFM.getAscent()    / 2);
		DoppelpunktX = 100 - (dFM.charWidth(':') / 2);
		int w00      = dFM.stringWidth("00");
		MinutenX     = 5 + ((DoppelpunktX - w00) / 2);
		SekundenX    = 200 - w00 - MinutenX;
	}

	public void init() {
		if ( laufrunter ) {
			anzeige_ms = ( (long) ablaufGesamtzeit ) * 1000;
			anzeigeMin = ablaufGesamtzeit/60;
			anzeigeSec = ablaufGesamtzeit%60;
		}
		else {
			anzeige_ms = 0;
			anzeigeMin = 0;
			anzeigeSec = 0;
		}
	}

	public void addTime(int seconds) {
		// System.out.println( "addTime: " + seconds);
		anzeige_ms += ( (long) seconds ) * 1000;
		anzeigeSec  = (int)(anzeige_ms/1000);
		anzeigeMin  = anzeigeSec/60;
		anzeigeSec %= 60;
		repaint();
	}

	public void setZeitrichtung(boolean isRunter) {
		// System.out.println( "setZeitrichtung: " + laufrunter);
		if ( ( isRunter && laufrunter ) || ( ( ! isRunter ) && ( ! laufrunter ) ) )
			return;
		laufrunter = isRunter;
		if ( blinker != null && ! laufrunter ) {
			blinker.beenden();
			blinker = null;
		}
		repaint();
	}

	public void paint(Graphics g) {
		int i, markx, marky;
		String zeitString;

		// Digital-Anzeige ...
		g.setColor(Color.darkGray);
		g.setFont(digitalFont);
		g.drawRoundRect(10,10,180,80,20,20);
		g.setColor(fontColor);
		g.drawString(printf02d(anzeigeMin),MinutenX,digitalY);
		g.drawString(":",DoppelpunktX,digitalY);
		g.drawString(printf02d(anzeigeSec),SekundenX,digitalY);
	}

	private String printf02d(int n) {
		if ( n < 10 ) return '0' + Integer.toString(n);
		else          return Integer.toString(n);
	}

	public void anhalten() {
		// System.out.println("ablaufzeitCanvas: anhalten: "  );
		isRunning = false;
	}

	/*
	 * Klicken auf den entsprechenden Button fhrt zu dieser Methode
	 */
	public void beginnenFortsetzen() {
		if ( isRunning )     // luft ja schon ...
			return;

		// fr die Zeitdifferenz in run()
		date         = new Date();
		aktuelle_ms  = date.getTime();

		if(ablaufzeitCanvasThread == null) {
			ablaufzeitCanvasThread    = new Thread(this);
			ablaufzeitCanvasThread.start();
		}

		isRunning = true;
	}

	/*
	 * Diese Ablaufzeit beenden.
	 * ablaufzeitende: Ende der Zeit oder vorzeitig abgebrochen.
	 * zeitEndeAktion: Wenn das Fenster das Interface zeitEnde implementiert hat,
	 *                 und dieser Wert true, wird dessen zeitEndeAction() ausgefhrt.
	 */
	public void beenden(boolean ablaufzeitende, boolean zeitEndeAktion) {
		// System.out.println("ablaufzeitCanvas: beenden: " );
		beendet = true;

		// der Blinker wird beendet ...
		if ( blinker != null ) blinker.beenden();
		blinker = null;

		sa.makeBeep();

		// Ablaufzeit-Ende ...
		if ( zeitEndeAktion && fenster instanceof zeitEnde  ) {
			zeitEnde zEF = (zeitEnde) fenster;
			zEF.zeitEndeAction();
		}

		// der Thread wird beendet
		ablaufzeitCanvasThread = null;

		if ( ablaufzeitende )  // bei regulrem Ende, eine Sekunde noch anzeigen ...
			try {Thread.sleep(1000);} catch (InterruptedException e){}

		fenster.dispose();
	}

	/*
	 * Die folgende Methode bildet das blinkable-Interface
	 */
	public void blink (boolean onOff) {
		if ( onOff ) {
			fontColor = Color.red;       // Schrift grn
		}
		else {
			fontColor = Color.darkGray;  // Schrift in alter Farbe
		}
		repaint();
	}

	public void run() {
		long last_ms;
		// System.out.println("ablaufzeitCanvas: run: " + s + blinker );
		while (ablaufzeitCanvasThread != null) {
			if ( isRunning )  {
				lastSec = anzeigeSec;            // merken: alter Sekundenanteil ohne die Minuten
				last_ms = aktuelle_ms;           // merken
				date         = new Date();
				aktuelle_ms  = date.getTime();
				if ( laufrunter ) {              // ablaufende Zeit
					anzeige_ms -= aktuelle_ms - last_ms;
					if ( anzeige_ms < 0 )
						anzeige_ms = 0;
					anzeigeSec = (int)(anzeige_ms/1000);
					if ( anzeigeSec <= 10 && blinker == null) {   // Blinken
						blinker = new Blinkgeber(400, 400, this);
					}
					// Schon zu Ende ?
					if ( anzeigeSec == 0 ) {
						anhalten();
						if ( blinker != null ) blinker.beenden();
						blinker = null;
						if ( startatonce )
							ablaufzeitCanvasThread = null;
					}
				}
				else {                           // steigende Zeit
					anzeige_ms += aktuelle_ms - last_ms;
					anzeigeSec  = (int)(anzeige_ms/1000);
				}

				// anzeigeSec aufteilen in min und sec
				anzeigeMin  = anzeigeSec/60;
				anzeigeSec %= 60;
				if ( lastSec != anzeigeSec ) repaint();         // nur repaint bei neuer Zeit
			}
			try {Thread.sleep(100);} catch (InterruptedException e){}
		}
		if ( ! beendet )              // wenn schon durch "Stopp" beendet, dann nicht noch einmal
			beenden(true, true);  // true: Zeit zu Ende; true: zeitEndeAction() ausfhren, wenn Interface vorhanden.
	}
}

/*
 * Diese Klasse ist fr die Konfiguration der Parameter.
 */
class schiriConfig extends Frame implements ActionListener, WindowListener, KeyListener {
	SchiriAnlage  sa;
	CheckboxGroup simulationCheckboxgroup;
	Checkbox      simTrue, simFalse;
	CheckboxGroup durchlaufendeZeitCheckboxgroup;
	Checkbox      durchlaufendeZeitTrue, durchlaufendeZeitFalse;
	CheckboxGroup vollesProtokollCheckboxgroup;
	Checkbox      vollesProtokollTrue, vollesProtokollFalse;
	Choice        uw1, uw2, sl;
	Button        setButton, cancelButton;
	TextField     spielzeitTextfeld, strafzeitTextfeld, strafwurfzeitTextfeld, halbzeitpauseTextfeld, auszeitTextfeld, kurzLangSchwelleTextfeld;

	int           spielzeit;
	int           strafzeit;
	int           strafwurfzeit;
	int           halbzeitpause;
	int           auszeit;
	boolean       schiriSimulation, durchlaufendeZeit, vollesProtokoll;
	int           statusBitUw1;         // UWR-Schiedsrichter am Status-Eingang (mglich 3-7)
	int           statusBitUw2;
	int           statusBitSL;
	long          schiriSignalKurzLangSchwelle;
	Point         ownerObenLinks;
	Dimension     ownerSize, thisSize;

	public schiriConfig (SchiriAnlage sa) {
		this.sa = sa;
		this.setTitle(sa.getTextLabel("configTitle"));
		this.setLayout(new BorderLayout(15,15));

		this.addWindowListener(this);

		// About ...
		Panel aboutPanel = new Panel(new FlowLayout(FlowLayout.CENTER,5,5));
		this.add("North", aboutPanel);
		aboutPanel.add(new Label(sa.getTextLabel("programName") + ", Copyright Ulrich Wller, 2003-" + SchiriAnlage.VersionDate[2]));

		// Parameter-Tabelle ...
		Panel parameterPanel = new Panel(new GridLayout(12,2,10,10));  // 12 Zeilen, 2 Spalten
		this.add("Center", parameterPanel);

		// Spielzeit eintragen ...
		Panel spielzeitLabelPanel = new Panel(new BorderLayout());
		spielzeitLabelPanel.add("East", new Label (sa.getTextLabel("playtime") + ":"));
		parameterPanel.add(spielzeitLabelPanel);                                      // (1,1)
		Panel spielzeitPanel = new Panel(new GridLayout(1,2));
		spielzeitTextfeld    = new TextField (5);
		spielzeitPanel.add(spielzeitTextfeld);
		spielzeitPanel.add(new Label("s"));
		parameterPanel.add(spielzeitPanel);                                           // (1,2)

		// Strafzeit eintragen ...
		Panel strafzeitLabelPanel = new Panel(new BorderLayout());
		strafzeitLabelPanel.add("East", new Label (sa.getTextLabel("penaltyTime") + ":"));
		parameterPanel.add(strafzeitLabelPanel);                                      // (2,1)
		Panel strafzeitPanel = new Panel(new GridLayout(1,2));
		strafzeitTextfeld    = new TextField (5);
		strafzeitPanel.add(strafzeitTextfeld);
		strafzeitPanel.add(new Label("s"));
		parameterPanel.add(strafzeitPanel);                                           // (2,2)

		// Strafwurfzeit eintragen ...
		Panel strafwurfzeitLabelPanel = new Panel(new BorderLayout());
		strafwurfzeitLabelPanel.add("East", new Label (sa.getTextLabel("penaltyThrowTime") + ":"));
		parameterPanel.add(strafwurfzeitLabelPanel);                                  // (3,1)
		Panel strafwurfzeitPanel = new Panel(new GridLayout(1,2));
		strafwurfzeitTextfeld    = new TextField (5);
		strafwurfzeitPanel.add(strafwurfzeitTextfeld);
		strafwurfzeitPanel.add(new Label("s"));
		parameterPanel.add(strafwurfzeitPanel);                                       // (3,2)

		// Halbzeitpause eintragen ...
		Panel halbzeitpauseLabelPanel = new Panel(new BorderLayout());
		halbzeitpauseLabelPanel.add("East", new Label (sa.getTextLabel("halfTimeInterval") + ":"));
		parameterPanel.add(halbzeitpauseLabelPanel);                                  // (4,1)
		Panel halbzeitpausePanel = new Panel(new GridLayout(1,2));
		halbzeitpauseTextfeld    = new TextField (5);
		halbzeitpausePanel.add(halbzeitpauseTextfeld);
		halbzeitpausePanel.add(new Label("s"));
		parameterPanel.add(halbzeitpausePanel);                                       // (4,2)

		// Auszeit eintragen ...
		Panel auszeitLabelPanel = new Panel(new BorderLayout());
		auszeitLabelPanel.add("East", new Label (sa.getTextLabel("timeOut") + ":"));
		parameterPanel.add(auszeitLabelPanel);                                        // (5,1)
		Panel auszeitPanel = new Panel(new GridLayout(1,2));
		auszeitTextfeld    = new TextField (5);
		auszeitPanel.add(auszeitTextfeld);
		auszeitPanel.add(new Label("s"));
		parameterPanel.add(auszeitPanel);                                             // (5,2)

		// erweitertes Protokoll ?
		Panel vollesProtokollLabelPanel = new Panel(new BorderLayout());
		vollesProtokollLabelPanel.add("East", new Label (sa.getTextLabel("fullProtocol") + ":"));
		parameterPanel.add(vollesProtokollLabelPanel);                                // (6,1)
		Panel vollesProtokollPanel = new Panel(new GridLayout(1,2));
		vollesProtokollCheckboxgroup = new CheckboxGroup();
		vollesProtokollTrue  = new Checkbox(sa.getTextLabel("yes"), vollesProtokollCheckboxgroup, false);
		vollesProtokollFalse = new Checkbox(sa.getTextLabel("no"), vollesProtokollCheckboxgroup, false);
		vollesProtokollPanel.add(vollesProtokollTrue);
		vollesProtokollPanel.add(vollesProtokollFalse);
		parameterPanel.add(vollesProtokollPanel);                                     // (6,2)


		// durchlaufende Zeit ?
		Panel durchlaufendeZeitLabelPanel = new Panel(new BorderLayout());
		durchlaufendeZeitLabelPanel.add("East", new Label (sa.getTextLabel("continuousClock") + ":"));
		parameterPanel.add(durchlaufendeZeitLabelPanel);                              // (7,1)
		Panel durchlaufendeZeitPanel = new Panel(new GridLayout(1,2));
		durchlaufendeZeitCheckboxgroup = new CheckboxGroup();
		durchlaufendeZeitTrue  = new Checkbox(sa.getTextLabel("yes"), durchlaufendeZeitCheckboxgroup, false);
		durchlaufendeZeitFalse = new Checkbox(sa.getTextLabel("no"), durchlaufendeZeitCheckboxgroup, false);
		durchlaufendeZeitPanel.add(durchlaufendeZeitTrue);
		durchlaufendeZeitPanel.add(durchlaufendeZeitFalse);
		parameterPanel.add(durchlaufendeZeitPanel);                                   // (7,2)

		// Simulation erlaubt ?
		Panel schiriSimulationsLabelPanel = new Panel(new BorderLayout());
		schiriSimulationsLabelPanel.add("East", new Label (sa.getTextLabel("refereeSim") + ":"));
		parameterPanel.add(schiriSimulationsLabelPanel);                              // (8,1)
		Panel schiriSimulationsPanel = new Panel(new GridLayout(1,2));
		simulationCheckboxgroup = new CheckboxGroup();
		simTrue  = new Checkbox(sa.getTextLabel("on"), simulationCheckboxgroup, false);
		simFalse = new Checkbox(sa.getTextLabel("off"), simulationCheckboxgroup, false);
		schiriSimulationsPanel.add(simTrue);
		schiriSimulationsPanel.add(simFalse);
		parameterPanel.add(schiriSimulationsPanel);                                   // (8,2)

		// Anschluss der Schiri-Signalgeber ...
		Panel schiriSignalgeberLabelPanel = new Panel(new BorderLayout());
		schiriSignalgeberLabelPanel.add("East", new Label (sa.getTextLabel("signalConnection") + ":"));
		parameterPanel.add(schiriSignalgeberLabelPanel);                              // (9,1)
		Panel schiri1SignalgeberPanel = new Panel(new GridLayout(1,2));
		uw1 = new Choice();
		uw1.add("3");
		uw1.add("4");
		uw1.add("5");
		uw1.add("6");
		uw1.add("7");
		schiri1SignalgeberPanel.add(new Label(sa.getTextLabel("refereeShort") + " 1"));
		schiri1SignalgeberPanel.add(uw1);
		parameterPanel.add(schiri1SignalgeberPanel);                                  // (9,2)

		parameterPanel.add(new Panel());                                              // (10,1)
		Panel schiri2SignalgeberPanel = new Panel(new GridLayout(1,2));
		uw2 = new Choice();
		uw2.add("3");
		uw2.add("4");
		uw2.add("5");
		uw2.add("6");
		uw2.add("7");
		schiri2SignalgeberPanel.add(new Label(sa.getTextLabel("refereeShort") + " 2"));
		schiri2SignalgeberPanel.add(uw2);
		parameterPanel.add(schiri2SignalgeberPanel);                                  // (10,2)

		parameterPanel.add(new Panel());                                              // (11,1)
		Panel schiri3SignalgeberPanel = new Panel(new GridLayout(1,2));
		sl  = new Choice();
		sl.add("3");
		sl.add("4");
		sl.add("5");
		sl.add("6");
		sl.add("7");
		schiri3SignalgeberPanel.add(new Label(sa.getTextLabel("DeckRefShort") + "   "));
		schiri3SignalgeberPanel.add(sl);
		parameterPanel.add(schiri3SignalgeberPanel);                                  // (11,2)

		// kurz/lang Signal Unterscheidung eintragen ...
		Panel kurzLangSchwelleLabelPanel = new Panel(new BorderLayout());
		kurzLangSchwelleLabelPanel.add("East", new Label (sa.getTextLabel("signalThreshold") + ":"));
		parameterPanel.add(kurzLangSchwelleLabelPanel);                               // (12,1)
		Panel kurzLangSchwellePanel = new Panel(new GridLayout(1,2));
		kurzLangSchwelleTextfeld    = new TextField (5);
		kurzLangSchwellePanel.add(kurzLangSchwelleTextfeld);
		kurzLangSchwellePanel.add(new Label("ms"));
		parameterPanel.add(kurzLangSchwellePanel);                                    // (12,2)

		// Buttons ...
		Panel buttonPanel = new Panel(new FlowLayout(FlowLayout.CENTER,15,15));
		this.add("South", buttonPanel);
		setButton    = new Button("   " + sa.getTextLabel("ok") + "   ");
		cancelButton = new Button(sa.getTextLabel("cancel"));
		buttonPanel.add(setButton);
		buttonPanel.add(cancelButton);

		setButton.addActionListener(this);   // Mouse-Eingaben
		cancelButton.addActionListener(this);

		setButton.addKeyListener(this);      // Tastatur-Eingaben
		cancelButton.addKeyListener(this);

//		this.setSize (400,500);
		this.pack();

		this.activate();                     // Werte eintragen und anzeigen

		// Wohin ...
		ownerObenLinks = sa.programmFenster.getLocation();
		ownerSize      = new Dimension();
		ownerSize      = sa.programmFenster.getSize(ownerSize);
		thisSize       = new Dimension();
		thisSize       = this.getSize(thisSize);
		setLocation(ownerObenLinks.x + ((ownerSize.width  - thisSize.width ) / 2),
			    ownerObenLinks.y + ((ownerSize.height - thisSize.height) / 2));
	}

	/*
	 * Werte eintragen und anzeigen ...
	 */
	public void activate() {
		// Werte uebertragen auf lokale Variablen und in das Fenster eintragen ...
		this.getValues();
		this.setTable();
		this.show();
	}

	/*
	 * Werte aus der Tabelle lesen ...
	 */
	public void getTable() {
		try {
			// Schiri-Anschluesse ...
			statusBitUw1 = Integer.parseInt(uw1.getSelectedItem());
			statusBitUw2 = Integer.parseInt(uw2.getSelectedItem());
			statusBitSL  = Integer.parseInt(sl.getSelectedItem());
			// Schiri-Simulation ...
			schiriSimulation = ( simulationCheckboxgroup.getSelectedCheckbox() == simTrue ) ? true : false;
			// durchlaufende Zeit ...
			durchlaufendeZeit = ( durchlaufendeZeitCheckboxgroup.getSelectedCheckbox() == durchlaufendeZeitTrue ) ? true : false;
			// erweitertes Protokoll ...
			vollesProtokoll = ( vollesProtokollCheckboxgroup.getSelectedCheckbox() == vollesProtokollTrue ) ? true : false;
			// Spielzeit ...
			spielzeit        = Integer.parseInt(spielzeitTextfeld.getText());
			// Strafzeit ...
			strafzeit        = Integer.parseInt(strafzeitTextfeld.getText());
			// Strafwurfzeit ...
			strafwurfzeit    = Integer.parseInt(strafwurfzeitTextfeld.getText());
			// Halbzeitpause ...
			halbzeitpause    = Integer.parseInt(halbzeitpauseTextfeld.getText());
			// Auszeit ...
			auszeit    = Integer.parseInt(auszeitTextfeld.getText());
			// kurz/lang Signal Schwelle ...
			schiriSignalKurzLangSchwelle
				 = (long) Integer.parseInt(kurzLangSchwelleTextfeld.getText());
		} catch (NumberFormatException ex) {
			new alertFenster(sa.getTextLabel("wrongData"), this);
		}
	}

	/*
	 * Werte in die Tabelle eintragen ...
	 */
	public void setTable() {
		// Schiri-Anschluesse ...
		uw1.select(Integer.toString(statusBitUw1));
		uw2.select(Integer.toString(statusBitUw2));
		sl.select (Integer.toString(statusBitSL ));
		// Schiri-Simulation ...
		if ( schiriSimulation ) simulationCheckboxgroup.setSelectedCheckbox(simTrue);
		else                    simulationCheckboxgroup.setSelectedCheckbox(simFalse);
		// durchlaufende Zeit ...
		if ( durchlaufendeZeit ) durchlaufendeZeitCheckboxgroup.setSelectedCheckbox(durchlaufendeZeitTrue);
		else                     durchlaufendeZeitCheckboxgroup.setSelectedCheckbox(durchlaufendeZeitFalse);
		// erweitertes Protokoll ...
		if ( vollesProtokoll ) vollesProtokollCheckboxgroup.setSelectedCheckbox(vollesProtokollTrue);
		else                   vollesProtokollCheckboxgroup.setSelectedCheckbox(vollesProtokollFalse);
		// Spielzeit ...
		spielzeitTextfeld.setText(Integer.toString(spielzeit));
		// Strafzeit ...
		strafzeitTextfeld.setText(Integer.toString(strafzeit));
		// Strafwurfzeit ...
		strafwurfzeitTextfeld.setText(Integer.toString(strafwurfzeit));
		// Halbzeitpause ...
		halbzeitpauseTextfeld.setText(Integer.toString(halbzeitpause));
		// Auszeit ...
		auszeitTextfeld.setText(Integer.toString(auszeit));
		// kurz/lang Signal Schwelle ...
		kurzLangSchwelleTextfeld.setText(Integer.toString((int) schiriSignalKurzLangSchwelle));
	}

	/*
	 * Werte vom Hauptprogramm holen ...
	 */
	public void getValues() {
		// Schiri-Anschluesse ...
		this.statusBitUw1     = sa.statusBitUw1;
		this.statusBitUw2     = sa.statusBitUw2;
		this.statusBitSL      = sa.statusBitSL;
		// Schiri-Simulation ...
		this.schiriSimulation = sa.schiriSimulation;
		// durchlaufende Zeit ...
		this.durchlaufendeZeit = sa.durchlaufendeZeit;
		// erweitertes Protokoll ...
		this.vollesProtokoll  = sa.vollesProtokoll;
		// Spielzeit ...
		this.spielzeit        = sa.spielzeit;
		// Strafzeit ...
		this.strafzeit        = sa.strafzeit;
		// Strafwurfzeit ...
		this.strafwurfzeit    = sa.strafwurfzeit;
		// Halbzeitpause ...
		this.halbzeitpause    = sa.halbzeitpause;
		// Auszeit ...
		this.auszeit          = sa.auszeit;
		// kurz/lang Signal Schwelle ...
		this.schiriSignalKurzLangSchwelle
				      = sa.schiriSignalKurzLangSchwelle;
	}

	/*
	 * Werte ans Hauptprogramm bergeben ...
	 */
	public void setValues() {
		// Schiri-Anschluesse ...
		sa.statusBitUw1          = this.statusBitUw1;
		sa.uwSchiri1.statusBit   = this.statusBitUw1;
		sa.statusBitUw2          = this.statusBitUw2;
		sa.uwSchiri2.statusBit   = this.statusBitUw2;
		sa.statusBitSL           = this.statusBitSL;
		sa.spielleiter.statusBit = this.statusBitSL;
		// Schiri-Simulation ...
		sa.schiriSimulation = this.schiriSimulation;
		// durchlaufende Zeit ...
		sa.durchlaufendeZeit = this.durchlaufendeZeit;
		// erweitertes Protokoll ...
		sa.setErweitertesProtokoll(vollesProtokoll);
		// Spielzeit ...
		sa.spielzeit        = this.spielzeit;
		sa.spieluhr.spielzeit = this.spielzeit;
		sa.spieluhr.init();
		sa.spieluhr.repaint();
		// Strafzeit ...
		sa.strafzeit        = this.strafzeit;
		sa.strafzeitRechts1.setGesamtStrafzeit(strafzeit);
		sa.strafzeitRechts2.setGesamtStrafzeit(strafzeit);
		sa.strafzeitRechts3.setGesamtStrafzeit(strafzeit);
		sa.strafzeitLinks1.setGesamtStrafzeit(strafzeit);
		sa.strafzeitLinks2.setGesamtStrafzeit(strafzeit);
		sa.strafzeitLinks3.setGesamtStrafzeit(strafzeit);
		// Strafwurfzeit ...
		sa.strafwurfzeit    = this.strafwurfzeit;
		sa.strafwurfRechts.setStrafwurf(strafwurfzeit);
		sa.strafwurfLinks.setStrafwurf(strafwurfzeit);
		// Halbzeitpause ...
		sa.halbzeitpause    = this.halbzeitpause;
		// Auszeit ...
		sa.auszeit          = this.auszeit;
		// kurz/lang Signal Schwelle ...
		sa.schiriSignalKurzLangSchwelle
				    = this.schiriSignalKurzLangSchwelle;
	}

	/*
	 * Die folgenden Methoden bilden das WindowListener-Interface und
	 * beantworten ersteinmal das Anklicken des Windows-Schliessens.
	 */
	public void windowClosing(WindowEvent e) {
		this.dispose();                     // Konfig-Fenster entfernen.
	}
	public void windowActivated(WindowEvent e)   { }
	public void windowClosed(WindowEvent e)      { }
	public void windowDeactivated(WindowEvent e) { }
	public void windowDeiconified(WindowEvent e) { }
	public void windowIconified(WindowEvent e)   { }
	public void windowOpened(WindowEvent e)      { }

	/*
	 * Die folgende Methode bildet das ActionListener-Interface und
	 * beantworten das Anklicken der Buttons.
	 */
	public void actionPerformed(ActionEvent e) {
		// if ( debug ) System.out.println(e.getActionCommand());
		if ( ! ( e.getSource() instanceof Button ) ) {
			return;
		}
		Button target = (Button) e.getSource();        // MOUSE CLICK auf Button ...
		if      (target == setButton) {
			// Werte aus dem Fenster in die lokalen Variablen und dann zum Hauptprogramm ...
			this.getTable();
			this.setValues();
			this.dispose();             // Konfig-Fenster entfernen.
		}
		else if (target == cancelButton)
			this.dispose();             // Konfig-Fenster entfernen.
	}

	/*
	 * Die folgenden Methoden bilden das KeyListener-Interface und
	 * beantworten Tastatureingaben.
	 */
	public void keyPressed(KeyEvent e) {
		int key = e.getKeyCode();
		if ( key != KeyEvent.VK_ENTER )
			return;
		if ( ! ( e.getSource() instanceof Button ) ) {
			return;
		}
		Button target = (Button) e.getSource();        // Tastatur-Eigabe ...
		if      (target == setButton) {
			// Werte aus dem Fenster in die lokalen Variablen und dann zum Hauptprogramm ...
			this.getTable();
			this.setValues();
			this.dispose();             // Konfig-Fenster entfernen.
		}
		else if (target == cancelButton)
			this.dispose();             // Konfig-Fenster entfernen.
	}
	public void keyReleased(KeyEvent e)  { }
	public void keyTyped(KeyEvent e)     { }
}

/*
 * Diese Klasse ist fr die Kommunikation zum C-Programm ueber Fifos (named Pipes)
 * verantwortlich. Dadurch ist fr die Klasse SchiriAnlage alles einfach:
 * 	setDataPort(String data)          setzt den Ausgang.
 * 	setStatusOverwrite(String status) simuliert einen Eingang.
 * 	quitKommunikation()               beendet die Kommunikation mit dem C-Programm
 *
 */
class ParallelPortKommunikation implements Runnable {
	private static boolean debug = false;
	private        boolean simulation;

	int wait = 20; /* wait a second = 20 ms, more than the ANSWER_WAIT in ParallelPortControl */

	SchiriAnlage sa;
	Thread KommunikationsThread;

	String PPData            = "00000000"; // Bit7,...,Bit0
	String PPStatus          = "00000000";
	String PPStatusOverwrite = "00000000";
	String readString, readData, readStatus;

	File fifo_pp_command;                  // Pipe vom C-Programm
	File fifo_ppc_answer;                  // Pipe zum C-Programm
	FileInputStream fileIn;
	FileOutputStream fileout;
	byte[] inbyte;
	String str;
	int readitem;

	boolean quit = false;
	boolean newData = false;

	public ParallelPortKommunikation(boolean simulation, SchiriAnlage sa) {
		this.simulation = simulation;
		this.sa         = sa;
		KommunikationsThread = new Thread(this);
		KommunikationsThread.start();            // sofort starten
		fifo_pp_command = new File (sa.fifo_pp_command);
		fifo_ppc_answer = new File (sa.fifo_ppc_answer);
		inbyte = new byte[80];
		if ( debug ) System.out.println("ParallelPortKommunikation startet.");
	}

	/*
	 * neue Daten an den Parallelport ...
	 */
	public void setDataPort(String data) {
		newData = true;
		PPData = data;
	}

	/*
	 * simuliert einen Eingang ...
	 */
	public void setStatusOverwrite(String status) {
		if ( status.compareTo(PPStatusOverwrite) != 0 ) {
			sa.setChangedStatus(status);
			PPStatusOverwrite = status;
		}
	}

	/*
	 * Ende ...
	 */
	public void quitKommunikation() {
		quit = true;
		// Wait a bit for the final communication ...
		try{
			Thread.sleep(2*wait);
		} catch (Exception e) {
			System.out.println("ParallelPortKommunikation: Fehler bei wait: " + e.toString());
		}
		stop();
	}

	/*
	 * der Thread wird dies ausfhren ...
	 */
	public void run() {
		if ( simulation ) runSimulation();
		else              runReal();
	}

	/*
	 * der Thread als Simulation ...
	 */
	private void runSimulation() {
		if ( debug ) System.out.println("ParallelPortKommunikation: Scheifenbeginn.");
		do {
			if ( newData ) {
				str = PPData + '\n';
				newData = false;
			}
			else {
				str = "OnlyRead\n";
			}
			if ( quit ) {
				str = "quit\n";
			}
			try{
				Thread.sleep(wait); /* Wait a bit */
			} catch (Exception e) {
				System.out.println("ParallelPortKommunikation: Fehler bei wait: " + e.toString());
			}
		} while ( ! quit );
	}

	/*
	 * der Thread fr echten Betrieb ...
	 */
	private void runReal() {
		// ffnen der Fifos ...
		if ( ! openFifos() ) return;

		// Nun kannst beginnen ...
		if ( debug ) System.out.println("ParallelPortKommunikation: Scheifenbeginn.");
		do {
			if ( newData ) {
				str = PPData + '\n';
				newData = false;
			}
			else {
				str = "OnlyRead\n";
			}
			if ( quit ) {
				str = "quit\n";
			}
			if ( debug ) System.out.print("ParallelPortKommunikation -> fifo_pp_command: " + str);
			try{
				fileout.write(str.getBytes());          // Herausschreiben ...
				fileout.flush();                        // flush ..
				if ( debug ) System.out.println("ParallelPortKommunikation: Wait a second...");
				Thread.sleep(wait);                     // Wait a bit ...
				do {
					readitem = fileIn.available();  // gibt's etwas zu lesen ...
					if ( debug ) System.out.println("ParallelPortKommunikation: " + readitem + " Byte available.");
					if ( readitem > 0 ) {           // lesen ...
						fileIn.read(inbyte, 0, readitem);
						readString = new String(inbyte, 0, readitem);
					}
					else {
						if ( debug ) System.out.println("ParallelPortKommunikation: Wait a second...");
						Thread.sleep(wait);
					}
				} while ( readitem == 0 );              // solange versuchen, bis etwas zu lesen da ist!
			} catch (Exception e) {
				System.out.println("ParallelPortKommunikation: Fehler bei der Kommunikation: " + e.toString());
				stop();
				return;
			}
			// "readString" aufteilen
			if ( debug ) System.out.println("ParallelPortKommunikation: " + readString);
			StringTokenizer st = new StringTokenizer(readString);
			readData   = st.nextToken();
			readStatus = st.nextToken();                 // hier sind die wichtigen Informationen der Schiries drin!

			// check the return of data ...
			// if ( readData.compareTo(PPData) != 0 )
			//	System.out.println("ParallelPortKommunikation: Fehler bei der Kommunikation: Data verschieden");

			// check for new input ...
			if ( readStatus.compareTo(PPStatus) != 0 ) { // wenn sich der Status des gendert hat ...
				sa.setChangedStatus(readStatus);     // ... an Hauptprogramm bergeben
				PPStatus = readStatus;
			}
		} while ( ! quit );
	}

	/*
	 * ffnen der Pipes ...
	 */
	private boolean openFifos() {
		boolean gotFileStream = false;
		int     openCount     = 0;
		int     openWait      = 1000; /* 1000 ms */

		while ( ! gotFileStream ) {
			try {
				if ( openCount > 0 ) Thread.sleep(openWait);       // Wait a second for next try
				fileout = new FileOutputStream(fifo_pp_command);   // neuer Stream (versuchen)
				if ( debug ) System.out.println("ParallelPortKommunikation: Output found.");
				gotFileStream = true;
			} catch (Exception e) {                                    // kein Erfolg beim ffnen der Pipe
				gotFileStream = false;
				openCount++;
				if ( debug ) System.out.println("ParallelPortKommunikation: Output not found." + e.toString());
				if ( openCount == 5 ) return false;
			}
		}
		openCount = 0;
		gotFileStream = false;
		while ( ! gotFileStream ) {
			try {
				if ( openCount > 0 ) Thread.sleep(openWait);       // Wait a second for next try
				fileIn = new FileInputStream(fifo_ppc_answer);     // neuer Stream (versuchen)
				if ( debug ) System.out.println("ParallelPortKommunikation: Input found.");
				gotFileStream = true;
			} catch (Exception e) {                                    // kein Erfolg beim ffnen der Pipe
				gotFileStream = false;
				openCount++;
				if ( debug ) System.out.println("ParallelPortKommunikation: Input not found." + e.toString());
				if ( openCount == 5 ) return false;
			}
		}
		return true;
	}

	/*
	 * alles sauber beenden ...
	 */
	public void stop() {
		int closeWait = 1000;
		try{
			if ( ! simulation ) {
				fileIn.close();
				fileout.close();
				Thread.sleep(closeWait); /* Wait a second */
			}
		}
		catch (Exception e) {
			System.out.println("ParallelPortKommunikation: Fehler beim Schlieen der Fifos: " + e.toString());
			return;
		}
		if ( debug ) System.out.println("ParallelPortKommunikation: ENDE");
		KommunikationsThread = null;
	}
}


/*
 * Ein Dialog-Fenster fr einen Warnhinweis.
 */
class alertFenster extends Dialog implements ActionListener, KeyListener, WindowListener  {
	Dimension ownerSize, thisSize;   // zur Positionierung
	Point     ownerObenLinks;
	int       numberOfLines;         // Anzahl der Zeilen im Alert-Fenster
	int       numberOfButtons;       // Anzahl der Buttons bei Dialog

	// Alert aus einem Frame ...
	public alertFenster(String longString, Frame owner) {
		// System.out.println("alertFenster: ");
		super(owner, longString, true);
		initAlert(stringParts(longString));
		setPosition(owner);
		this.show();
	}

	// Alert aus einem Dialog (z.B. Protokoll-Eintrag) ...
	public alertFenster(String longString, Dialog owner) {
		// System.out.println("alertFenster: ");
		super(owner, longString, true);
		initAlert(stringParts(longString));
		setPosition(owner);
		this.show();
	}

	// Alert mit mehreren Buttons und Titel ...
	public alertFenster(String title, String longString, Button[] schalter, Frame owner) {
		// System.out.println("alertFenster: ");
		super(owner, title, true);
		initAlert(stringParts(longString), schalter);
		setPosition(owner);
		// show(); muss vom aufrufenden Objekt aus gestartet werden
	}

	/*
	 * Inititalisierung ...
	 */
	private void initAlert(String[] allLines) {
		numberOfLines = allLines.length;

		Button okButton = new Button("   OK   ");
		Panel  randPanel = new Panel(new GridLayout(numberOfLines+1,1,10,10));
		this.setLayout(new FlowLayout(FlowLayout.CENTER, 10,10));
		this.add(randPanel);

		okButton.addActionListener(this);
		okButton.addKeyListener(this);
		this.addWindowListener(this);
		for (int i = 0; i < numberOfLines; i++)
			randPanel.add(new Label(allLines[i]));
		randPanel.add(okButton);
		this.pack();
	}

	/*
	 * Inititalisierung fr Dialog mit mehreren Buttons ...
	 */
	private void initAlert(String[] allLines, Button[] schalter) {
		numberOfLines = allLines.length;
		numberOfButtons = schalter.length;

		Panel  randPanel = new Panel(new GridLayout(numberOfLines+1,1,10,10));
		this.setLayout(new FlowLayout(FlowLayout.CENTER, 10,10));
		this.add(randPanel);

		this.addWindowListener(this);
		for (int i = 0; i < numberOfLines; i++)
			randPanel.add(new Label(allLines[i]));
		Panel buttonPanel = new Panel();
		randPanel.add(buttonPanel);
		for (int i = 0; i < numberOfButtons; i++)
			buttonPanel.add(schalter[i]);

		this.pack();
	}

	/*
	 * Teilt den langen String in passende Stcke ...
	 */
	public static String[] stringParts (String longString) {
		int maxLineNumber = 20;
		String [] parts   = new String[maxLineNumber];
		int blankIndex[]  = new int[maxLineNumber];
		int normalMinLength = 40;
		int normalMaxLength = 50;
		int oldBlank        =  0;
		// Suche nach den passenden Bruchstellen ...
		for (int i = 0; i < maxLineNumber; i++) {
			blankIndex[i] = longString.indexOf(" ", normalMinLength + oldBlank);
			if ( blankIndex[i] - oldBlank > normalMaxLength ) { // zu lang ?
				int tmpBlank = longString.substring(oldBlank + 1,blankIndex[i]-1).lastIndexOf(" ");
				if ( tmpBlank > -1 ) blankIndex[i] = tmpBlank + oldBlank + 1;
			}
			// kurze Wrter gefolgt von einem langen am Schluss
			if ( blankIndex[i] == -1
				 &&  longString.substring(oldBlank).length() > normalMaxLength ) {
				int tmpBlank = longString.lastIndexOf(" ");
				if ( tmpBlank > oldBlank ) blankIndex[i] = tmpBlank;
			}
			if ( blankIndex[i] == -1 ) { // endgltig am Ende des Strings
				parts = new String[i+1];
				break;
			}
			else oldBlank = blankIndex[i];
		}
		oldBlank = -1;
		for (int i = 0; i < parts.length; i++) {
			int endIndex = blankIndex[i];
			if ( endIndex == -1 ) endIndex = longString.length();
			parts[i] = longString.substring(oldBlank+1, endIndex);
			oldBlank = blankIndex[i];
		}
		return parts;
	}

	/*
	 * Positionierung ...
	 */
	public void setPosition(Window owner) {
		ownerObenLinks = owner.getLocation();
		ownerSize      = new Dimension();
		ownerSize      = owner.getSize(ownerSize);
		thisSize       = new Dimension();
		thisSize       = this.getSize(thisSize);
		setLocation(ownerObenLinks.x + ((ownerSize.width  - thisSize.width ) / 2),
			    ownerObenLinks.y + ((ownerSize.height - thisSize.height) / 2));
	}

	public void schliessen() {
		this.setVisible(false);
		this.dispose();
	}

	/*
	 * Die folgenden Methoden bilden das WindowListener-Interface und
	 * beantworten ersteinmal das Anklicken des Windows-Schliessens.
	 */
	public void windowClosing(WindowEvent e) {
		this.schliessen();                     // Dialog-Fenster entfernen.
	}
	public void windowActivated(WindowEvent e)   { }
	public void windowClosed(WindowEvent e)      { }
	public void windowDeactivated(WindowEvent e) { }
	public void windowDeiconified(WindowEvent e) { }
	public void windowIconified(WindowEvent e)   { }
	public void windowOpened(WindowEvent e)      { }

	/*
	 * Die folgende Methode bildet das ActionListener-Interface und
	 * beantworten das Anklicken der Buttons.
	 */
	public void actionPerformed(ActionEvent e) {
		this.dispose();
	}

	/*
	 * Die folgenden Methoden bilden das KeyListener-Interface und
	 * beantworten Tastatureingaben.
	 */
	public void keyPressed(KeyEvent e) {
		int key = e.getKeyCode();
		if ( key != KeyEvent.VK_ENTER )
			return;
		this.dispose();
	}
	public void keyReleased(KeyEvent e)  { }
	public void keyTyped(KeyEvent e)     { }
}

/*
 * Diese Klasse stellt ein Fenster mit der Liste der Mannschaften dar.
 */
class mannschaftenListe implements ActionListener, WindowListener, KeyListener, ItemListener {
	public static boolean debug = SchiriAnlage.debug;
	SchiriAnlage      sa;
	int               anzahlMannschaften = 0;                      // Anzahl der Mannschaften werden mitgezhlt
	boolean           selectIsLinks      = true;                   // Bestimmung der linken Mannschaft? sonst rechts
	Label             aboutLabel;
	Color             trennBalkenColor   = Color.lightGray;        // Farbe des Trennbalkens
	Button            newButton, deleteButton;                     // Buttons
	Button            ladenButton, speichernButton, cancelButton;
	Button            setBlueButton, setWhiteButton;
	Button            newSpielerButton, deleteSpielerButton, mannschaftOkButton;
	Button            spielerOkButton;
	TextField         mannschaftsnameTextField;                   // Texteingaben
	TextField         spielerNummerTextField, spielerNameTextField;
	Checkbox          mannschaftsfuehrerCheckbox;                 // Mannschaftsfhrer zum anklicken
	List              listeDerSpieler = new List(9);              // Spielerliste der selektierten Mannschaft
	List              listeDerMannschaften = new List(8);         // Mannschaftsliste
	mannschaft        firstMannschaft = null; // erster in der Liste
	mannschaft        newMannschaft   = null; // neue Mannschaft solange noch nicht gespeichert
	mannschaft        editMannschaft  = null; // Die Mannschaft wird unten angezeigt, entweder newMannschaft oder selected
	spieler           newSpieler      = null; // neuer Spieler solange noch nicht gespeichert
	spieler           editSpieler     = null; // Der Spieler wird unten angezeigt, entweder newSpieler oder selected
	Font              InfoLabelFont;
	Point             ownerObenLinks;                             // Positionierung
	Dimension         ownerSize, thisSize;
	Frame             fenster;

	/*
	 * Konstruktor fr mannschaftenListe ...
	 */
	public mannschaftenListe (SchiriAnlage sa) {
		this.sa = sa;

		aboutLabel     = new Label ("                                             ");
		newMannschaft  = new mannschaft (sa, this);
		editMannschaft = newMannschaft;
		newSpieler     = new spieler(sa, newMannschaft);
		editSpieler    = newSpieler;

		// Buttons ...
		newButton       = new Button(sa.getTextLabel("newTeam"));
		deleteButton    = new Button(sa.getTextLabel("removeTeam"));
		ladenButton     = new Button(sa.getTextLabel("teamListLoad"));
		speichernButton = new Button(sa.getTextLabel("teamListSave"));
		cancelButton    = new Button(sa.getTextLabel("close"));
		setBlueButton   = new Button(sa.getTextLabel("playsBlue"));
		setWhiteButton  = new Button(sa.getTextLabel("playsWhite"));

		newSpielerButton    = new Button(sa.getTextLabel("newPlayer"));
		deleteSpielerButton = new Button(sa.getTextLabel("removePlayer"));
		mannschaftOkButton  = new Button(sa.getTextLabel("registerTeam"));

		spielerOkButton = new Button(sa.getTextLabel("registerPlayer"));

		Color blau      = new Color (192,192,255);
		setBlueButton.setBackground(blau);
		setWhiteButton.setBackground(Color.white);

		// Dieses Panel ueberwacht seine Buttons selbst ...
		newButton.addActionListener(this);        // Mouse-Klicks
		deleteButton.addActionListener(this);
		cancelButton.addActionListener(this);
		setBlueButton.addActionListener(this);
		setWhiteButton.addActionListener(this);
		ladenButton.addActionListener(this);
		speichernButton.addActionListener(this);
		newSpielerButton.addActionListener(this);
		deleteSpielerButton.addActionListener(this);
		mannschaftOkButton.addActionListener(this);
		spielerOkButton.addActionListener(this);

		newButton.addKeyListener(this);           // Tastatur-Eingaben
		//editButton.addKeyListener(this);
		deleteButton.addKeyListener(this);
		cancelButton.addKeyListener(this);
		setBlueButton.addKeyListener(this);
		setWhiteButton.addKeyListener(this);
		ladenButton.addKeyListener(this);
		speichernButton.addKeyListener(this);
		newSpielerButton.addKeyListener(this);
		deleteSpielerButton.addKeyListener(this);
		mannschaftOkButton.addKeyListener(this);
		spielerOkButton.addKeyListener(this);

		listeDerMannschaften.addItemListener(this);
		listeDerSpieler.addItemListener(this);
	}

	/*
	 * Die folgende Methode wird beim Aktivieren des Mannschaftsbutton aufgerufen.
	 * selectIsLinks = true : Die Linke Mannschaft wird bestimmt, sonst die rechte
	 */
	public void showMannschaftsliste(boolean selectIsLinks){
		if ( fenster != null )
			schliessen();
		this.selectIsLinks = selectIsLinks;

		InfoLabelFont = sa.InfoLabelFont;

		// Frame ...
		fenster = new Frame(sa.getTextLabel("teamList"));
		fenster.setLayout(new BorderLayout(5,5));
		aboutLabel.setText(selectIsLinks ? sa.getTextLabel("selectTeam") + " " + sa.getTextLabel("left") :
										   sa.getTextLabel("selectTeam") + " " + sa.getTextLabel("right"));
		fenster.addWindowListener(this);

		// Unterteilung fr Mannschaftsliste, Mannschaft, Spieler
		Panel mlPanel = new Panel(new BorderLayout(5,5));
		Panel maPanel = new Panel(new BorderLayout(5,5));
		Panel spPanel = new Panel(new BorderLayout(5,5));
		fenster.add(mlPanel, BorderLayout.NORTH);
		fenster.add(maPanel, BorderLayout.CENTER);
		fenster.add(spPanel, BorderLayout.SOUTH);

		// About Mannschaftsliste ...
		Panel aboutPanel = new Panel(new FlowLayout(FlowLayout.CENTER,15,15));
		mlPanel.add(aboutPanel, BorderLayout.NORTH);
		aboutPanel.add(aboutLabel);

		// Liste der Mannschaften ...
		Panel listeButtonPanel        = new Panel(new BorderLayout(15,15));
		Panel buttonRechtsAussenPanel = new Panel(new FlowLayout(FlowLayout.CENTER,15,0));
		Panel buttonRechtsPanel       = new Panel(new GridLayout(5,1,15,15));
		Panel buttonUntenPanel        = new Panel(new FlowLayout(FlowLayout.CENTER,50,0));
		mlPanel.add(listeButtonPanel, BorderLayout.CENTER);
		listeButtonPanel.add(listeDerMannschaften, BorderLayout.CENTER);

		// Buttons Mannschaftsliste ...
		mlPanel.add(buttonRechtsAussenPanel, BorderLayout.EAST);
		buttonRechtsAussenPanel.add(buttonRechtsPanel, BorderLayout.CENTER);
		listeButtonPanel.add(buttonUntenPanel, BorderLayout.SOUTH);
		buttonRechtsPanel.add(ladenButton);
		buttonRechtsPanel.add(speichernButton);
		buttonRechtsPanel.add(newButton);
		buttonRechtsPanel.add(deleteButton);
		buttonRechtsPanel.add(cancelButton);

		buttonUntenPanel.add(setBlueButton);
		buttonUntenPanel.add(setWhiteButton);

		// Trennbalken Mannschaft .................................................
		Panel mannschaftTrennPanel = new Panel();
		maPanel.add(mannschaftTrennPanel, BorderLayout.NORTH);
		mannschaftTrennPanel.setBackground(trennBalkenColor);  // Balken

		// Center ...
		Panel centerPanel           = new Panel(new BorderLayout(15,15));
		Panel mannschaftsPanel      = new Panel(new FlowLayout(FlowLayout.LEFT,15,5));
		Panel spielerListePanel     = new Panel(new FlowLayout(FlowLayout.LEFT,15,5));
		Panel rechtsAussenPanel     = new Panel(new FlowLayout(FlowLayout.CENTER,15,5));
		Panel mannschaftbuttonPanel = new Panel(new GridLayout(3,1,15,50));
		centerPanel.add (mannschaftsPanel, BorderLayout.NORTH);
		centerPanel.add (spielerListePanel, BorderLayout.CENTER);
		maPanel.add(centerPanel, BorderLayout.CENTER);
		maPanel.add(rechtsAussenPanel, BorderLayout.EAST);
		rechtsAussenPanel.add(mannschaftbuttonPanel, BorderLayout.CENTER);

		// Mannschaftsname ...
		mannschaftsPanel.add(new Label(sa.getTextLabel("team") + ":"));
		mannschaftsnameTextField  = new TextField(20);
		mannschaftsPanel.add(mannschaftsnameTextField);

		// Spielerliste ...
		spielerListePanel.add(new Label(sa.getTextLabel("player") + ":"));
		spielerListePanel.add(listeDerSpieler);

		// Buttons ...
		mannschaftbuttonPanel.add(mannschaftOkButton);
		mannschaftbuttonPanel.add(newSpielerButton);
		mannschaftbuttonPanel.add(deleteSpielerButton);

		// Trennbalken Spieler ..........................................................
		Panel spielerTrennPanel  = new Panel();
		spPanel.add(spielerTrennPanel, BorderLayout.NORTH);
		spielerTrennPanel.setBackground(trennBalkenColor);  // Balken

		// Center ...
		Panel spielerPanel       = new Panel(new BorderLayout(15,0));
		Panel nummernPanel       = new Panel(new FlowLayout(FlowLayout.LEFT,5,15));
		Panel namePanel          = new Panel(new FlowLayout(FlowLayout.LEFT,5,15));
		Panel spielerButtonPanel = new Panel(new FlowLayout(FlowLayout.CENTER,15,40));
		spielerPanel.add (nummernPanel, BorderLayout.SOUTH);
		spielerPanel.add (namePanel, BorderLayout.CENTER);
		spPanel.add(spielerPanel, BorderLayout.CENTER);
		spPanel.add(spielerButtonPanel, BorderLayout.EAST);

		// Nummer ...
		nummernPanel.add(new Label(sa.getTextLabel("number") + ":"));
		spielerNummerTextField  = new TextField(2);
		nummernPanel.add(spielerNummerTextField);

		// Mannschaftsfhrer ...
		nummernPanel.add(new Panel());                      // fr Abstand ...
		mannschaftsfuehrerCheckbox = new Checkbox(sa.getTextLabel("teamLeader"), false);
		nummernPanel.add(mannschaftsfuehrerCheckbox);

		// Name ...
		namePanel.add(new Label(sa.getTextLabel("playerName") + ":"));
		spielerNameTextField  = new TextField(30);
		namePanel.add(spielerNameTextField);

		// Buttons ...
		spielerButtonPanel.add(spielerOkButton);

		//fenster.setSize (400,500);
		fenster.pack();

		// Wohin ...
		ownerObenLinks = sa.programmFenster.getLocation();
		ownerSize      = new Dimension();
		ownerSize      = sa.programmFenster.getSize(ownerSize);
		thisSize       = new Dimension();
		thisSize       = fenster.getSize(thisSize);
		int addX = ( selectIsLinks ) ? 50 : (ownerSize.width  - thisSize.width - 50);
		fenster.setLocation(ownerObenLinks.x + addX, ownerObenLinks.y + ((ownerSize.height - thisSize.height) / 2));

		fenster.show();

		listeAktualisieren(firstMannschaft);
	}

	/*
	 * berprfe die Mannschaft fr volles Protokoll ...
	 */
	public boolean checkMannschaft(mannschaft checkMannschaft, Frame returnFrame) {
		if ( checkMannschaft == null ) {
			new alertFenster(sa.getTextLabel("selectTeams"), returnFrame);
			return false;
		}
		if ( checkMannschaft.anzahlSpieler < 2 ) {
			new alertFenster(SchiriAnlage.replaceVar(sa.getTextLabel("insertPlayer"), checkMannschaft.name), returnFrame);
			return false;
		}
		if ( checkMannschaft.mannschaftsfuehrer == null ) {
			new alertFenster(SchiriAnlage.replaceVar(sa.getTextLabel("selectTeamLeader"), checkMannschaft.name), returnFrame);
			return false;
		}
		return true;
	}

	/*
	 * Fllen der Liste ...
	 */
	public void listeAktualisieren(mannschaft selected) {
		mannschaft fsp   = firstMannschaft;
		int        index = 0;
		mannschaft sortedElements[];

		listeDerMannschaften.removeAll();

		if ( fsp == null ) return;

		sortedElements = new mannschaft[anzahlMannschaften];

		do {                                   // Kette in das Array kopieren
			sortedElements[index] = fsp;
			index++;
			fsp = fsp.next;
		} while (fsp != null && index < anzahlMannschaften);

		if ( fsp != null || index < anzahlMannschaften ) {
			new alertFenster(sa.getTextLabel("errorTeamNumber"), fenster);
			return;
		}

		// sortieren ...
		sortElements(sortedElements);

		for (index=0; index<anzahlMannschaften; index++) {  // in der Liste anzeigen
			listeDerMannschaften.add(sortedElements[index].name);
			sortedElements[index].indexInList = index;
		}

		// die selektierte Mannschaft anzeigen ...
		if ( selected != null && selected.indexInList < anzahlMannschaften && selected.indexInList >= 0 ) {
			listeDerMannschaften.select(selected.indexInList);
			editMannschaft = selected;
			listeDerMannschaften.makeVisible(selected.indexInList);
			selected.showMannschaft();
		}
	}

	/*
	 * Sortierungsalgorithmus
	 */
	public void sortElements(mannschaft[] sortedElements) {
	  mannschaft tmp;
	  int lo0 = 0;
	  int hi0 = sortedElements.length-1;

	  for (int i= lo0; i<hi0; i++ ) {
	    for (int j=i+1; j<=hi0; j++) {
	      if ( sortedElements[i].name.compareTo(sortedElements[j].name) > 0 ) {
		 // vertauschen ...
		 tmp               = sortedElements[i];
		 sortedElements[i] = sortedElements[j];
		 sortedElements[j] = tmp;
	      }
	    }
	  }
	}

	/*
	 * Mannschaft in der Kette mit Index index
	 */
	public mannschaft getMannschaft(int index) {
		mannschaft ma = firstMannschaft;

		if ( ma == null ) return null;
		while ( ma.indexInList != index && ma.next != null ) ma = ma.next;
		if ( ma.indexInList != index ) return null;
		return ma;
	}

	/*
	 * die letzte Mannschaft in der Kette
	 */
	public mannschaft getLastMannschaft() {
		mannschaft last = firstMannschaft;

		if ( last == null ) return last;
		while ( last.next != null ) last = last.next;
		return last;
	}

	/*
	 * die Mannschaft in der Kette, die davor liegt.
	 */
	public mannschaft getPreviousMannschaft(mannschaft ma) {
		mannschaft previous = firstMannschaft;

		if ( previous == null ) return previous;
		while ( previous.next != null && previous.next != ma ) previous = previous.next;
		return previous;
	}

	/*
	 * Das Element wird in die Kette eingehngt (aufgenommen).
	 */
	public void einhaengen(mannschaft neuInListe) {
		mannschaft last = getLastMannschaft();
		if ( last == null ) firstMannschaft = neuInListe;
		else		    last.next       = neuInListe;
		neuInListe.next = null;
		anzahlMannschaften++;
	}

	/*
	 * Das Element wird aus der Kette ausgehngt (gelscht).
	 */
	public void aushaengen(mannschaft rausAusListe) {
		if ( rausAusListe == firstMannschaft ) {
			firstMannschaft = rausAusListe.next;
		}
		else {
			mannschaft previous = getPreviousMannschaft(rausAusListe);
			if ( previous == null ) {
				new alertFenster(SchiriAnlage.replaceVar(sa.getTextLabel("errorTeamList"), rausAusListe.name), fenster);
			}
			previous.next = rausAusListe.next;
		}
		anzahlMannschaften--;
	}


	/*
	 * Methode openFile().
	 * wird beim Aktivieren des Liste-ffen-Button aufgerufen.
	 * openFile() besorgt die Daten (Datei oder URL), wenn's geht
	 * und schiebt den Inhalt in den String fileString. Dann werden
	 * die Manschaften in die Liste eingetragen.
	 */
	private void openFile() {
		String      filename   = "mannschaftsconfig.html";
		File        datafile;
		InputStream stream     = null;
		String      fileString = null;

		try {
			if ( SchiriAnlage.runAsProgram ) {
				filename = askFilename(filename);
				if ( filename == null )            // keine Auswahl einer Datei
					return;
				datafile = getFile(filename);
				if ( datafile == null )            // keine brauchbare Datei, Alerts in getFile(...)
					return;
				stream   = getInputStreamProg(datafile);
			}
			else {
				new alertFenster(sa.getTextLabel("exampleTeam"), fenster);

				stream = getInputStreamApplet(filename);
				if ( stream == null )
					return;
			}
			fileString = getFileString(stream);        // aus Stream lesen
		} catch (IOException e) {
			System.out.println(e);
		}

		readData(fileString);
		listeAktualisieren(firstMannschaft);
	}

	/*
	 * Diese Methode fragt nach filename
	 * Return-Wert = Dateiname
	 * askFilename wird von openFile() aufgerufen.
	 */
	private String askFilename (String filename) {
		FileDialog fd = new FileDialog (fenster, sa.getTextLabel("loadTeam"), FileDialog.LOAD);
		//fd.setDirectory("..\\mannschafts-konfigs");
		fd.setFile(filename);
		fd.show();
		filename = fd.getFile();                   // warten auf die Auswahl ...

		if ( filename == null ) {
			return null;
		}

		filename = fd.getDirectory() + filename;    // Verzeichnis braucht man auch ...
		return filename;
	}

	/*
	 * Diese Methode ueberprueft die Datei "filename"
	 * Return-Wert = null, wenn Datei nicht lesbar/vorhanden.
	 * getFile() wird von openFile() aufgerufen.
	 */
	private File getFile(String filename) throws IOException {
		File datafile = new File(filename);	   // Probleme beim Datei einlesen?
		if ( ! datafile.exists() ) {
			new alertFenster(SchiriAnlage.replaceVar(sa.getTextLabel("fileNotFound"), filename), fenster);
			return null;
		}
		if ( ! datafile.isFile() ) {
			new alertFenster(SchiriAnlage.replaceVar(sa.getTextLabel("noFile"), filename), fenster);
			return null;
		}
		if ( ! datafile.canRead() ) {
			new alertFenster(SchiriAnlage.replaceVar(sa.getTextLabel("noReadFile"), filename), fenster);
			return null;
		}
		return datafile;
	}

	/*
	 * Diese Methode liefert den InputStream zur Datei datafile
	 * Return-Wert = InputStream, wenn alles ok. Sonst null.
	 * getInputStreamProg() wird von openFile() aufgerufen.
	 */
	private InputStream getInputStreamProg (File datafile) throws IOException {
		FileInputStream fileIn = new FileInputStream(datafile);
		return fileIn;
	}

	/*
	 * Diese Methode liefert den InputStream zur URL zum filename
	 * Return-Wert = InputStream, wenn alles ok. Sonst null.
	 * getInputStreamApplet() wird von openFile() aufgerufen.
	 */
	private InputStream getInputStreamApplet (String filename) throws IOException {
		URL         dataUrl;

		try {
			dataUrl = new URL(sa.getDocumentBase(), filename);
		} catch (MalformedURLException e) {
			new alertFenster(SchiriAnlage.replaceVar(sa.getTextLabel("noLoadFile"), filename), fenster);
			return null;
		}
		String urlString = dataUrl.toString();

		return dataUrl.openStream();
	}


	/*
	 * Methode getFileString():
	 * IN: datafile    die Datei
	 * Liest den Datei-Inhalt in fileString
	 */
	public static String getFileString(InputStream stream) throws IOException {
		String fileString = "";
		BufferedReader reader;
		int  maxReadChars = 50000;
		int  readChars    = 0;
		char cbuf[]       = new char[maxReadChars];

		reader = new BufferedReader(new InputStreamReader(stream));

		// warten bis die ersten Daten da sind ...
		while ( ! reader.ready() ) {
			stream.available();
		}

		while ( (readChars = reader.read(cbuf, 0, maxReadChars)) != -1) {
			fileString += new String(cbuf, 0, readChars);
		}

		reader.close();

		return fileString;
	}

	/*
	 * Methode readData().
	 * IN: String fileString
	 * Erzeugt Mannschaften mit Spielern
	 */
	private void readData(String fileString) {
		int    maxStringLength = 80;
		int    pos, spos;
		String part, spart, spielerNummerString;
		String mannschaftsName;
		String spielerName;
		int    spielerNummer;
		mannschaft neueMannschaft;
		spieler    neuerSpieler;

		String mannschaftsTag         = "<mannschaft>";
		String mannschaftsNameTag     = "<mannschaftsname>";
		String spielerTag             = "<spieler>";
		String spielerNummerTag       = "<nummer>";
		String spielerNameTag         = "<name>";
		String spielerMFTag           = "<mannschaftsfuehrer>";

		// Mannschaftsschleife ... xmlString.indexOf(tagString,startPos);
		for ( pos  = fileString.indexOf(mannschaftsTag, 0);  // pos = -1, wenn nicht gefunden
		      pos >= 0;               // kein Mannschaft mehr!
		      pos  = fileString.indexOf(mannschaftsTag, pos+mannschaftsTag.length()) ) {

			part  = protokoll.getXmlTagString(fileString, mannschaftsTag, pos, false);
			if ( part == null ) return; // keine Mannschaften mehr ...
			// Mannschaftsname zuerst ...
			mannschaftsName = protokoll.getXmlTagString(part, mannschaftsNameTag, 0, false);
			if ( mannschaftsName == null || mannschaftsName.length() > maxStringLength )
				return;  // falsche Werte!
			mannschaftsName = mannschaftsName.trim();
			neueMannschaft = new mannschaft (sa, this, mannschaftsName);
			this.einhaengen(neueMannschaft);
			this.listeAktualisieren(neueMannschaft);
			// Spielerschleife ...
			for ( spos  = part.indexOf(spielerTag, 0);
			      spos >= 0;               // kein Spieler mehr!
			      spos  = part.indexOf(spielerTag, spos+spielerTag.length()) ) {

				spart  = protokoll.getXmlTagString(part, spielerTag, spos, false);
				if ( spart == null ) break; // keine Mannschaften mehr ...
				// Spielernummer ...
				spielerNummerString = protokoll.getXmlTagString(spart, spielerNummerTag, 0, false);
				if ( spielerNummerString == null || spielerNummerString.length() > 4 ) return; // falsche Werte!
				try {
					spielerNummer = Integer.parseInt(spielerNummerString.trim());
				} catch (NumberFormatException ex) { return; }
				// Spielername ...
				spielerName = protokoll.getXmlTagString(spart, spielerNameTag, 0, false);
				if ( spielerName == null || spielerName.length() > maxStringLength ) return; // falsche Werte!
				spielerName = spielerName.trim();
				neuerSpieler = new spieler (sa, neueMannschaft, spielerNummer, spielerName);
				if ( protokoll.getXmlTagString(spart, spielerMFTag, 0, false) != null )
					neueMannschaft.mannschaftsfuehrer = neuerSpieler;
				neueMannschaft.einhaengen(neuerSpieler);
				neueMannschaft.listeAktualisieren(neueMannschaft.firstSpieler);
			}
		}
	}

	/*
	 * Methode writeData().
	 * IN: BufferedWriter writer (zum Schreiben der Daten)
	 * Wird nur von sichern() aufgerufen,
	 * Schreibt die Daten in das HTML-File
	 */
	private void writeData(BufferedWriter writer) throws IOException {
		mannschaft writeMannschaft = firstMannschaft;
		spieler    writeSpieler;
		String     writeString, mannschaftString, spielerString;
		String     allSpielerString, allMannschaftString, mannschaftTemplateString, spielerTemplateString;

		String mannschaftsTag         = "<mannschaft>";
		String mannschaftsNameTag     = "<mannschaftsname>";
		String spielerTag             = "<spieler>";
		String spielerNummerTag       = "<nummer>";
		String spielerNameTag         = "<name>";
		String spielerMFTag           = "<mannschaftsfuehrer>";

		// Dies Template wird zur Erzeugung der Mannschaftsdatei verwendet ...
		writeString = "<html>\n<head>\n" +
			"	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-15\"></meta>\n" +
			"	<meta name=\"mannschaftsconfig\"></meta>\n" +
			"</head>\n<body>\n<ul>\n" +
			"<mannschaft>\n<li>\n<mannschaftsname></mannschaftsname>\n<ul>\n" +
			"<spieler><li><nummer></nummer>&nbsp;<name></name>&nbsp;<mannschaftsfuehrer></mannschaftsfuehrer></li></spieler>" +
			"</ul>\n</li>\n</mannschaft>" +
			"</ul>\n</body>\n</html>\n";

		mannschaftTemplateString = protokoll.getXmlTagString(writeString, mannschaftsTag, 0, true);
		spielerTemplateString    = protokoll.getXmlTagString(writeString, spielerTag, 0, true);
		// Mannschaften ...
		allMannschaftString = "";
		while ( writeMannschaft != null ) {
			mannschaftString = protokoll.setXmlTag(mannschaftTemplateString, mannschaftsNameTag, writeMannschaft.name, 0, false);
			writeSpieler = writeMannschaft.firstSpieler;
			allSpielerString = "";
			while ( writeSpieler != null ) {
				spielerString = protokoll.setXmlTag(spielerTemplateString, spielerNummerTag, ""+writeSpieler.nummer, 0, false);
				spielerString = protokoll.setXmlTag(spielerString, spielerNameTag, writeSpieler.name, 0, false);
				if ( writeSpieler == writeMannschaft.mannschaftsfuehrer )
					spielerString = protokoll.setXmlTag(spielerString, spielerMFTag, "(" + sa.getTextLabel("teamLeaderAbr") + ")", 0, false);
				else
					spielerString = protokoll.setXmlTag(spielerString, spielerMFTag, "", 0, true);  // Tags weg!
				allSpielerString += spielerString + "\n";
				writeSpieler = writeSpieler.next;
			}
			mannschaftString = protokoll.setXmlTag(mannschaftString, spielerTag, allSpielerString, 0, true);
			allMannschaftString += mannschaftString + "\n";
			writeMannschaft = writeMannschaft.next;
		}
		writeString = protokoll.setXmlTag(writeString, mannschaftsTag, allMannschaftString, 0, true);
		if ( writeString == null ) {  // zur Sicherheit, falls die Initialisierung mal gendert wird.
			new alertFenster(sa.getTextLabel("errTeamWrite"), fenster);
			return;
		}
		writer.write(writeString);
	}

	/*
	 * Methode sichern().
	 * Sichert dieses File nach filename
	 */
	public void sichern(String filename) {
		BufferedWriter writer;

		try {
			File datafile = new File(filename);

			FileOutputStream fileOut = new FileOutputStream(datafile);
			writer = new BufferedWriter(new OutputStreamWriter(fileOut));
			writeData(writer);         // schreiben
			writer.flush();            // Rest raus
			writer.close();            // wieder schliessen
		} catch (IOException e) {
			new alertFenster(sa.getTextLabel("followingErr") + " " + e.toString(), fenster);
			System.out.println(e);
			return;
		}
	}

	/*
	 * Methode sichernAls().
	 * Zeigt eine FileselectBox fuer die Angabe eines filename und
	 * sichert dieses File nach filename
	 */
	public void sichernAls() {
		String filename = "mannschaftsconfig.html";

		FileDialog fd = new FileDialog (fenster, sa.getTextLabel("saveTeam"), FileDialog.SAVE);
		fd.setFile(filename);
		fd.show();
		filename = fd.getFile();                   // warten auf die Auswahl ...

		if ( filename == null ) {
			return;
		}
		filename = fd.getDirectory() + filename;   // Verzeichnis braucht man auch ...

		File datafile = new File(filename);

		sichern(filename);
	}

	/*
	 * Methode schliessen().
	 * Entfernt das Mannschaftsfenster.
	 */
	public void schliessen () {
		fenster.dispose();
	}


	/*
	 * Die folgenden Methoden bilden das WindowListener-Interface und
	 * beantworten ersteinmal das Anklicken des Windows-Schliessens.
	 */
	public void windowClosing(WindowEvent e) {
		schliessen();
	}
	public void windowActivated(WindowEvent e)   { }
	public void windowClosed(WindowEvent e)      { }
	public void windowDeactivated(WindowEvent e) { }
	public void windowDeiconified(WindowEvent e) { }
	public void windowIconified(WindowEvent e)   { }
	public void windowOpened(WindowEvent e)      { }

	/*
	 * Die folgende Methode bildet das ItemListener-Interface und
	 * beantworten das Selektieren eines Listen-Elements: Das Element wird unten angezeigt.
	 */
	public void itemStateChanged(ItemEvent e) {
		// System.out.println("ListenElement, e.getItem() = " + e.getItem());
		Integer    Index;
		int        index;
		mannschaft selected;
		spieler    selectedSpieler;
		List       liste;

		if ( ! ( e.getSource() instanceof List ) ) {
			return;
		}
		liste = (List) e.getSource();

		if ( e.getItem() instanceof Integer ) {
			Index    = (Integer) e.getItem();
			index    = Index.intValue();
			if ( liste == listeDerMannschaften ) {
				selected = getMannschaft(index);
				// System.out.println("Die Mannschaft " + selected.name + " wurde ausgewhlt!");
				editMannschaft = selected;
				selected.showMannschaft();
			}
			else if ( liste == listeDerSpieler ) {
				selectedSpieler = editMannschaft.getSpielerByIndex(index);
				//System.out.println("Der Spieler " + selectedSpieler.name + " wurde ausgewhlt!");
				selectedSpieler.showSpieler();
				editSpieler = selectedSpieler;
			}
		}
	}

	/*
	 * Die folgende Methode bildet das ActionListener-Interface und
	 * beantworten das Anklicken der Buttons.
	 */
	public void actionPerformed(ActionEvent e) {
		if ( ! ( e.getSource() instanceof Button ) ) {
			return;
		}

		if ( debug ) System.out.println("Button: " + e.getSource());

		Button target = (Button) e.getSource();        // MOUSE CLICK auf Button ...
		buttonAction(target);
	}

	/*
	 * Die folgenden Methoden bilden das KeyListener-Interface und
	 * beantworten Tastatureingaben.
	 */
	public void keyPressed(KeyEvent e) {
		if ( debug ) System.out.println("KeyEvent: " + e);

		int key = e.getKeyCode();

		if ( key != KeyEvent.VK_ENTER )                // Return bzw. Enter
			return;
		if ( ! ( e.getSource() instanceof Button ) ) {
			if ( debug ) System.out.println("ActionEvent: " + e);
			if ( debug ) System.out.println("Kein Button!?");
			return;
		}
		Button target = (Button) e.getSource();        // Return mit selektiertem Button ...
		buttonAction(target);
	}
	public void keyReleased(KeyEvent e)  { }
	public void keyTyped(KeyEvent e)     { }

	/*
	 * Die folgenden Methoden ist wird gemeinsam von actionPerformed und keyPressed genutzt.
	 */
	public void buttonAction(Button target) {
		int index        = this.listeDerMannschaften.getSelectedIndex();
		int spielerIndex = this.listeDerSpieler.getSelectedIndex();
		if      (target == newButton) {  // neue Mannschaft
				if ( newMannschaft != null ) {
					newMannschaft = null;
				}
				listeDerMannschaften.deselect(index);
				newMannschaft = new mannschaft(sa, this);
				editMannschaft = newMannschaft;
				mannschaftsnameTextField.setText("");
				editMannschaft.listeAktualisieren(null);
		}
		else if (target == deleteButton) {
			if ( index == -1 ) {
				new alertFenster(sa.getTextLabel("noTeamSel"), fenster);
			}
			else {
				mannschaft deleteMannschaft = getMannschaft(index);
				this.aushaengen(deleteMannschaft);
				this.listeAktualisieren(firstMannschaft);
				if ( firstMannschaft == null ) {
					newMannschaft = new mannschaft(sa, this);
					editMannschaft = newMannschaft;
					mannschaftsnameTextField.setText("");
					editMannschaft.listeAktualisieren(null);
				}
			}
		}
		else if (target == ladenButton) {
			openFile();
		}
		else if (target == speichernButton) {
			if ( ! SchiriAnlage.runAsProgram ) {
				new alertFenster(sa.getTextLabel("noAppWri"), fenster);
			}
			else {
				sichernAls();
			}
		}
		else if (target == cancelButton) {
			schliessen();
		}
		else if (target == setBlueButton) {
			if ( firstMannschaft != null && index == -1 ) {
				new alertFenster(sa.getTextLabel("noTeamSel"), fenster);
			}
			else {
				 if ( sa.vollesProtokoll ) { // bei vollem Programm muss eine Mannschaft ausgewhlt werden.
					if ( index == -1 ) {
						new alertFenster(sa.getTextLabel("noTeamSelP"), fenster);
						return;
					}
					if ( ! checkMannschaft(getMannschaft(index), fenster) )
						return;
				}
				if ( selectIsLinks ) {
					sa.setMannschaftsColor( Color.blue );
					if ( sa.linkeMannschaft == null )
						sa.lMannschaftsButton.setLabel(sa.getTextLabel("blueTeam"));
					if ( sa.rechteMannschaft == null )
						sa.rMannschaftsButton.setLabel(sa.getTextLabel("whiteTeam"));
				}
				else {
					sa.setMannschaftsColor( Color.white );
					if ( sa.rechteMannschaft == null )
						sa.rMannschaftsButton.setLabel(sa.getTextLabel("blueTeam"));
					if ( sa.linkeMannschaft == null )
						sa.lMannschaftsButton.setLabel(sa.getTextLabel("whiteTeam"));
				}
				if ( index != -1 ) {
					mannschaft selectMannschaft = getMannschaft(index);
					if (selectIsLinks) {
						sa.linkeMannschaft = selectMannschaft;
						sa.lMannschaftsButton.setLabel(selectMannschaft.name);
					}
					else {
						sa.rechteMannschaft = selectMannschaft;
						sa.rMannschaftsButton.setLabel(selectMannschaft.name);
					}
				}
				schliessen();
			}
		}
		else if (target == setWhiteButton) {
			if ( firstMannschaft != null && index == -1 ) {
				new alertFenster(sa.getTextLabel("noTeamSel"), fenster);
			}
			else {
				if ( sa.vollesProtokoll ) { // bei vollem Programm muss eine Mannschaft ausgewhlt werden.
				       if ( index == -1 ) {
					       new alertFenster(sa.getTextLabel("noTeamSelP"), fenster);
					       return;
				       }
				       if ( ! checkMannschaft(getMannschaft(index), fenster) )
					       return;
			       }
				if ( selectIsLinks ) {
					sa.setMannschaftsColor( Color.white );
					if ( sa.linkeMannschaft == null )
						sa.lMannschaftsButton.setLabel(sa.getTextLabel("whiteTeam"));
					if ( sa.rechteMannschaft == null )
						sa.rMannschaftsButton.setLabel(sa.getTextLabel("blueTeam"));
				}
				else {
					sa.setMannschaftsColor(Color.blue);
					if ( sa.rechteMannschaft == null )
						sa.rMannschaftsButton.setLabel(sa.getTextLabel("whiteTeam"));
					if ( sa.linkeMannschaft == null )
						sa.lMannschaftsButton.setLabel(sa.getTextLabel("blueTeam"));
				}
				if ( index != -1 ) {
					mannschaft selectMannschaft = getMannschaft(index);
					if ( selectIsLinks ){
						sa.linkeMannschaft = selectMannschaft;
						sa.lMannschaftsButton.setLabel(selectMannschaft.name);
					}
					else {
						sa.rechteMannschaft = selectMannschaft;
						sa.rMannschaftsButton.setLabel(selectMannschaft.name);
					}
				}
				schliessen();
			}
		}
		else if (target == newSpielerButton) {               // Neuer Spieler
			if ( newSpieler != null ) {
				newSpieler = null;
			}
			listeDerSpieler.deselect(spielerIndex);
			newSpieler = new spieler(sa, editMannschaft);
			editSpieler = newSpieler;
			spielerNameTextField.setText("");
			spielerNummerTextField.setText("");
			mannschaftsfuehrerCheckbox.setState(false);
			//System.out.println("Neuer Spieler");
			editMannschaft.buttonAction(target);
		}
		else if (target == deleteSpielerButton) {            // Spieler lschen
			//System.out.println("Spieler lschen");
			editMannschaft.buttonAction(target);
		}
		else if (target == mannschaftOkButton) {             // Mannschaft speichern
			//System.out.println("Mannschaft speichern");
			editMannschaft.buttonAction(target);
		}

		else if (target == spielerOkButton) {                // Spieler speichern
			//System.out.println("Spieler speichern");
			editSpieler.buttonAction(target);
		}
	}
}


/*
 * Diese Klasse stellt eine Mannschaft dar. Alle Spieler werden aufgelistet.
 */
class mannschaft {
	public static boolean debug = SchiriAnlage.debug;
	SchiriAnlage      sa;
	mannschaftenListe ml;
	String            name;
	int               anzahlSpieler;
	List              listeDerSpieler;
	mannschaft        next = null;               // hiermit wird die Kette gebildet.
	spieler           firstSpieler = null;       // erster in der Liste
	spieler           newSpieler = null;         // solange noch nicht gespeichert
	spieler           mannschaftsfuehrer = null; // null = noch nicht gesetzt
	public int        indexInList = -1;          // Platz in der Liste; -1 = Nicht in der Liste

	/*
	 * Konstruktor fr mannschaft ...
	 */
	public mannschaft (SchiriAnlage sa, mannschaftenListe ml) {
		// System.out.println("mannschaft" + aaa);
		this.sa = sa;
		this.ml = ml;

		listeDerSpieler = ml.listeDerSpieler;
		//System.out.println("mannschaft: listeDerSpieler = " + listeDerSpieler);
	}

	/*
	 * Konstruktor fr mannschaft mit bekanntem Namen (aus Datei) ...
	 */
	public mannschaft (SchiriAnlage sa, mannschaftenListe ml, String name) {
		this(sa, ml);
		this.name = name;
	}

	/*
	 * Die folgende Method wird beim Aktivieren des Mannschaftsbutton aufgerufen.
	 */
	public void showMannschaft(){
		if ( name != null ) {
			ml.mannschaftsnameTextField.setText(name);
			listeAktualisieren(firstSpieler);
		}
	}

	/*
	 * Fllen der Liste ...
	 */
	public void listeAktualisieren(spieler selected) {
		spieler fsp   = firstSpieler;
		int     index = 0;
		spieler sortedElements[];

		listeDerSpieler.removeAll();           // Anzeige leeren

		if ( fsp == null ) {
			ml.newSpieler     = new spieler(sa, this);
			ml.editSpieler    = ml.newSpieler;
			//System.out.println("mannschaft: listeAktualisieren = " + ml.editSpieler);
			ml.editSpieler.showSpieler();  // Spieler-Eintrge lschen
			return;
		}

		sortedElements = getsortedSpieler();   // alle neu sortieren

		// sortiert in die Liste eintragen ...
		for (index=0; index<anzahlSpieler; index++) {
			listeDerSpieler.add(sortedElements[index].nummer + " " + sortedElements[index].name);
			sortedElements[index].indexInList = index;
		}

		// den richtigen Spieler seletieren ...
		if ( selected != null && selected.indexInList < anzahlSpieler && selected.indexInList >= 0 ) {
			listeDerSpieler.select(selected.indexInList);
			ml.editSpieler = selected;
			listeDerSpieler.makeVisible(selected.indexInList);
			selected.showSpieler();
		}
	}

	/*
	 * liefert Array von sortierten Spielern ...
	 */
	public spieler[] getsortedSpieler() {
		spieler fsp   = firstSpieler;
		int     index = 0;
		spieler sortedElements[];

		if ( fsp == null ) return null;

		sortedElements = new spieler[anzahlSpieler];

		do {                                   // Kette in das Array kopieren
			sortedElements[index] = fsp;
			index++;
			fsp = fsp.next;
		} while (fsp != null && index < anzahlSpieler);

		if ( fsp != null || index < anzahlSpieler ) {
			new alertFenster(sa.getTextLabel("wrongPlayerNo"), ml.fenster);
			return null;
		}

		// sortieren ...
		sortElements(sortedElements);

		return sortedElements;
	}

	/*
	 * Sortierungsalgorithmus
	 */
	private void sortElements(spieler[] sortedElements) {
	  spieler tmp;
	  int lo0 = 0;
	  int hi0 = sortedElements.length -1;

	  for (int i= lo0; i<hi0; i++ ) {
	    for (int j=i+1; j<=hi0; j++) {
	      if ( sortedElements[i].nummer > sortedElements[j].nummer ) {
		 // vertauschen ...
		 tmp               = sortedElements[i];
		 sortedElements[i] = sortedElements[j];
		 sortedElements[j] = tmp;
	      }
	    }
	  }
	}

	/*
	 * Spieler in der Kette mit Index index
	 */
	public spieler getSpielerByIndex(int index) {
		spieler sp = firstSpieler;

		if ( sp == null ) return null;
		while ( sp.indexInList != index && sp.next != null ) sp = sp.next;
		if ( sp.indexInList != index ) return null;
		return sp;
	}

	/*
	 * Spieler in der Kette mit Spielernummer nummer
	 */
	public spieler getSpielerByNummer(int nummer) {
		spieler sp = firstSpieler;

		if ( sp == null ) return null;
		while ( sp.nummer != nummer && sp.next != null ) sp = sp.next;
		if ( sp.nummer != nummer ) return null;
		return sp;
	}

	/*
	 * die letzter Spieler in der Kette
	 */
	public spieler getLastSpieler() {
		spieler last = firstSpieler;

		if ( last == null ) return null;
		while ( last.next != null ) last = last.next;
		return last;
	}

	/*
	 * der Spieler in der Kette, die davor liegt.
	 */
	public spieler getPreviousSpieler(spieler sp) {
		spieler previous = firstSpieler;

		if ( previous == null ) return null;
		while ( previous.next != null && previous.next != sp ) previous = previous.next;
		return previous;
	}

	/*
	 * Das Element wird in die Kette eingehngt (aufgenommen). Am Ende der Liste.
	 */
	public void einhaengen(spieler neuInListe) {
		spieler last = getLastSpieler();
		if ( last == null ) firstSpieler = neuInListe;
		else		    last.next    = neuInListe;
		neuInListe.next = null;
		anzahlSpieler++;
	}

	/*
	 * Das Element wird aus der Kette ausgehngt (gelscht).
	 */
	public void aushaengen(spieler rausAusListe) {
		if ( rausAusListe == firstSpieler ) {
			firstSpieler = rausAusListe.next;
		}
		else {
			spieler previous = getPreviousSpieler(rausAusListe);
			if ( previous == null ) {
				new alertFenster(SchiriAnlage.replaceVar(sa.getTextLabel("playerNotList"), rausAusListe.name), ml.fenster);
			}
			previous.next = rausAusListe.next;
		}
		anzahlSpieler--;
	}

	/*
	 * Die folgenden Methoden ist wird gemeinsam von actionPerformed und keyPressed der mannschftsListe genutzt.
	 */
	public void buttonAction(Button target) {
		int index = this.listeDerSpieler.getSelectedIndex();
		if      (target == ml.newSpielerButton) {  // neuer Spieler
			newSpieler = new spieler (sa, this);
		}
		else if (target == ml.deleteSpielerButton) {  // Spieler entfernen
			if ( index == -1 ) {
				new alertFenster(sa.getTextLabel("selectPlayer"), ml.fenster);
			}
			else {
				spieler deleteSpieler = getSpielerByIndex(index);
				this.aushaengen(deleteSpieler);
				this.listeAktualisieren(firstSpieler);
			}
		}
		else if (target == ml.mannschaftOkButton) {  // Mannschaft so eintragen in die Liste
			String tmpName   = ml.mannschaftsnameTextField.getText().trim();
			if ( tmpName.length() > 0 ) {
				name = tmpName;
				if ( this.indexInList == -1 )
					ml.einhaengen(this);
				ml.listeAktualisieren(this);
			}
			else {
				new alertFenster(sa.getTextLabel("teamNameInput"), ml.fenster);
			}
		}
	}
}

/*
 * Diese Klasse stellt einen Spieler dar.
 */
class spieler {
	public static boolean debug = SchiriAnlage.debug;
	SchiriAnlage      sa;
	mannschaft        zugehoerigeMannschaft;
	mannschaftenListe ml;
	int               nummer;
	String            name;
	spieler           next = null;         // hiermit wird die Kette gebildet.
	public int        indexInList = -1;    // Platz in der Liste; -1 = Nicht in der Liste

	/*
	 * Konstruktor fr spieler ...
	 */
	public spieler (SchiriAnlage sa, mannschaft zugehoerigeMannschaft) {
		this.sa = sa;
		this.zugehoerigeMannschaft = zugehoerigeMannschaft;
		this.ml = zugehoerigeMannschaft.ml;
	}

	/*
	 * Konstruktor fr spieler mit Name und Nummer (aus Datei) ...
	 */
	public spieler (SchiriAnlage sa, mannschaft zugehoerigeMannschaft, int nummer, String name) {
		this(sa, zugehoerigeMannschaft);  // obigen Konstruktor benutzen
		this.nummer = nummer;
		this.name   = name;
	}

	/*
	 * Die folgende Method wird beim Aktivieren des Mannschaftsbutton aufgerufen.
	 */
	public void showSpieler(){
		// Nummer ins Fenster eintragen ...
		if ( nummer > 0 )
			ml.spielerNummerTextField.setText(Integer.toString(nummer));
		else
			ml.spielerNummerTextField.setText("");
		// Name ...
		if ( name != null )
			ml.spielerNameTextField.setText(name);
		else
			ml.spielerNameTextField.setText("");
		if ( zugehoerigeMannschaft.mannschaftsfuehrer == this )
			ml.mannschaftsfuehrerCheckbox.setState(true);
		else
			ml.mannschaftsfuehrerCheckbox.setState(false);
	}

	/*
	 * Eintrag ins Protokoll-Formular
	 */
	public String getWechselString() {
		String           pause = "|| ";
		String           imSpiel = "X ";
		Color            c = null;
		ProtokollEintrag sortedElements[];
		String           returnString = "";

		if      ( sa.linkeMannschaft  == zugehoerigeMannschaft )
			c = sa.colorLinks;
		else if ( sa.rechteMannschaft == zugehoerigeMannschaft && sa.colorLinks != null )
			c = (sa.colorLinks == Color.blue) ? Color.white : Color.blue;

		if ( c == null ) {
			System.out.println(sa.getTextLabel("errorNoColor"));
			return returnString;
		}

		// Protokoll-Eintrge ...
		if ( sa.aktuellesProtokoll == null ) return returnString;
		sortedElements = sa.aktuellesProtokoll.getsortedEntries();
		if ( sortedElements == null ) { // keine Eintrge -> fertig
			return returnString;
		}

		for (int i=0; i < sa.aktuellesProtokoll.anzahlEintraege; i++) {
			ProtokollEintrag p = sortedElements[i];

			if ( c != p.colorEntry ) continue;

			switch(p.type) {
				case protokoll.ANFANGRAUS   : // Am Anfang drauen
					if ( nummer == p.spnr || nummer == p.spnr2 || nummer == p.spnr3 || nummer == p.spnr4 )
						returnString += pause;
					break;
				case protokoll.WECHSEL      : // Wechsel
					if ( nummer == p.spnr )
						returnString += imSpiel;
					if ( nummer == p.spnr2 )
						returnString += pause;
					break;
			}
		}
		return returnString;
	}

	/*
	 * Die folgenden Methoden ist wird gemeinsam von actionPerformed und keyPressed in mannschaftsListe genutzt.
	 */
	public void buttonAction(Button target) {
		//System.out.println("spieler: buttonAction = " + target);
		if (target == ml.spielerOkButton) {
			try {
				int     tmpNummer = Integer.parseInt(ml.spielerNummerTextField.getText());
				String  tmpName   = ml.spielerNameTextField.getText().trim();
				boolean tmpMF     = ml.mannschaftsfuehrerCheckbox.getState();
				if ( tmpNummer > 0 && tmpName.length() > 0 ) {
					nummer = tmpNummer;
					name   = tmpName;
					if ( tmpMF )
						zugehoerigeMannschaft.mannschaftsfuehrer = this;
					if ( this.indexInList == -1 )
						zugehoerigeMannschaft.einhaengen(this);
					zugehoerigeMannschaft.listeAktualisieren(this);
				}
				else new alertFenster(sa.getTextLabel("wrongData"), ml.fenster);
			} catch (NumberFormatException ex) {new alertFenster(sa.getTextLabel("wrongData"), ml.fenster);}
		}
	}
}


/*
 * Diese Klasse stellt ein Fenster mit der Liste der Protokoll-Eintrge dar.
 */
class protokoll implements ActionListener, WindowListener, KeyListener, ItemListener, MouseListener, iconControl {
	public  static boolean debug = SchiriAnlage.debug;

	// Werte legen die Reihenfolge der Sortierung bei gleicher Zeit und Halbzeit fest!
	public static final int     UNDEFINED      = 99;
	public static final int     ANFANGRAUS     = 1;
	public static final int     TOR            = 2;
	public static final int     FREIWURF       = 3;
	public static final int     STRAFWURF      = 4;
	public static final int     SCHIRIBALL     = 5;
	public static final int     VERWARNUNG     = 6;
	public static final int     SPIELSPERRE    = 7;
	public static final int     ZEITSTRAFE     = 8;
	public static final int     WECHSEL        = 9;
	public static final int     AUSZEIT        = 10;
	public static final int     HALBZEITPAUSE  = 11;  // immer mit Restzeit 0 in der ersten Halbzeit

	SchiriAnlage      sa;
	Dialog            fenster = null;
	String            titleString;
	// Positionierung des Protokollfensters ...
	Point             ownerObenLinks;
	Dimension         ownerSize, thisSize;

	Button            newButton, deleteButton, schliessenButton, okButton, speichenButton, zeigenButton;
	List              listeDerEintraege = new List(12);
	int               anzahlEintraege   = 0;
	ProtokollEintrag  firstEntry        = null;  // erster in der Liste
	ProtokollEintrag  editEntry         = null;  // der sollte immer gesetzt sein!
	Font              InfoLabelFont;
	Font              textspaceFont     = new Font("Helvetica", Font.PLAIN, 18);
	String            protokollTemplateFilename;
	String            protokollTemplateVerzeichnis;
	String            protokollFilename;

	static final int  TYPECANVAS = 11;            // Anzahl der Type-Icons
	iconCanvas[]      allCanvas = new iconCanvas[TYPECANVAS];
	iconCanvas        torCanvas, freiwurfCanvas, strafwurfCanvas, wechselCanvas;
	iconCanvas        anfRausCanvas, schiriBallCanvas, verwarnungCanvas, sperreCanvas;
	iconCanvas        zeitStrafeCanvas, auszeitCanvas, halbzeitCanvas;
	CheckboxGroup     typeCheckboxgroup;
	Checkbox[]        allCheckbox = new Checkbox[TYPECANVAS];
	Checkbox          torCheckbox, freiwurfCheckbox, strafwurfCheckbox, wechselCheckbox;
	Checkbox          anfRausCheckbox, schiriBallCheckbox, verwarnungCheckbox, sperreCheckbox;
	Checkbox          zeitStrafeCheckbox, auszeitCheckbox, halbzeitCheckbox;
	CheckboxGroup     halbzeitCheckboxgroup;
	Checkbox          ersteHZCheckbox, zweiteHZCheckbox;
	Canvas            blauCanvas, weissCanvas;
	CheckboxGroup     farbeCheckboxgroup;
	Checkbox          blauCheckbox, weissCheckbox;
	TextField         minutenTextField, sekundenTextField, bemerkungTextField;
	TextField         spnrTextField, spnr2TextField, spnr3TextField, spnr4TextField;
	Panel             spnrPanel, spnr2Panel, spnr3Panel, spnr4Panel;
	Label             spnrLabel, spnr2Label;

	/*
	 * Konstruktor fr protokoll ...
	 */
	public protokoll (SchiriAnlage sa) {
		this.sa = sa;

		// Buttons ...
		newButton        = new Button(sa.getTextLabel("newEntry"));
		deleteButton     = new Button(sa.getTextLabel("removeProtEntry"));
		okButton         = new Button(sa.getTextLabel("registerProtEntry"));
		schliessenButton = new Button(sa.getTextLabel("registerClose"));
		speichenButton   = new Button(sa.getTextLabel("saveProtocol"));
		zeigenButton     = new Button(sa.getTextLabel("showProtocol"));

		// Dieses Panel ueberwacht seine Buttons selbst ...
		newButton.addActionListener(this);        // Mouse-Klicks
		deleteButton.addActionListener(this);
		okButton.addActionListener(this);
		schliessenButton.addActionListener(this);
		speichenButton.addActionListener(this);
		zeigenButton.addActionListener(this);

		newButton.addKeyListener(this);           // Tastatur-Eingaben
		deleteButton.addKeyListener(this);
		okButton.addKeyListener(this);
		schliessenButton.addKeyListener(this);
		speichenButton.addKeyListener(this);
		zeigenButton.addKeyListener(this);

		typeCheckboxgroup   = new CheckboxGroup();
		torCheckbox         = new Checkbox(sa.getTextLabel("goalShort"), typeCheckboxgroup, false);
		freiwurfCheckbox    = new Checkbox(sa.getTextLabel("freeThrowShort"), typeCheckboxgroup, false);
		strafwurfCheckbox   = new Checkbox(sa.getTextLabel("penaltyThrowShort"), typeCheckboxgroup, false);
		wechselCheckbox     = new Checkbox(sa.getTextLabel("exchangeShort"), typeCheckboxgroup, false);
		anfRausCheckbox     = new Checkbox(sa.getTextLabel("initiallyOutShort"), typeCheckboxgroup, false);
		schiriBallCheckbox  = new Checkbox(sa.getTextLabel("refereeBallShort"), typeCheckboxgroup, false);
		verwarnungCheckbox  = new Checkbox(sa.getTextLabel("warningShort"), typeCheckboxgroup, false);
		sperreCheckbox      = new Checkbox(sa.getTextLabel("disqualiShort"), typeCheckboxgroup, false);
		zeitStrafeCheckbox  = new Checkbox(sa.getTextLabel("timePenShort"), typeCheckboxgroup, false);
		auszeitCheckbox     = new Checkbox(sa.getTextLabel("timeOutShort"), typeCheckboxgroup, false);
		halbzeitCheckbox    = new Checkbox(sa.getTextLabel("halfTimeShort"), typeCheckboxgroup, false);

		torCanvas           = new iconCanvas(sa, this, false, protokoll.TOR);          //  Konstruktor ohne Hupe
		freiwurfCanvas      = new iconCanvas(sa, this, false, protokoll.FREIWURF);
		strafwurfCanvas     = new iconCanvas(sa, this, false, protokoll.STRAFWURF);
		wechselCanvas       = new iconCanvas(sa, this, false, protokoll.WECHSEL);
		anfRausCanvas       = new iconCanvas(sa, this, false, protokoll.ANFANGRAUS);
		schiriBallCanvas    = new iconCanvas(sa, this, false, protokoll.SCHIRIBALL);
		verwarnungCanvas    = new iconCanvas(sa, this, false, protokoll.VERWARNUNG);
		sperreCanvas        = new iconCanvas(sa, this, false, protokoll.SPIELSPERRE);
		zeitStrafeCanvas    = new iconCanvas(sa, this, false, protokoll.ZEITSTRAFE);
		auszeitCanvas       = new iconCanvas(sa, this, false, protokoll.AUSZEIT);
		halbzeitCanvas      = new iconCanvas(sa, this, false, protokoll.HALBZEITPAUSE);

		allCanvas[0]   = torCanvas;
		allCanvas[1]   = freiwurfCanvas;
		allCanvas[2]   = strafwurfCanvas;
		allCanvas[3]   = wechselCanvas;
		allCanvas[4]   = anfRausCanvas;
		allCanvas[5]   = schiriBallCanvas;
		allCanvas[6]   = verwarnungCanvas;
		allCanvas[7]   = sperreCanvas;
		allCanvas[8]   = zeitStrafeCanvas;
		allCanvas[9]   = auszeitCanvas;
		allCanvas[10]  = halbzeitCanvas;

		allCheckbox[0] = torCheckbox;
		allCheckbox[1] = freiwurfCheckbox;
		allCheckbox[2] = strafwurfCheckbox;
		allCheckbox[3] = wechselCheckbox;
		allCheckbox[4] = anfRausCheckbox;
		allCheckbox[5] = schiriBallCheckbox;
		allCheckbox[6] = verwarnungCheckbox;
		allCheckbox[7] = sperreCheckbox;
		allCheckbox[8] = zeitStrafeCheckbox;
		allCheckbox[9] = auszeitCheckbox;
		allCheckbox[10]= halbzeitCheckbox;

		torCheckbox.addItemListener(this);
		freiwurfCheckbox.addItemListener(this);
		strafwurfCheckbox.addItemListener(this);
		wechselCheckbox.addItemListener(this);
		anfRausCheckbox.addItemListener(this);
		schiriBallCheckbox.addItemListener(this);
		verwarnungCheckbox.addItemListener(this);
		sperreCheckbox.addItemListener(this);
		zeitStrafeCheckbox.addItemListener(this);
		auszeitCheckbox.addItemListener(this);
		halbzeitCheckbox.addItemListener(this);

		listeDerEintraege.addItemListener(this);

		if ( sa.runAsProgram )
			protokollTemplateVerzeichnis = System.getProperty("user.dir") + System.getProperty("file.separator");
		else
			protokollTemplateVerzeichnis = "";  // zur Sicherheit vordefiniert,

		protokollTemplateFilename = protokollTemplateVerzeichnis + "protokollTemplate.html";
	}

	/*
	 * Die folgende Method wird aufgerufen beim Aktivieren des Protokolls-Button ("neu" = null) und,
	 * wenn bei vollem Protokoll Informationen notwendig sind ("neu" ist der neue P.-Eintrag).
	 */
	public void showProtokoll(ProtokollEintrag neu){
		if ( fenster != null )
			schliessen();
		if ( sa.vollesProtokoll ) {
			if ( sa.linkeMannschaft == null || sa.rechteMannschaft == null ) {
				new alertFenster(sa.getTextLabel("errorTeamEntry"), sa.programmFenster);
				return;
			}
			titleString = sa.getTextLabel("protocol") + ": " + sa.linkeMannschaft.name + " " + sa.getTextLabel("against") + " " + sa.rechteMannschaft.name;
		}
		else
			titleString = sa.getTextLabel("protocolPartly");

		InfoLabelFont = sa.InfoLabelFont;

		// Frame ...
		fenster = new Dialog(sa.programmFenster, titleString);
		fenster.setLayout(new BorderLayout(5,5));
		fenster.setBackground(sa.programmFenster.getBackground());
		fenster.addWindowListener(this);

		// drei Hauptpanel ...
		Panel protokollPanel = new Panel(new BorderLayout(5,5));
		Panel protEntryPanel = new Panel(new BorderLayout(5,5));  // mit beiden Trennbalken und centerPanel
		Panel buttonPEPanel  = new Panel(new FlowLayout(FlowLayout.CENTER,50,15));
		fenster.add(protokollPanel, BorderLayout.NORTH);
		fenster.add(protEntryPanel, BorderLayout.CENTER);
		fenster.add(buttonPEPanel, BorderLayout.SOUTH);

		// Liste der Protokoll-Eintrge ...
		protokollPanel.add(listeDerEintraege, BorderLayout.CENTER);

		// Buttons rechts ...
		Panel buttonRechtsAussenPanel = new Panel(new FlowLayout(FlowLayout.CENTER,15,60));
		Panel buttonRechtsPanel       = new Panel(new GridLayout(2,1,15,60));
		protokollPanel.add(buttonRechtsAussenPanel, BorderLayout.EAST);
		buttonRechtsAussenPanel.add(buttonRechtsPanel);
		buttonRechtsPanel.add(zeigenButton);
		buttonRechtsPanel.add(speichenButton);

		// Buttons unten schon hier ...
		buttonPEPanel.add(newButton);
		buttonPEPanel.add(deleteButton);
		buttonPEPanel.add(okButton);
		buttonPEPanel.add(schliessenButton);

		// Trennbalken Protokoll .................................................
		Panel protokollTrennPanel = new Panel();
		protEntryPanel.add(protokollTrennPanel, BorderLayout.NORTH);
		protokollTrennPanel.setBackground(Color.lightGray);  // Balken

		// Center ...
		Panel centerPanel = new Panel(new BorderLayout(5,5));
		//centerPanel.setBackground(Color.yellow); // zum Test

		// Type ...
		Panel typePanel = new Panel(new FlowLayout(FlowLayout.LEFT,15,5));
		//typePanel.setBackground(Color.blue); // zum Test

		Panel torPanel = new Panel(new BorderLayout(0,0));
		torPanel.add(torCanvas, BorderLayout.CENTER);
		torPanel.add(torCheckbox, BorderLayout.SOUTH);
		typePanel.add(torPanel);

		Panel freiwurfPanel = new Panel(new BorderLayout(0,0));
		freiwurfPanel.add(freiwurfCanvas, BorderLayout.CENTER);
		freiwurfPanel.add(freiwurfCheckbox, BorderLayout.SOUTH);
		typePanel.add(freiwurfPanel);

		Panel strafwurfPanel = new Panel(new BorderLayout(0,0));
		strafwurfPanel.add(strafwurfCanvas, BorderLayout.CENTER);
		strafwurfPanel.add(strafwurfCheckbox, BorderLayout.SOUTH);
		typePanel.add(strafwurfPanel);

		Panel wechselPanel = new Panel(new BorderLayout(0,0));
		wechselPanel.add(wechselCanvas, BorderLayout.CENTER);
		wechselPanel.add(wechselCheckbox, BorderLayout.SOUTH);
		typePanel.add(wechselPanel);

		Panel anfRausPanel = new Panel(new BorderLayout(0,0));
		anfRausPanel.add(anfRausCanvas, BorderLayout.CENTER);
		anfRausPanel.add(anfRausCheckbox, BorderLayout.SOUTH);
		typePanel.add(anfRausPanel);

		Panel schiriBallPanel = new Panel(new BorderLayout(0,0));
		schiriBallPanel.add(schiriBallCanvas, BorderLayout.CENTER);
		schiriBallPanel.add(schiriBallCheckbox, BorderLayout.SOUTH);
		typePanel.add(schiriBallPanel);

		Panel verwarnungPanel = new Panel(new BorderLayout(0,0));
		verwarnungPanel.add(verwarnungCanvas, BorderLayout.CENTER);
		verwarnungPanel.add(verwarnungCheckbox, BorderLayout.SOUTH);
		typePanel.add(verwarnungPanel);

		Panel sperrePanel = new Panel(new BorderLayout(0,0));
		sperrePanel.add(sperreCanvas, BorderLayout.CENTER);
		sperrePanel.add(sperreCheckbox, BorderLayout.SOUTH);
		typePanel.add(sperrePanel);

		Panel zeitStrafePanel = new Panel(new BorderLayout(0,0));
		zeitStrafePanel.add(zeitStrafeCanvas, BorderLayout.CENTER);
		zeitStrafePanel.add(zeitStrafeCheckbox, BorderLayout.SOUTH);
		typePanel.add(zeitStrafePanel);

		Panel auszeitPanel = new Panel(new BorderLayout(0,0));
		auszeitPanel.add(auszeitCanvas, BorderLayout.CENTER);
		auszeitPanel.add(auszeitCheckbox, BorderLayout.SOUTH);
		typePanel.add(auszeitPanel);

		Panel halbzeitPanel = new Panel(new BorderLayout(0,0));
		halbzeitPanel.add(halbzeitCanvas, BorderLayout.CENTER);
		halbzeitPanel.add(halbzeitCheckbox, BorderLayout.SOUTH);
		typePanel.add(halbzeitPanel);

		// Restzeit, Farbe, Spielernummer ...
		Panel zeitEtcPanel = new Panel(new FlowLayout(FlowLayout.LEFT,20,0));
		Panel zeitPanel    = new Panel(new BorderLayout(0,0));
		//zeitPanel.setBackground(Color.red); // zum Test
		minutenTextField   = new TextField(2);
		sekundenTextField  = new TextField(2);
		zeitPanel.add(new Label(sa.getTextLabel("remainderTime"),Label.CENTER),BorderLayout.NORTH);
		Panel zeitTextFieldsPanel = new Panel(new FlowLayout(FlowLayout.CENTER,0,0));
		zeitTextFieldsPanel.add(minutenTextField);
		zeitTextFieldsPanel.add(new Label(":", Label.CENTER));
		zeitTextFieldsPanel.add(sekundenTextField);
		zeitPanel.add(zeitTextFieldsPanel, BorderLayout.CENTER);
		Panel halbzeitAuswahlPanel   = new Panel();
		halbzeitCheckboxgroup        = new CheckboxGroup();
		ersteHZCheckbox              = new Checkbox("1."+ sa.getTextLabel("HalfTimeAbr"), halbzeitCheckboxgroup, false);
		zweiteHZCheckbox             = new Checkbox("2."+ sa.getTextLabel("HalfTimeAbr"), halbzeitCheckboxgroup, false);
		halbzeitAuswahlPanel.add(ersteHZCheckbox);
		halbzeitAuswahlPanel.add(zweiteHZCheckbox);
		zeitPanel.add(halbzeitAuswahlPanel, BorderLayout.SOUTH);

		// Farbe ...
		Panel farbePanel   = new Panel(new FlowLayout(FlowLayout.CENTER, 0,0));
		farbeCheckboxgroup = new CheckboxGroup();
		// Blau ...
		Panel blauPanel          = new Panel(new BorderLayout(0,0));
		Panel blauColorPanel     = new Panel(new FlowLayout(FlowLayout.CENTER,0,0));
		Panel blauRandColorPanel = new Panel(new FlowLayout(FlowLayout.CENTER,2,2));
		blauCanvas               = new Canvas();
		blauCanvas.setSize(28,28);
		blauCanvas.setBackground(Color.blue);
		blauCanvas.addMouseListener(this);
		blauRandColorPanel.setBackground(Color.gray);
		blauColorPanel.add(blauRandColorPanel);
		blauRandColorPanel.add(blauCanvas);
		blauPanel.add(blauColorPanel, BorderLayout.CENTER);
		blauCheckbox = new Checkbox(sa.getTextLabel("blue"), farbeCheckboxgroup, false);
		blauPanel.add(blauCheckbox, BorderLayout.SOUTH);
		farbePanel.add(blauPanel);
		// Weiss ...
		Panel weissPanel          = new Panel(new BorderLayout(0,0));
		Panel weissColorPanel     = new Panel(new FlowLayout(FlowLayout.CENTER,0,0));
		Panel weissRandColorPanel = new Panel(new FlowLayout(FlowLayout.CENTER,2,2));
		weissCanvas               = new Canvas();
		weissCanvas.setSize(28,28);
		weissCanvas.setBackground(Color.white);
		weissCanvas.addMouseListener(this);
		weissRandColorPanel.setBackground(Color.gray);
		weissColorPanel.add(weissRandColorPanel);
		weissRandColorPanel.add(weissCanvas);
		weissPanel.add(weissColorPanel, BorderLayout.CENTER);
		weissCheckbox = new Checkbox(sa.getTextLabel("white"), farbeCheckboxgroup, false);
		weissPanel.add(weissCheckbox, BorderLayout.SOUTH);
		farbePanel.add(weissPanel);

		// Spielernummer ...
		spnrPanel     = new Panel(new BorderLayout(0,0));
		//spnrPanel.setBackground(Color.red); // zum Test
		spnrLabel     = new Label("1. " + sa.getTextLabel("playerOut"),Label.LEFT);
		spnrPanel.add(spnrLabel ,BorderLayout.NORTH);
		spnrTextField = new TextField(1);
		spnrPanel.add(spnrTextField, BorderLayout.CENTER);

		// Spielernummer2 ...
		spnr2Panel     = new Panel(new BorderLayout(0,0));
		//spnr2Panel.setBackground(Color.red); // zum Test
		spnr2Label     = new Label("2. " + sa.getTextLabel("playerOut"),Label.LEFT);
		spnr2Panel.add(spnr2Label,BorderLayout.NORTH);
		spnr2TextField = new TextField(1);
		spnr2Panel.add(spnr2TextField, BorderLayout.CENTER);

		// Spielernummer3 ...
		spnr3Panel     = new Panel(new BorderLayout(0,0));
		//spnr3Panel.setBackground(Color.red); // zum Test
		spnr3Panel.add(new Label("3. " + sa.getTextLabel("playerOut"),Label.LEFT),BorderLayout.NORTH);
		spnr3TextField = new TextField(1);
		spnr3Panel.add(spnr3TextField, BorderLayout.CENTER);

		// Spielernummer4 ...
		spnr4Panel     = new Panel(new BorderLayout(0,0));
		//spnr4Panel.setBackground(Color.red); // zum Test
		spnr4Panel.add(new Label("4. " + sa.getTextLabel("playerOut"),Label.LEFT),BorderLayout.NORTH);
		spnr4TextField = new TextField(1);
		spnr4Panel.add(spnr4TextField, BorderLayout.CENTER);

		zeitEtcPanel.add(zeitPanel);
		zeitEtcPanel.add(farbePanel);
		zeitEtcPanel.add(spnrPanel);
		zeitEtcPanel.add(spnr2Panel);
		zeitEtcPanel.add(spnr3Panel);
		zeitEtcPanel.add(spnr4Panel);

		// Bemerkung ...
		Panel bemerkungPanel = new Panel(new FlowLayout(FlowLayout.LEFT,15,5));
		//bemerkungPanel.setBackground(Color.red); // zum Test
		bemerkungTextField   = new TextField(60);
		bemerkungPanel.add(new Label(sa.getTextLabel("comment") + ":"));
		bemerkungPanel.add(bemerkungTextField);

		centerPanel.add (typePanel, BorderLayout.NORTH);
		centerPanel.add (zeitEtcPanel, BorderLayout.CENTER);
		centerPanel.add (bemerkungPanel, BorderLayout.SOUTH);
		protEntryPanel.add(centerPanel, BorderLayout.CENTER);

		// Trennbalken Protokoll .................................................
		Panel buttonTrennPanel = new Panel();
		protEntryPanel.add(buttonTrennPanel, BorderLayout.SOUTH);
		buttonTrennPanel.setBackground(Color.lightGray);  // Balken

		// Buttons werden schon oben eingesetzt ...

		//fenster.setSize (400,500);
		fenster.pack();

		// Wohin ...
		ownerObenLinks = sa.programmFenster.getLocation();
		ownerSize      = new Dimension();
		ownerSize      = sa.programmFenster.getSize(ownerSize);
		thisSize       = new Dimension();
		thisSize       = fenster.getSize(thisSize);
		fenster.setLocation(ownerObenLinks.x + ((ownerSize.width  - thisSize.width) / 2),
			    ownerObenLinks.y + ((ownerSize.height - thisSize.height) / 2) + 50);

		fenster.show();

		torCanvas.setImage(sa.korbBallImage, sa.korbImage, -1);                    // -1 = keine Zahl auf dem Bild
		freiwurfCanvas.setImage(sa.freiwurfImage, sa.freiwurfGrauImage, -1);
		strafwurfCanvas.setImage(sa.strafwurfImage, sa.strafwurfGrauImage, -1);
		wechselCanvas.setImage(sa.wechselImage, sa.wechselGrauImage, -1);
		anfRausCanvas.setImage(sa.anfRausImage, sa.anfRausGrauImage, -1);
		schiriBallCanvas.setImage(sa.schiriBallImage, sa.schiriBallGrauImage, -1);
		verwarnungCanvas.setImage(sa.verwarnungImage, sa.verwarnungGrauImage, -1);
		sperreCanvas.setImage(sa.sperreImage, sa.sperreGrauImage, -1);
		zeitStrafeCanvas.setImage(sa.zeitStrafeImage, sa.zeitStrafeGrauImage, -1);
		auszeitCanvas.setImage(sa.auszeitImage, sa.auszeitGrauImage, -1);
		halbzeitCanvas.setImage(sa.halbzeitImage, sa.halbzeitGrauImage, -1);

		if ( neu != null )                       // "neu" ist Argument dieser Methode
			editEntry = neu;
		// "neu" = neuer Eintrag, (bei vollem Protokoll durch Spielverlauf, d.h. ohne Protokoll-Button)
		protokollListeAktualisieren(neu, true);  // siehe nchste Methode
	}

	/*
	 * Neuschreiben der Liste ...
	 * selected soll ausgewhlt werden. Wenn null dann den letzten auswhlen.
	 * Ausnahme: showNew = false: dann wird der alte weiter angezeigt.
	 * Dies tritt nur ein, wenn ein Eintrag editiert wird und ein anderer durchs Spiel hinzukommt.
	 * Dieser wird dann nur die aktualisierte Liste eingetragen.
	 */
	public void protokollListeAktualisieren(ProtokollEintrag selected, boolean showNew) {
		// System.out.println("listeAktualisieren, selected = "  );
		ProtokollEintrag fe    = firstEntry;
		int              index = 0;
		// Index, der anzuzeigen ist, wenn nicht entryUpdate. Dabei old: vor aktulisierung; new: danach
		int              oldSelectedIndex, newSelectedIndex = -1;
		ProtokollEintrag sortedElements[];

		if ( fenster == null || ! fenster.isShowing() ) // nichts zu tun ...
			return;

		// Index fr bisher selektierten Eintrag (nur fr showNew = false)
		oldSelectedIndex = listeDerEintraege.getSelectedIndex();

		listeDerEintraege.removeAll();                  // alle lschen

		if ( fe == null && showNew ) {                  // wenn noch keine Eintrge, dann neuen erzeugen, editEntry setzen!
			if ( selected == null )
				editEntry = newProtokollEntry(UNDEFINED, null);
			else
				editEntry = selected;            // neuer Eintrag durch Schiri, Auszeit-Button, ...
			editEntry.showEntry();
			return;
		}

		sortedElements = getsortedEntries();                             // sortieren

		for (index=0; index<anzahlEintraege; index++) {
			listeDerEintraege.add(sortedElements[index].toString()); // einzeln wieder in die Liste eintragen
			if ( oldSelectedIndex >= 0 && sortedElements[index].indexInList == oldSelectedIndex )  // alte Selektion merken ...
				newSelectedIndex = index;                        // hat nach Sortierung ggf. den neuen Platz newSelectedIndex
			sortedElements[index].indexInList = index;               // jedem Eintrag seine neue Position i.d.L. eintr.
		}

		if ( selected == null )
			selected = sortedElements[anzahlEintraege-1];            // letzter Eintrag

		if ( ! showNew ) {                                               // alte Selektion wieder herstellen
			if ( newSelectedIndex >= 0 ) {                           // altes editEntry bleibt
				listeDerEintraege.select(newSelectedIndex);
				listeDerEintraege.makeVisible(newSelectedIndex);
			}
		}
		else if ( selected.indexInList < anzahlEintraege && selected.indexInList >= 0 ) {  // Anzeigen des ausgesuchten Eintrags
			listeDerEintraege.select(selected.indexInList);
			listeDerEintraege.makeVisible(selected.indexInList);
			editEntry = selected;
			editEntry.showEntry();
		}
		else {                                      // bei vollem Prot. kommen die neuen Eintrge mit selected.indexInList = -1
			editEntry.showEntry();
		}
	}

	/*
	 * liefert Array von sortierten Protokoll-Eintrgen ...
	 */
	public ProtokollEintrag[] getsortedEntries() {
		ProtokollEintrag fe    = firstEntry;
		int              index = 0;
		ProtokollEintrag sortedElements[];

		if ( fe == null ) return null;

		sortedElements = new ProtokollEintrag[anzahlEintraege];

		do {                                   // Kette in das Array kopieren
			sortedElements[index] = fe;
			index++;
			fe = fe.next;
		} while (fe != null && index < anzahlEintraege);

		if ( fe != null || index < anzahlEintraege ) {
			new alertFenster(sa.getTextLabel("errorProtEntry"), fenster);
			return null;
		}

		// sortieren ...
		sortElements(sortedElements);

		return sortedElements;
	}

	/*
	 * Sortierungsalgorithmus
	 */
	public void sortElements(ProtokollEintrag[] sortedElements) {
	  ProtokollEintrag tmp;
	  int lo0 = 0;
	  int hi0 = sortedElements.length -1;

	  for (int i= lo0; i<hi0; i++ ) {
	    for (int j=i+1; j<=hi0; j++) {
	      if ( sortedElements[i].compareTo(sortedElements[j]) > 0 ) {
		 // vertauschen ...
		 tmp               = sortedElements[i];
		 sortedElements[i] = sortedElements[j];
		 sortedElements[j] = tmp;
	      }
	    }
	  }
	}

	/*
	 * Protokoll-Eintrag in der Kette mit Index index
	 */
	public ProtokollEintrag getEntry(int index) {
		ProtokollEintrag pe = firstEntry;

		if ( pe == null ) return null;
		while ( pe.indexInList != index && pe.next != null ) pe = pe.next;
		if ( pe.indexInList != index ) return null;
		return pe;
	}

	/*
	 * der letzte Protokoll-Eintrag in der Kette
	 */
	public ProtokollEintrag getLastEntry() {
		ProtokollEintrag last = firstEntry;

		if ( last == null ) return last;
		while ( last.next != null ) last = last.next;
		return last;
	}

	/*
	 * der letzte Protokoll-Eintrag aus der sortierten Reihenfolge
	 */
	public ProtokollEintrag getLastSortedEntry() {
		ProtokollEintrag[] sortedEntries = getsortedEntries();

		if ( sortedEntries == null ) return null;

		return sortedEntries[sortedEntries.length - 1];
	}

	/*
	 * der Protokoll-Eintrag in der Kette, der davor liegt.
	 */
	public ProtokollEintrag getPreviousEntry(ProtokollEintrag pe) {
		ProtokollEintrag previous = firstEntry;

		if ( previous == null ) return previous;
		while ( previous.next != null && previous.next != pe ) previous = previous.next;
		return previous;
	}

	/*
	 * Das Element wird in die Kette eingehngt (aufgenommen).
	 */
	public void einhaengen(ProtokollEintrag neuInListe) {
		ProtokollEintrag last = getLastEntry();
		if ( last == null ) firstEntry = neuInListe;
		else		    last.next  = neuInListe;
		neuInListe.next = null;
		anzahlEintraege++;
	}

	/*
	 * Das Element wird aus der Kette ausgehngt (gelscht).
	 */
	public void aushaengen(ProtokollEintrag rausAusListe) {
		if ( rausAusListe == firstEntry ) {
			firstEntry = rausAusListe.next;
		}
		else {
			ProtokollEintrag previous = getPreviousEntry(rausAusListe);
			if ( previous == null )
				new alertFenster(SchiriAnlage.replaceVar(sa.getTextLabel("errorProtMissing"), rausAusListe.toString()), fenster);
			previous.next = rausAusListe.next;
		}
		anzahlEintraege--;
	}

	/*
	 * Die Tore werden korrekt angezeigt.
	 */
	public void setTore() {
		ProtokollEintrag e         = firstEntry;
		int              toreBlau  = 0;
		int              toreWeiss = 0;

		// Wenn die Farbe nicht gesetzt ist, knnen die Tore nicht zugeordnet werden
		if ( sa.colorLinks == null ) return;

		for ( e = firstEntry; e != null; e = e.next ) {
			if ( e.type == protokoll.TOR && e.colorEntry != null ) {
				if ( e.colorEntry == Color.blue ) toreBlau++;
				else                              toreWeiss++;
			}
		}
		if ( sa.colorLinks == Color.blue ) {
			sa.torLinks.setTore(toreBlau);
			sa.torRechts.setTore(toreWeiss);
		}
		else {
			sa.torLinks.setTore(toreWeiss);
			sa.torRechts.setTore(toreBlau);
		}
	}

	/*
	 * Der Torstand bis zu einem bestimmten Protokoll-Eintrag. Returnwerte: [0] = blau, [1] = weiss
	 * biszuEntry = null -> bis Spielende
	 */
	public int[] getTorstand(ProtokollEintrag biszuEntry) {
		ProtokollEintrag[] sortedEntries = getsortedEntries();
		int[]              torstand      = new int[2];
		int                toreBlau      = 0;
		int                toreWeiss     = 0;

		if ( sortedEntries == null ) {  // zur Sicherheit ...
			torstand[0] = toreBlau;
			torstand[1] = toreWeiss;
			return torstand;
		}

		for (int i=0; i<sortedEntries.length; i++) {
			if ( sortedEntries[i].type == protokoll.TOR && sortedEntries[i].colorEntry != null ) {
				if (sortedEntries[i].colorEntry == Color.blue) toreBlau++;
				else                                           toreWeiss++;
			}
			if ( biszuEntry != null && sortedEntries[i] == biszuEntry ) // Ende der Zhlung.
				break;
		}

		torstand[0] = toreBlau;
		torstand[1] = toreWeiss;

		return torstand;
	}

	/*
	 * Methode writeData().
	 * IN: BufferedWriter writer (zum Schreiben der Daten)
	 * Wird nur von sichern() aufgerufen,
	 * Schreibt die Daten in das HTML-File
	 */
	private void writeData(BufferedWriter writer) throws IOException {
		mannschaft       weisseMannschaft = null;
		mannschaft       blaueMannschaft  = null;
		String           weisseMannschaftName, blaueMannschaftName;
		spieler          sortedSpielerWeiss[];
		spieler          sortedSpielerBlau[];
		int              spielerzeilenanzahl = 0;
		String           spielerZeileTemplate, protokollEintragTemplate;
		String           spielerZeile        = "";
		String           allSpielerZeilen    = "";
		String           protokollZeile      = "";
		String           allProtokollZeilen  = "";
		ProtokollEintrag sortedElements[];
		int              torstand[];
		//ProtokollEintrag writeEntry          = firstEntry;
		String           writeString;

		String datumTag               = "<datum>";

		String mannschaftBlauTag      = "<mannschaftBlau>";
		String mannschaftWeissTag     = "<mannschaftWeiss>";
		String spielerZeileTag        = "<spielerzeile>";
		String spielerNummerBlauTag   = "<spielernummerBlau>";
		String spielerNummerWeissTag  = "<spielernummerWeiss>";
		String spielerNameBlauTag     = "<spielernameBlau>";
		String spielerNameWeissTag    = "<spielernameWeiss>";
		String spielerWechselBlauTag  = "<spielerwechselBlau>";
		String spielerWechselWeissTag = "<spielerwechselWeiss>";

		String protokollEintragTag    = "<protokollEintrag>";
		String protokollRestzeitTag   = "<restzeit>";
		String protokollFarbeTag      = "<farbe>";
		String protokollSpNummerTag   = "<spielernummer>";
		String protokollTorTag        = "<tor>";
		String protokollVerwarnungTag = "<verwarnung>";
		String protokollZeitstrafeTag = "<zeitstrafe>";
		String protokollSperreTag     = "<spielsperre>";
		String protokollWechselTag    = "<wechsel>";
		String protokollAuszeitTag    = "<auszeit>";
		String protokollFreiwurfTag   = "<freiwurf>";
		String protokollStrafwurfTag  = "<strafwurf>";
		String protokollSchiriballTag = "<schiriball>";
		String protokollBemerkungTag  = "<bemerkung>";
		String protokollTorstandTag   = "<torstand>";

		String EndTorstandTag         = "<endstand>";

		// damit initialisiert :-(
		sortedSpielerWeiss = new spieler[1];
		sortedSpielerBlau  = new spieler[1];

		// lesen des Templates ...
		File datafile = new File(protokollTemplateFilename);
		if ( ! datafile.exists() || ! datafile.isFile() || ! datafile.canRead() ) {
			String meldung = SchiriAnlage.replaceVar(sa.getTextLabel("protTemplateRead"), protokollTemplateFilename);
			if ( fenster != null )
				new alertFenster(meldung, fenster);
			else
				new alertFenster(meldung, sa.programmFenster);
			return;
		}
		FileInputStream fileIn = new FileInputStream(datafile);
		writeString = mannschaftenListe.getFileString(fileIn);

		// Mannschaften ...
		if ( sa.colorLinks == Color.blue ) {
			blaueMannschaft  = sa.linkeMannschaft;
			weisseMannschaft = sa.rechteMannschaft;
		}
		else if ( sa.colorLinks == Color.white ) {
			weisseMannschaft = sa.linkeMannschaft;
			blaueMannschaft  = sa.rechteMannschaft;
		}
		if ( blaueMannschaft == null ) {
			blaueMannschaftName = sa.getTextLabel("blueTeam");
		}
		else {
			blaueMannschaftName = blaueMannschaft.name;
			sortedSpielerBlau   = blaueMannschaft.getsortedSpieler();
			spielerzeilenanzahl = blaueMannschaft.anzahlSpieler;
		}
		if ( weisseMannschaft == null ) {
			weisseMannschaftName = sa.getTextLabel("whiteTeam");
		}
		else {
			weisseMannschaftName = weisseMannschaft.name;
			sortedSpielerWeiss   = weisseMannschaft.getsortedSpieler();
			if ( weisseMannschaft.anzahlSpieler > spielerzeilenanzahl )
				spielerzeilenanzahl = weisseMannschaft.anzahlSpieler;
		}

		// Datum einsetzen ...
		writeString = protokoll.setXmlTag(writeString, datumTag, sa.getDatumUhrzeit(false) , 0, false);

		// Mannschaftsnamen einsetzen ...
		writeString = protokoll.setXmlTag(writeString, mannschaftBlauTag, blaueMannschaftName, 0, false);
		writeString = protokoll.setXmlTag(writeString, mannschaftWeissTag, weisseMannschaftName, 0, false);

		// Spielerzeilen bestimmen und einsetzen ...
		spielerZeileTemplate = protokoll.getXmlTagString(writeString, spielerZeileTag, 0, true);
		for ( int i=0; i < spielerzeilenanzahl; i++) {
			spielerZeile = spielerZeileTemplate;
			if ( blaueMannschaft != null && i < blaueMannschaft.anzahlSpieler ) {
				// System.out.print("Blau: " + sortedSpielerBlau[i].name + "; i=" + i + "\n");
				String mannschaftsfuehrer = ( blaueMannschaft.mannschaftsfuehrer == sortedSpielerBlau[i] ) ? " (" + sa.getTextLabel("teamLeaderAbr") + ")" : "";
				spielerZeile = protokoll.setXmlTag(spielerZeile,
							spielerNummerBlauTag, ""+sortedSpielerBlau[i].nummer, 0, false);
				spielerZeile = protokoll.setXmlTag(spielerZeile,
							spielerNameBlauTag, sortedSpielerBlau[i].name + mannschaftsfuehrer, 0, false);
				spielerZeile = protokoll.setXmlTag(spielerZeile,
							spielerWechselBlauTag, sortedSpielerBlau[i].getWechselString(), 0, false);
			}
			if ( weisseMannschaft != null && i < weisseMannschaft.anzahlSpieler ) {
				// System.out.print("Weiss: " + sortedSpielerWeiss[i].name + "; i=" + i + "\n");
				String mannschaftsfuehrer = ( weisseMannschaft.mannschaftsfuehrer == sortedSpielerWeiss[i] ) ? " (" + sa.getTextLabel("teamLeaderAbr") + ")" : "";
				spielerZeile = protokoll.setXmlTag(spielerZeile,
							spielerNummerWeissTag, ""+sortedSpielerWeiss[i].nummer, 0, false);
				spielerZeile = protokoll.setXmlTag(spielerZeile,
							spielerNameWeissTag, sortedSpielerWeiss[i].name + mannschaftsfuehrer, 0, false);
				spielerZeile = protokoll.setXmlTag(spielerZeile,
							spielerWechselWeissTag, sortedSpielerWeiss[i].getWechselString(), 0, false);
			}
			allSpielerZeilen += spielerZeile + "\n";
		}
		writeString = protokoll.setXmlTag(writeString, spielerZeileTag, allSpielerZeilen, 0, true);

		// Endergebnis bestimmen und eintragen ...
		torstand = getTorstand(null);  // null = Torstand am Ende des Spiels
		writeString = protokoll.setXmlTag(writeString, EndTorstandTag, "" + torstand[0] + ":" + torstand[1], 0, false);

		if ( writeString == null ) {
			String meldung = sa.getTextLabel("errorProtWrite");
			if ( fenster != null )
				new alertFenster(meldung, fenster);
			else
				new alertFenster(meldung, sa.programmFenster);
			return;
		}

		// Protokoll-Eintrge vorhanden? Wenn nein, schon schreiben ...
		sortedElements = getsortedEntries();
		if ( sortedElements == null ) { // keine Eintrge -> fertig
			writer.write(writeString);
			return;
		}

		// Protokoll-Eintrge bestimmen und eintragen ...
		protokollEintragTemplate = protokoll.getXmlTagString(writeString, protokollEintragTag, 0, true);
		for ( int i=0; i < anzahlEintraege; i++) {
			ProtokollEintrag p = sortedElements[i];
			protokollZeile = protokollEintragTemplate;

			switch(p.type) {
				case protokoll.ANFANGRAUS   : // "Am Anfang drauen" in die Bemerkung
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollBemerkungTag, p.toString(), 0, false);
					break;
				case protokoll.TOR          :
					torstand = getTorstand(p);
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollSpNummerTag, "" + p.spnr, 0, false);
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollTorTag, "X", 0, false);
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollTorstandTag,
						"" + torstand[0] + ":" + torstand[1], 0, false);
					break;
				case protokoll.FREIWURF     :
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollFreiwurfTag, "X", 0, false);
					break;
				case protokoll.STRAFWURF    :
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollSpNummerTag, "" + p.spnr, 0, false);
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollStrafwurfTag, "X", 0, false);
					break;
				case protokoll.SCHIRIBALL   :
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollSchiriballTag, "X", 0, false);
					break;
				case protokoll.VERWARNUNG   :
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollSpNummerTag, "" + p.spnr, 0, false);
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollVerwarnungTag, "X", 0, false);
					break;
				case protokoll.SPIELSPERRE  :
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollSpNummerTag, "" + p.spnr, 0, false);
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollSperreTag, "X", 0, false);
					break;
				case protokoll.ZEITSTRAFE   :
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollSpNummerTag, "" + p.spnr, 0, false);
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollZeitstrafeTag, "X", 0, false);
					break;
				case protokoll.WECHSEL      : // Wechsel in die Bemerkung
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollBemerkungTag,
						sa.getTextLabel("changeIn") + ": " + p.spnr + "; " + sa.getTextLabel("changeOut") + ": " + p.spnr2, 0, false);
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollWechselTag, "X", 0, false);
					break;
				case protokoll.AUSZEIT      :
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollAuszeitTag, "X", 0, false);
					break;
				case protokoll.HALBZEITPAUSE: // Halbzeitpause in die Bemerkung
					protokollZeile = protokoll.setXmlTag(protokollZeile, protokollBemerkungTag, sa.getTextLabel("halfTimeInt"), 0, false);
					break;
			}
			// Restzeit einsetzen ...
			if ( p.minuten >= 0 && p.sekunden >= 0 && p.type != protokoll.ANFANGRAUS && p.type != HALBZEITPAUSE )
				protokollZeile = protokoll.setXmlTag(protokollZeile, protokollRestzeitTag, p.getRestzeitString(false), 0, false);
			// Farbe einsetzen ...
			if ( p.colorEntry != null && p.type != protokoll.SCHIRIBALL && p.type != HALBZEITPAUSE )
				protokollZeile = protokoll.setXmlTag(protokollZeile, protokollFarbeTag,
					( p.colorEntry == Color.blue ) ? "B" : "W", 0, false);
			// Bemerkung einsetzen ...
			if ( p.type != protokoll.ANFANGRAUS && p.type != HALBZEITPAUSE && p.type != WECHSEL && p.bemerkung != null )
				protokollZeile = protokoll.setXmlTag(protokollZeile, protokollBemerkungTag, p.bemerkung, 0, false);

			allProtokollZeilen += protokollZeile;
		}
		writeString = protokoll.setXmlTag(writeString, protokollEintragTag, allProtokollZeilen, 0, true);

		if ( writeString == null ) {
			String meldung = sa.getTextLabel("errorProtWrite");
			if ( fenster != null )
				new alertFenster(meldung, fenster);
			else
				new alertFenster(meldung, sa.programmFenster);
			return;
		}

		// Schreiben des Protokolls, wenn Protokoll-Eintrge vorhanden
		writer.write(writeString);
	}

	/*
	 * Methode setNewProtokollDatei().
	 * Der Name fr die Protokoll-Datei wird gesetzt.
	 * Das Argument "filename" ist ohne Verzeichnis.
	 */
	public void setNewProtokollDatei(String filename) {
		protokollFilename = filename;
	}

	/*
	 * Methode protkollSichern().
	 * Sichert das Protokoll
	 */
	public void protkollSichern() {
		int      beginLine;
		int      endLine;
		BufferedWriter writer;

		if ( ! SchiriAnlage.runAsProgram ) { // Zur Sicherheit! Nur das Programm kann schreiben!
			return;
		}
		try {
			File datafile = new File(protokollFilename);
			FileOutputStream fileOut = new FileOutputStream(datafile);
			writer = new BufferedWriter(new OutputStreamWriter(fileOut));
			writeData(writer);         // wirklich schreiben
			writer.flush();            // Rest raus
			writer.close();            // wieder schliessen
		} catch (IOException e) {
			if ( fenster != null )
				new alertFenster(sa.getTextLabel("errorProtWrite") + " " + e.toString(), fenster);
			else
				new alertFenster(sa.getTextLabel("errorProtWrite") + " " + e.toString(), sa.programmFenster);
			//System.out.println(e);
			return;
		}
	}

	/*
	 * Diese Methode zeigt das Protokoll im Browser
	 */
	public void startBrowser(String filename) {
		String       curDir       = "";
		String       fileURL      = "";
		// bei Windows kann man einen Browser mit Webseite starten ber "rundll32 url.dll,FileProtocolHandler URL"
		// fileURL wird unten erst gesetzt
		String[]     commandoWin   = { "rundll32", "url.dll,FileProtocolHandler", fileURL};
		String[]     commandoLinux = new String[2];
		// bei Linux: Browser KDE, Gnome, Firefox, Mozilla
		String[]     browserLinux  = { "konqueror", "epiphany", "firefox", "mozilla" };
		Runtime      RT;
		Process      proz;
		int          returnWert, i = 0;
		String       errorString = "";
		BufferedReader reader;
		int          maxReadChars = 50000;
		int          readChars    = 0;
		char         cbuf[]       = new char[maxReadChars];

		RT = java.lang.Runtime.getRuntime();
		URL url;
		String os = System.getProperty("os.name");
		boolean isWindows = ( os != null && os.startsWith("Windows") );
		// System.out.println("os = " + os + " isWindows = " + isWindows);

		if ( ! SchiriAnlage.runAsProgram ) { // Applets haben's leicht :-), AppletContext!
			try {
				url = new  URL(sa.getDocumentBase(), filename);
				sa.getAppletContext().showDocument(url, "protokollFenster");
			} catch (Exception e) {}
			return;
		}
		else {
			curDir   = System.getProperty("user.dir");
			fileURL  ="file:" + curDir + File.separator + filename;
			// System.out.println("URL = " + fileURL);
		}
		if ( isWindows ) { // Aufruf speziell fr Windows ...
			commandoWin[2] = fileURL;
			try {
				proz = RT.exec(commandoWin);      // ausgefhren fr Windows !
			} catch (IOException e) {
				System.out.println("Could not exec '" + commandoWin[0] + " " + commandoWin[1] + " " + commandoWin[2] + "'!");
				return;
			} catch (IllegalThreadStateException e) {
				System.out.println("'" + commandoWin[0] + " " + commandoWin[1] + " " + commandoWin[2] + "' with IllegalThreadStateException!");
				return;
			}
		}
		else { // nicht Windows -> die verschiedenen Browser aus browserLinux werden durchprobiert ...
			for (int j=0; j < browserLinux.length; j++) {
				try {
					commandoLinux[0] = browserLinux[j];
					commandoLinux[1] = fileURL;
					proz = RT.exec(commandoLinux);      // na endlich wird was ausgefhrt !
				} catch (IOException e) {
					System.out.println("Could not exec '" + commandoLinux[0] + " " + commandoLinux[1] + "'!");
					continue;   // nchsten Browser testen ...
				} catch (IllegalThreadStateException e) {
					System.out.println("'" + commandoLinux[0] + " " + commandoLinux[1] + "' with IllegalThreadStateException!");
					return;     // keinen Browser mehr testen ...
				}
				return;
			}
			String meldung = SchiriAnlage.replaceVar(sa.getTextLabel("noBrowser"), filename);
			if ( fenster != null )
				new alertFenster(meldung, fenster);
			else
				new alertFenster(meldung, sa.programmFenster);
		}
	}

	/*
	 * Protokoll-Fenster schliessen ...
	 */
	public void schliessen () {
		editEntry = null;            // zur Sicherheit
		fenster.dispose();
	}

	/*
	 * Erzeugt einen neuen Protokoll-Eintrag, der noch nicht in der Liste eingetragen ist.
	 */
	public ProtokollEintrag newProtokollEntry(int type, Color farbe) {
		return new ProtokollEintrag(sa, this, type, farbe);
	}

	/*
	 * Die folgende Methode bildet das iconCanvas-Interface und
	 * wird beim Anklicken des Icons gestartet.
	 */
	public void iconCanvasAction (iconCanvas ic) {
		editEntry.setAnzeigeType(ic.getType());
	}

	/*
	 * Die folgende Methode bildet das MouseListener-Interface und
	 * beantworten das Drcken und Loslassen der Maus.
	 */
	public void mouseClicked(MouseEvent e)   {
		if      ( e.getComponent() == blauCanvas )
			farbeCheckboxgroup.setSelectedCheckbox(blauCheckbox);
		else if ( e.getComponent() == weissCanvas )
			farbeCheckboxgroup.setSelectedCheckbox(weissCheckbox);
	}
	public void mouseEntered (MouseEvent e)   { }
	public void mouseExited  (MouseEvent e)   { }
	public void mousePressed (MouseEvent e)   { }
	public void mouseReleased(MouseEvent e)   { }

	/*
	 * Die folgende Methode bildet das ItemListener-Interface und
	 * beantworten das Auswaehlen eines Types.
	 */
	public void itemStateChanged(ItemEvent e) {
		// System.out.println("itemStateChanged, e.getItem() = " + e.getItem());
		if (  e.getSource() instanceof Checkbox  )
			itemStateChangedCheckbox((Checkbox) e.getSource());
		else if ( e.getSource() instanceof List && e.getItem() instanceof Integer)
			itemStateChangedList((List) e.getSource(), (Integer) e.getItem());
	}

	/*
	 * Diese Methode wird oben aufgerufen, wenn Zustand einer Checkbox gendert wird.
	 */
	public void itemStateChangedCheckbox(Checkbox target) {
		for (int i = 0; i < allCheckbox.length; i++ ) {
			if ( target == allCheckbox[i] ) {
				editEntry.setAnzeigeType(allCanvas[i].getType());
			}
		}
		if ( target == blauCheckbox ) {           // noch keine Aktion (mglich: Aufhellung der blauen Flche)
		}
		else if ( target == weissCheckbox ) {     // noch keine Aktion
		}
	}

	/*
	 * Diese Methode wird oben aufgerufen, wenn ein anderer Listen-Eintrag selektiert wird.
	 */
	public void itemStateChangedList(List liste, Integer Index) {
		int index = Index.intValue();
		// System.out.println("itemStateChangedList: Der Protokoll-Eintrag mit Index " + index + " wurde ausgewhlt!");
		if ( liste == listeDerEintraege ) {                            // anderen Protokoll-Eintrag ausgewhlt ...
			if ( editEntry.tmptype == protokoll.UNDEFINED    ) {   // UNDEFINED braucht nicht gesichert zu werden
				editEntry = getEntry(index);
				editEntry.showEntry();                         // ausgewhlten Eintrag anzeigen
			}
			else if ( editEntry.checkValues(false) ) {             // geht das Sichern ohne weitere Angaben?
				entryEintragen();                              // bisherigen P.-Eintrag in die Liste
				listeDerEintraege.select(index);               // entryEintragen() verstellt leider die Selektion
				editEntry = getEntry(index);
				editEntry.showEntry();                         // ausgewhlten Eintrag anzeigen
			}
			else {                                                 // type ist bestimmt, aber Angaben reichen nicht
				if ( editEntry.indexInList >= 0 )              // alten Eintrag wieder anzeigen
					listeDerEintraege.select(editEntry.indexInList);
				else if ( listeDerEintraege.getSelectedIndex() >= 0 )
					listeDerEintraege.deselect(listeDerEintraege.getSelectedIndex());
				editEntry.checkValues(true);                   // Hinweis auf fehlende Daten
			}
		}
	}

	/*
	 * Die folgenden Methoden bilden das WindowListener-Interface und
	 * beantworten ersteinmal das Anklicken des Windows-Schliessens.
	 */
	public void windowClosing(WindowEvent e) {
		schliessen();
	}
	public void windowActivated(WindowEvent e)   { }
	public void windowClosed(WindowEvent e)      { }
	public void windowDeactivated(WindowEvent e) { }
	public void windowDeiconified(WindowEvent e) { }
	public void windowIconified(WindowEvent e)   { }
	public void windowOpened(WindowEvent e)      { }

	/*
	 * Die folgende Methode bildet das ActionListener-Interface und
	 * beantworten das Anklicken der Buttons.
	 */
	public void actionPerformed(ActionEvent e) {
		if ( ! ( e.getSource() instanceof Button ) ) {
			return;
		}

		if ( debug ) System.out.println("Button: " + e.getSource());

		Button target = (Button) e.getSource();        // MOUSE CLICK auf Button ...
		buttonAction(target);
	}

	/*
	 * Die folgenden Methoden bilden das KeyListener-Interface und
	 * beantworten Tastatureingaben.
	 */
	public void keyPressed(KeyEvent e) {
		// System.out.println("KeyEvent: " + e);

		int key = e.getKeyCode();

		if ( key != KeyEvent.VK_ENTER )
			return;
		if ( ! ( e.getSource() instanceof Button ) ) {
			if ( debug ) System.out.println("ActionEvent: Kein Button!? " + e);
			return;
		}
		Button target = (Button) e.getSource();        // Tastatur-Eigabe ...
		buttonAction(target);
	}
	public void keyReleased(KeyEvent e)  { }
	public void keyTyped(KeyEvent e)     { }

	/*
	 * Die folgenden Methoden ist wird gemeinsam von actionPerformed und keyPressed genutzt.
	 */
	public void buttonAction(Button target) {
		// System.out.println("buttonAction: " + target);
		int index = this.listeDerEintraege.getSelectedIndex();
		if      (target == newButton) {           // neuer Protokoll-Eintrag ...
			if ( editEntry.tmptype != protokoll.UNDEFINED && entryEintragen() ) {  // bisherigen P.-Eintrag in die Liste
				int oldSelectedIndex = listeDerEintraege.getSelectedIndex();
				if ( oldSelectedIndex >= 0 )
					listeDerEintraege.deselect(oldSelectedIndex);
				editEntry = newProtokollEntry(UNDEFINED, null);
				editEntry.showEntry();
			}
		}
		else if (target == deleteButton) {        // selektierten Protokoll-Eintrag lschen ...
			if ( index >= 0 && editEntry.indexInList != index ) {
				new alertFenster(sa.getTextLabel("selectProtEntry"), fenster);
			}
			else {
				if ( editEntry.indexInList >= 0 )
					aushaengen(editEntry);
				protokollListeAktualisieren(null, true);  // der letzte Protokoll-Eintrag wird angezeigt
			}
		}
		else if (target == okButton) {            // Protokoll-Fenster eintragen ...
			entryEintragen();
		}
		else if (target == schliessenButton) {    // Protokoll-Fenster eintragen und Protokoll-Fenster schliessen
			if ( entryEintragen() )
				schliessen();
		}
		else if (target == zeigenButton) {        // Protokoll anzeigen ...
			if ( ! SchiriAnlage.runAsProgram ) {
				new alertFenster(sa.getTextLabel("appletWrite") + " " + sa.getTextLabel("sampleProtocol"), fenster);
				startBrowser("protokoll.html");  // fr's Applet ohne kompletten Pfad.
			}
			else {  // Das Programm sichert zuerst und startet dann den Browser mit kompletten Pfad.
				protkollSichern();
				startBrowser(protokollFilename);
			}
		}
		else if (target == speichenButton) {      // Protokoll speichern ...
			if ( ! SchiriAnlage.runAsProgram ) {
				new alertFenster(sa.getTextLabel("appletWrite"), fenster);
				return;
			}
			protkollSichern();
		}
	}

	/*
	 * Die folgende Methode trgt den Protokoll-Eintrag ein ...
	 */
	private boolean entryEintragen() {
		boolean returnValue = false;
		if ( editEntry.checkValues (true) ) {      // alles Werte ok?
			returnValue = true;
			editEntry.getValues();
			if ( editEntry.indexInList == -1 ) // noch neu
				einhaengen(editEntry);
			protokollListeAktualisieren(editEntry, true);
			if ( sa.vollesProtokoll )          // aktuellen Torstand anzeigen
				setTore();

			// Wenn der Protokoll-Eintrag aktuell ist, werden noch nderungen ausserhalb des Protokoll-Fensters gemacht.
			if ( editEntry.minuten  == sa.spieluhr.getRestMinuten() &&
			     editEntry.sekunden == sa.spieluhr.getRestSekunden()   ) {
				// Icons im Hauptfenster aktualisieren ...
				if (editEntry.type == protokoll.TOR) {
					sa.korbCanvas.setActive(true);
					sa.foulCanvas.setActive(false);
				}
				else if (editEntry.type == protokoll.FREIWURF || editEntry.type == protokoll.STRAFWURF) {
					sa.korbCanvas.setActive(false);
					sa.foulCanvas.setActive(true);
				}
				else {
					sa.korbCanvas.setActive(false);
					sa.foulCanvas.setActive(false);
				}

				// Info-Zeile ...
				sa.print_meldung(editEntry.toString(), true);

				// Strafwurf aktivieren ???
				if (editEntry.type       == protokoll.STRAFWURF &&
				    sa.colorLinks        != null                &&
				    editEntry.colorEntry != null                   ) {
					if (sa.colorLinks == editEntry.colorEntry && !sa.strafwurfLinks.isActivated)
						sa.strafwurfLinks.activatedStrafwurf();
					if (sa.colorLinks != editEntry.colorEntry && !sa.strafwurfRechts.isActivated)
						sa.strafwurfRechts.activatedStrafwurf();
				}
			}
		}
		return returnValue;
	}

	/*
	 * Die folgenden Methoden wird fr das Einlesen von XML-Daten genutzt.
	 * Der String hinter dem Tag (z.B.:"<spieler>") bis zum entsprechenden End-Tag (hier "</spieler>")
	 * wird zurckgegeben.
	 * Testen z.B. mit
	 * System.out.println(protokoll.getXmlTagString("Anfang<spieler>nicht zu sehen</spieler>Ende","<spieler>",3,false));
	 */
	public static String getXmlTagString(String xmlString, String tagString, int startPos, boolean taginclude) {
		String endTag;
		int    foundPos;
		int    endPos;

		if ( xmlString == null || tagString == null )  // bitte keine Null-Pointer-Exception
			return null;

		endTag   = "</" + tagString.substring(1);
		foundPos = xmlString.indexOf(tagString,startPos);
		endPos   = xmlString.indexOf(endTag,startPos);

		if ( foundPos < 0 || endPos < 0 || foundPos > endPos )
			return null; // ein Tag nicht gefunden oder Fehler ...
		if ( taginclude )
			return xmlString.substring(foundPos,endPos + tagString.length() + 1);
		return xmlString.substring(foundPos + tagString.length(),endPos);
	}

	/*
	 * Die folgenden Methoden wird fr das Schreiben von XML-Daten genutzt.
	 * Hinter dem Tag (z.B.:"<spieler>") bis zum entsprechenden End-Tag (hier "</spieler>")
	 * wird im XML-String zwischen den Positionen der setString eingefgt:
	 * if (tagex) -> Tags werden entfernt;
	 * System.out.println(protokoll.setXmlTag("Anfang<spieler>nicht zu sehen</spieler>Ende","<spieler>","Ulrich",3,false));
	 */
	public static String setXmlTag(String xmlString, String tagString, String setString, int startPos, boolean tagex) {
		String endTag;
		int    foundPos;
		int    endPos;

		if ( xmlString == null  || tagString == null  || setString == null )  // bitte keine Null-Pointer-Exception
			return null;

		endTag   = "</" + tagString.substring(1);
		foundPos = xmlString.indexOf(tagString,startPos);
		endPos   = xmlString.indexOf(endTag,startPos);

		if ( foundPos < 0 || endPos < 0 || foundPos > endPos )
			return null; // ein Tag nicht gefunden oder Fehler ...

		if ( tagex ) // Tags werden mit entfernt.
			return xmlString.substring(0, foundPos) + setString + xmlString.substring(endPos + tagString.length() + 1);
		return xmlString.substring(0, foundPos + tagString.length()) + setString + xmlString.substring(endPos);
	}
}


/*
 * Diese Klasse stellt einen Protokoll-Eintrag im Protokoll-Fenster dar.
 */
class ProtokollEintrag {
	public static boolean debug = SchiriAnlage.debug;
	SchiriAnlage      sa;
	protokoll         prot;
	boolean           ersteHalbzeit;                 // entspricht der Halbzeit des Eintrags, nicht dem aktuellen Stand von sa!
	int               minuten  = -1;                 // -1 heisst nicht definiert
	int               sekunden = -1;
	int               spnr     = 0, spnr2 = 0, spnr3 = 0, spnr4 = 0;  // 0 heisst nicht definiert
	int               type     = protokoll.UNDEFINED; // wird zu protokoll.TOR, ...
	int               tmptype  = protokoll.UNDEFINED; // solange noch kein ok ...

	Color             colorEntry = null;              // blau, white -> Farbe gesetzt; null -> Farbe noch nicht gesetzt
	String            bemerkung;

	ProtokollEintrag  next = null;                    // hiermit wird die Kette gebildet.
	int               indexInList = -1;               // Platz in der Liste; -1 = Nicht in der Liste

	/*
	 * Konstruktor einen Protokoll-Eintrag ...
	 */
	public ProtokollEintrag (SchiriAnlage sa, protokoll prot, int type, Color farbe) {
		// System.out.println("neuer ProtokollEintrag: " + type);
		boolean protokollFensterZeigen;           // wird das Protokoll-Fenster angezeigt (fr Zusatzinformationen)?

		this.sa            = sa;
		this.prot          = prot;
		this.type          = type;
		this.tmptype       = type;
		this.colorEntry    = farbe;
		this.ersteHalbzeit = sa.ersteHalbzeit;    // bei Erzeugung wird erst mal die Spielzeit als Zeit eingetragen
		this.minuten       = sa.spieluhr.getRestMinuten();
		this.sekunden      = sa.spieluhr.getRestSekunden();

		// Freiwurf lschen, wenn neuer Strafwurf zur gleichen Zeit bei nicht vollem Protokoll
		if ( type == protokoll.STRAFWURF ) {
			for ( ProtokollEintrag pe = prot.firstEntry; pe != null; pe = pe.next ) {
				if ( pe.type == protokoll.FREIWURF          &&
				     pe.minuten == this.minuten             &&
				     pe.sekunden == this.sekunden           &&
				     pe.ersteHalbzeit == this.ersteHalbzeit &&
				     ! sa.vollesProtokoll                       )
					prot.aushaengen(pe);
			}
		}

		// Protokoll-Fenster ist schon da: der neue P.-Eintrag (this) wird in die Liste eingetragen, wenn nicht UNDEFINED
		if ( prot.fenster != null && prot.fenster.isShowing() ) {
			if ( type != protokoll.UNDEFINED ) {
				prot.einhaengen(this);
				prot.protokollListeAktualisieren(null, false); // Die Editierung des alten nicht stren!
			}
			return;  // Fertig, wenn Protokoll-Fenster offen ist.
		}

		// Ab hier kann man davon ausgehen, dass das Protokoll-Fenster nicht offen ist.
		// Also ffnen oder still in Liste eintragen ...
		protokollFensterZeigen = sa.vollesProtokoll;                        // Basis-Definition
		if ( type == protokoll.HALBZEITPAUSE || type == protokoll.AUSZEIT ) // keine Zusatzangaben notwendig
			protokollFensterZeigen = false;

		if ( protokollFensterZeigen ) {
			prot.showProtokoll(this); // this wird erst nach Editierung in die Liste eingehngt.
		}
		else {
			prot.einhaengen(this);
			prot.protokollListeAktualisieren(null, true);  // keine spezielle Selektion in der Liste und letzten anzeigen.
		}                                                      // hat keine Bedeutung, da Protokoll-Fenster nicht offen.
	}


	/*
	 * Die folgende Methode zeigt einen Protokoll-Eitrag im Detail an.
	 */
	public void showEntry(){
		String nothing = "";

		if ( prot.fenster == null || ! prot.fenster.isShowing() )  // nichts zu tun ...
			return;

		// zur Sicherheit ...
		if ( type == 0 )
			type = protokoll.UNDEFINED;

		tmptype = type;

		setAnzeigeType(type);

		if      ( colorEntry == Color.blue  ) prot.farbeCheckboxgroup.setSelectedCheckbox(prot.blauCheckbox);
		else if ( colorEntry == Color.white ) prot.farbeCheckboxgroup.setSelectedCheckbox(prot.weissCheckbox);
		else                                  prot.farbeCheckboxgroup.setSelectedCheckbox(null);
		if      ( spnr  > 0                 ) prot.spnrTextField.setText(Integer.toString(spnr));
		else                                  prot.spnrTextField.setText(nothing);
		if      ( spnr2 > 0                 ) prot.spnr2TextField.setText(Integer.toString(spnr2));
		else                                  prot.spnr2TextField.setText(nothing);
		if      ( spnr3 > 0                 ) prot.spnr3TextField.setText(Integer.toString(spnr3));
		else                                  prot.spnr3TextField.setText(nothing);
		if      ( spnr4 > 0                 ) prot.spnr4TextField.setText(Integer.toString(spnr4));
		else                                  prot.spnr4TextField.setText(nothing);
		if      ( bemerkung != null         ) prot.bemerkungTextField.setText(bemerkung);
		else                                  prot.bemerkungTextField.setText(nothing);
		if      ( minuten >= 0              ) prot.minutenTextField.setText(Integer.toString(minuten));
		else                                  prot.minutenTextField.setText(nothing);
		if      ( sekunden >= 0             ) prot.sekundenTextField.setText(Integer.toString(sekunden));
		else                                  prot.sekundenTextField.setText(nothing);
		if      ( ersteHalbzeit             ) prot.halbzeitCheckboxgroup.setSelectedCheckbox(prot.ersteHZCheckbox);
		else                                  prot.halbzeitCheckboxgroup.setSelectedCheckbox(prot.zweiteHZCheckbox);
	}

	/*
	 * Die folgende Methode bringt die Sortierreihenfolge der Protokoll-Eintrge.
	 * Return-Wert < 0 heisst "this" vor "cPE"
	 */
	public int compareTo (ProtokollEintrag cPE) {
		if ( ! this.ersteHalbzeit &&   cPE.ersteHalbzeit ) return 1;              // erste Halbzeit zuerst
		if (   this.ersteHalbzeit && ! cPE.ersteHalbzeit ) return -1;
		if ( this.minuten  != cPE.minuten  ) return cPE.minuten - this.minuten;   // Minuten entscheiden
		if ( this.sekunden != cPE.sekunden ) return cPE.sekunden - this.sekunden; // Sekunden knne wichtig sein
		if ( this.type     != cPE.type     ) return this.type - cPE.type;         // bei gleicher Zeit entscheidet der Type
		if ( bemerkung != null && cPE.bemerkung != null )
			return bemerkung.compareTo(cPE.bemerkung);                        // tiebreaker Bemerkung
		return 0;
	}

	/*
	 * fr mindestens zweistellige Ausgabe der Minuten und Sekunden
	 */
	public String printf02d(int n) {
		if ( n < 10 ) return '0' + Integer.toString(n);
		else          return Integer.toString(n);
	}

	/*
	 * Erzeugt einen String mit Restzeit (mit/ohne Halbzeitangabe)
	 */
	public String getRestzeitString(boolean halbzeitAdd) {
		String hzString = (ersteHalbzeit)? " (1)" : " (2)";

		if ( ! halbzeitAdd ) hzString = "";

		if ( minuten != -1 && sekunden != -1 )
			return printf02d(minuten) + ":" + printf02d(sekunden) + hzString;
		else {
			if ( halbzeitAdd ) return "--:-- (?)";
			else               return "--:--";
		}

	}

	/*
	 * berschreibt die Methode toString() mit einer Ausgabe, die aussagekrftig ist.
	 */
	public String toString() {
		String returnString = getRestzeitString(true) + ", ";
		String colorString  = " <" + sa.getTextLabel("colorUnknown") + ">";


		if      ( colorEntry == Color.blue )  colorString = " " + sa.getTextLabel("blue");
		else if ( colorEntry == Color.white ) colorString = " " + sa.getTextLabel("white");

		switch(type) {
			case protokoll.UNDEFINED    : returnString += sa.getTextLabel("undefined"); break;
			case protokoll.ANFANGRAUS   : returnString  = sa.getTextLabel("initiallyOut") + ":" +
								      colorString + "; " + sa.getTextLabel("numberAbr") + " " + spnr;
						      if ( spnr2 > 0 ) returnString += ", " + sa.getTextLabel("numberAbr") + " " + spnr2;
						      if ( spnr3 > 0 ) returnString += ", " + sa.getTextLabel("numberAbr") + " " + spnr3;
						      if ( spnr4 > 0 ) returnString += ", " + sa.getTextLabel("numberAbr") + " " + spnr4;
						      break;
			case protokoll.TOR          : returnString += sa.getTextLabel("goalFor") + colorString +
								      "; " + sa.getTextLabel("numberAbr") + " " + spnr;
						      break;
			case protokoll.FREIWURF     : returnString += sa.getTextLabel("foulAgainst") + colorString;
						      break;
			case protokoll.STRAFWURF    : returnString += sa.getTextLabel("penaltyThrowA") + colorString +
								      ";  " + sa.getTextLabel("numberAbr") + " " + spnr;
						      break;
			case protokoll.SCHIRIBALL   : returnString += sa.getTextLabel("refereeBall"); break;
			case protokoll.VERWARNUNG   : returnString += sa.getTextLabel("warningAgainst") + colorString +
								      ";  " + sa.getTextLabel("numberAbr") + " " + spnr;
						      break;
			case protokoll.SPIELSPERRE  : returnString += sa.getTextLabel("disqualiAgainst") + colorString +
								      ";  " + sa.getTextLabel("numberAbr") + " " + spnr;
						      break;
			case protokoll.ZEITSTRAFE   : returnString += sa.getTextLabel("penaltyTimeFor") + colorString +
								      ";  " + sa.getTextLabel("numberAbr") + " " + spnr;
						      break;
			case protokoll.WECHSEL      : returnString += sa.getTextLabel("exchange") + colorString +
								      "; " + sa.getTextLabel("changeIn") + "  " + sa.getTextLabel("numberAbr") +
								      " " + spnr + ", " + sa.getTextLabel("changeOut") + "  " + sa.getTextLabel("numberAbr") + " " + spnr2;
						      break;
			case protokoll.AUSZEIT      : returnString += sa.getTextLabel("timeOutFor") + colorString;
						      break;
			case protokoll.HALBZEITPAUSE: returnString  = sa.getTextLabel("halfTimeInt"); break;
		}
		if ( bemerkung != null ) returnString += "; " + bemerkung;
		return returnString;
	}

	/*
	 * Beim Klick auf einen anderen Eintrag-Type werden durch diese Methode andere Elemente des Fensters gezeigt.
	 */
	public void setAnzeigeType(int tmptype) {
		if ( prot.fenster == null || ! prot.fenster.isShowing() )  // nichts zu tun ...
			return;

		this.tmptype = tmptype;
		// System.out.println("setAnzeigeType: " + tmptype);
		for (int i = 0; i < prot.allCanvas.length; i++ ) {
			if ( prot.allCanvas[i].getType() == tmptype ) {
				prot.allCanvas[i].setActive(true);
				prot.typeCheckboxgroup.setSelectedCheckbox(prot.allCheckbox[i]);
			}
			else {
				prot.allCanvas[i].setActive(false);
			}
		}
		// abhngig vom Type mssen einige Elemente noch ein hide() bekommen ...
		switch(tmptype) {
			case protokoll.UNDEFINED    :
				setSpielerVisible(false, false, false, false);
				prot.typeCheckboxgroup.setSelectedCheckbox(null);
				break;
			case protokoll.ANFANGRAUS   :
				setSpielerVisible(true, true, true, true);
				prot.spnrLabel.setText("1. " + sa.getTextLabel("playerOut"));
				prot.spnr2Label.setText("2. " + sa.getTextLabel("playerOut"));
				break;
			case protokoll.TOR          :
				setSpielerVisible(true, false, false, false);
				prot.spnrLabel.setText(sa.getTextLabel("scorer"));
				break;
			case protokoll.FREIWURF     :
				setSpielerVisible(false, false, false, false);
				break;
			case protokoll.STRAFWURF    :
				setSpielerVisible(true, false, false, false);
				prot.spnrLabel.setText(sa.getTextLabel("foulPlayer"));
				break;
			case protokoll.SCHIRIBALL   :
				setSpielerVisible(false, false, false, false);
				break;
			case protokoll.VERWARNUNG   :
				setSpielerVisible(true, false, false, false);
				prot.spnrLabel.setText(sa.getTextLabel("warnedPlayerShort"));
				break;
			case protokoll.SPIELSPERRE  :
				setSpielerVisible(true, false, false, false);
				prot.spnrLabel.setText(sa.getTextLabel("expelledPlayerShort"));
				break;
			case protokoll.ZEITSTRAFE   :
				setSpielerVisible(true, false, false, false);
				prot.spnrLabel.setText(sa.getTextLabel("forPlayer"));
				break;
			case protokoll.WECHSEL      :
				setSpielerVisible(true, true, false, false);
				prot.spnrLabel.setText(sa.getTextLabel("playerIn"));
				prot.spnr2Label.setText(sa.getTextLabel("playerOut"));
				break;
			case protokoll.AUSZEIT      :
				setSpielerVisible(false, false, false, false);
				break;
			case protokoll.HALBZEITPAUSE:
				setSpielerVisible(false, false, false, false);
				break;
		}
	}

	/*
	 * Die passenden Spielerfelder werden angezeigt oder versteckt.
	 */
	private void setSpielerVisible(boolean sp1, boolean sp2, boolean sp3, boolean sp4) {
		// zur Sicherheit ...
		if ( prot.spnrPanel == null || prot.spnr2Panel == null || prot.spnr3Panel == null || prot.spnr4Panel == null )
			return;
		prot.spnrPanel.setVisible(sp1);
		prot.spnr2Panel.setVisible(sp2);
		prot.spnr3Panel.setVisible(sp3);
		prot.spnr4Panel.setVisible(sp4);
	}

	/*
	 * berprft die Eingaben. true -> ok, kann eingetragen werden; false -> Fehlermeldung, keine Eintragung
	 */
	public boolean checkValues (boolean message) {
		//System.out.println("checkValues: tmptype=" + tmptype + ", type=" + type);
		switch(tmptype) {
			case protokoll.UNDEFINED    :
				if ( message ) {
					new alertFenster(sa.getTextLabel("typeNotSet"), prot.fenster);
				}
				return false;
			case protokoll.ANFANGRAUS   :
				if ( ! checkValueFarbe (message) || ! checkValueNummer (message) )
					return false;
				break;
			case protokoll.TOR          :
				if ( ! checkValueFarbe (message) || ! checkValueTime (message) ||
				     ! checkValueNummer (message)  )
					return false;
				break;
			case protokoll.FREIWURF     :
				if ( ! checkValueFarbe (message) || ! checkValueTime (message) )
					return false;
				break;
			case protokoll.STRAFWURF    :
				if ( ! checkValueFarbe (message) || ! checkValueTime (message) ||
				     ! checkValueNummer (message)  )
					return false;
				break;
			case protokoll.SCHIRIBALL   : break;
			case protokoll.VERWARNUNG   :
				if ( ! checkValueFarbe (message) || ! checkValueTime (message) ||
				     ! checkValueNummer (message)  )
					return false;
				break;
			case protokoll.SPIELSPERRE  :
				if ( ! checkValueFarbe (message) || ! checkValueTime (message) ||
				     ! checkValueNummer (message)  )
					return false;
				break;
			case protokoll.ZEITSTRAFE   :
				if ( ! checkValueFarbe (message) || ! checkValueTime (message) ||
				     ! checkValueNummer (message)  )
					return false;
				break;
			case protokoll.WECHSEL      :
				if ( ! checkValueFarbe (message) || ! checkValueTime (message) ||
				     ! checkValueNummer (message)  )
					return false;
				break;
			case protokoll.AUSZEIT      :
				if ( ! checkValueFarbe (message) || ! checkValueTime (message) )
					return false;
				break;
			case protokoll.HALBZEITPAUSE: break;
		}

		return true;
	}

	/*
	 * berprft die Zeit-Eingaben. true -> ok; false -> Fehlermeldung.
	 */
	private boolean checkValueTime (boolean message) {
		int   checkMinuten    = -1;
		int   checkSekunden   = -1;

		try {
			checkMinuten  = Integer.parseInt(prot.minutenTextField.getText());
			checkSekunden = Integer.parseInt(prot.sekundenTextField.getText());

		} catch (NumberFormatException ex) {}

		if ( checkMinuten  < 0 || checkMinuten  > (sa.spielzeit/60) ||
		     checkSekunden < 0 || checkSekunden > 59                ||
		     checkSekunden > (sa.spielzeit - (checkMinuten * 60))      ) {
			if ( message ) {
				new alertFenster(sa.getTextLabel("setRemainderTime"), prot.fenster);
			}
			return false;
		}
		return true;
	}

	/*
	 * berprft die Spielernummer-Eingaben. true -> ok; false -> Fehlermeldung.
	 */
	private boolean checkValueNummer (boolean message) {
		int        checkSpnr     = -1;
		int        check2Spnr    = -1;
		int        check3Spnr    = -1;
		int        check4Spnr    = -1;
		Checkbox   checkCheckbox = prot.farbeCheckboxgroup.getSelectedCheckbox();
		mannschaft m;

		try {
			checkSpnr     = Integer.parseInt(prot.spnrTextField.getText());
			if ( tmptype == protokoll.WECHSEL || tmptype == protokoll.ANFANGRAUS )
				check2Spnr     = Integer.parseInt(prot.spnr2TextField.getText());
			if ( tmptype == protokoll.ANFANGRAUS ) {
				check3Spnr     = Integer.parseInt(prot.spnr3TextField.getText());
				check4Spnr     = Integer.parseInt(prot.spnr4TextField.getText());
			}
		} catch (NumberFormatException ex) {}

		if ( checkSpnr < 1 || checkSpnr > 99 ) {  // Nummer berprfen ...
			if ( message ) {
				new alertFenster(sa.getTextLabel("setPlayerNumber"), prot.fenster);
			}
			return false;
		}
		if ( tmptype == protokoll.WECHSEL && ( check2Spnr < 1 || check2Spnr > 99 ) ) {  // 2. Nummer berprfen ...
			if ( message ) {
				new alertFenster(sa.getTextLabel("setPlayerNumber"), prot.fenster);
			}
			return false;
		}
		if ( tmptype == protokoll.ANFANGRAUS &&
		     ( check2Spnr < -1 || check2Spnr == 0 || check2Spnr > 99 || checkSpnr == check2Spnr ||
		       check3Spnr < -1 || check3Spnr == 0 || check3Spnr > 99 || (check3Spnr != -1 && (check3Spnr == checkSpnr || check3Spnr == check2Spnr)) ||
		       check4Spnr < -1 || check4Spnr == 0 || check4Spnr > 99 || (check4Spnr != -1 && (check4Spnr == checkSpnr || check4Spnr == check2Spnr || check4Spnr == check3Spnr))   ) ) {                          // 2. + 3. +4. Nummer berprfen ...
			if ( message ) {
				new alertFenster(sa.getTextLabel("setPlayerNumber"), prot.fenster);
			}
			return false;
		}

		if ( checkCheckbox == prot.blauCheckbox ) {    // Mannschaft finden ...
			if ( sa.colorLinks == Color.blue ) m = sa.linkeMannschaft;
			else                               m = sa.rechteMannschaft;
		}
		else {
			if ( sa.colorLinks == Color.white ) m = sa.linkeMannschaft;
			else                                m = sa.rechteMannschaft;
		}

		if ( m != null && m.getSpielerByNummer(checkSpnr) == null ) {  // nur fr erstes Feld ggf. neuen Spieler aufnehmen
			if ( message ) {
				new alertFenster(SchiriAnlage.replaceVar(SchiriAnlage.replaceVar(sa.getTextLabel("playerRegistered"), new Integer(checkSpnr).toString()), m.name), prot.fenster);
			}
			m.einhaengen(new spieler (sa, m, checkSpnr, sa.getTextLabel("player") + " " + checkSpnr));
			m.listeAktualisieren(m.firstSpieler);
		}
		return true;
	}

	/*
	 * berprft die Farbe-Eingaben. true -> ok; false -> Fehlermeldung.
	 */
	private boolean checkValueFarbe (boolean message) {
		Checkbox checkCheckbox = prot.farbeCheckboxgroup.getSelectedCheckbox();
		if ( checkCheckbox == null ) {
			if ( message ) {
				new alertFenster(sa.getTextLabel("colorNotSet"), prot.fenster);
			}
			return false;
		}
		return true;
	}

	/*
	 * Nimmt die Eingaben und speichert sie ab.
	 */
	public void getValues () {
		type = tmptype;
		try { // minutenTextField, sekundenTextField, spnrTextField, spnr2TextField, spnr3TextField, spnr4TextField ...
			minuten   = Integer.parseInt(prot.minutenTextField.getText());
			sekunden  = Integer.parseInt(prot.sekundenTextField.getText());
			spnr      = Integer.parseInt(prot.spnrTextField.getText());
			spnr2     = Integer.parseInt(prot.spnr2TextField.getText());
			spnr3     = Integer.parseInt(prot.spnr3TextField.getText());
			spnr4     = Integer.parseInt(prot.spnr4TextField.getText());
		} catch (NumberFormatException ex) {}
		// Farbe ...
		Checkbox getCheckbox = prot.farbeCheckboxgroup.getSelectedCheckbox();
		if      ( getCheckbox == null )              colorEntry = null;
		else if ( getCheckbox == prot.blauCheckbox ) colorEntry = Color.blue;
		else                                         colorEntry = Color.white;
		// Halbzeit ...
		if      ( prot.halbzeitCheckboxgroup.getSelectedCheckbox() == prot.zweiteHZCheckbox )
			ersteHalbzeit = false;
		else
			ersteHalbzeit = true;
		// Spezielle Setzungen ...
		if ( type == protokoll.HALBZEITPAUSE ) {
			minuten  = 0;
			sekunden = 0;
			ersteHalbzeit = true;
		}
		if ( type == protokoll.ANFANGRAUS ) {
			minuten  = sa.spielzeit / 60;
			sekunden = sa.spielzeit % 60;
			ersteHalbzeit = true;
		}
		// Bemerkung zum Schluss ...
		bemerkung = prot.bemerkungTextField.getText().trim();
	}
}
